/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          return pattern9 (x3, 
E_V1QImode); /* [-1, 0] */

        case E_V2QImode:
          if (pattern9 (x3, 
E_V2QImode) != 0)
            return -1;
          return 1;

        case E_V4QImode:
          if (pattern9 (x3, 
E_V4QImode) != 0)
            return -1;
          return 2;

        case E_V8QImode:
          if (pattern9 (x3, 
E_V8QImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V1HImode:
          if (pattern9 (x3, 
E_V1HImode) != 0)
            return -1;
          return 5;

        case E_V2HImode:
          if (pattern9 (x3, 
E_V2HImode) != 0)
            return -1;
          return 6;

        case E_V4HImode:
          if (pattern9 (x3, 
E_V4HImode) != 0)
            return -1;
          return 7;

        case E_V8HImode:
          if (pattern9 (x3, 
E_V8HImode) != 0)
            return -1;
          return 8;

        case E_V1SImode:
          if (pattern9 (x3, 
E_V1SImode) != 0)
            return -1;
          return 9;

        case E_V2SImode:
          if (pattern9 (x3, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern9 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V1DImode:
          if (pattern9 (x3, 
E_V1DImode) != 0)
            return -1;
          return 12;

        case E_V2DImode:
          if (pattern9 (x3, 
E_V2DImode) != 0)
            return -1;
          return 13;

        case E_V1TImode:
          if (pattern9 (x3, 
E_V1TImode) != 0)
            return -1;
          return 14;

        case E_TImode:
          if (pattern9 (x3, 
E_TImode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case IOR:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern9 (x3, 
E_V1QImode) != 0)
            return -1;
          return 16;

        case E_V2QImode:
          if (pattern9 (x3, 
E_V2QImode) != 0)
            return -1;
          return 17;

        case E_V4QImode:
          if (pattern9 (x3, 
E_V4QImode) != 0)
            return -1;
          return 18;

        case E_V8QImode:
          if (pattern9 (x3, 
E_V8QImode) != 0)
            return -1;
          return 19;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 20;

        case E_V1HImode:
          if (pattern9 (x3, 
E_V1HImode) != 0)
            return -1;
          return 21;

        case E_V2HImode:
          if (pattern9 (x3, 
E_V2HImode) != 0)
            return -1;
          return 22;

        case E_V4HImode:
          if (pattern9 (x3, 
E_V4HImode) != 0)
            return -1;
          return 23;

        case E_V8HImode:
          if (pattern9 (x3, 
E_V8HImode) != 0)
            return -1;
          return 24;

        case E_V1SImode:
          if (pattern9 (x3, 
E_V1SImode) != 0)
            return -1;
          return 25;

        case E_V2SImode:
          if (pattern9 (x3, 
E_V2SImode) != 0)
            return -1;
          return 26;

        case E_V4SImode:
          if (pattern9 (x3, 
E_V4SImode) != 0)
            return -1;
          return 27;

        case E_V1DImode:
          if (pattern9 (x3, 
E_V1DImode) != 0)
            return -1;
          return 28;

        case E_V2DImode:
          if (pattern9 (x3, 
E_V2DImode) != 0)
            return -1;
          return 29;

        case E_V1TImode:
          if (pattern9 (x3, 
E_V1TImode) != 0)
            return -1;
          return 30;

        case E_TImode:
          if (pattern9 (x3, 
E_TImode) != 0)
            return -1;
          return 31;

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern9 (x3, 
E_V1QImode) != 0)
            return -1;
          return 32;

        case E_V2QImode:
          if (pattern9 (x3, 
E_V2QImode) != 0)
            return -1;
          return 33;

        case E_V4QImode:
          if (pattern9 (x3, 
E_V4QImode) != 0)
            return -1;
          return 34;

        case E_V8QImode:
          if (pattern9 (x3, 
E_V8QImode) != 0)
            return -1;
          return 35;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 36;

        case E_V1HImode:
          if (pattern9 (x3, 
E_V1HImode) != 0)
            return -1;
          return 37;

        case E_V2HImode:
          if (pattern9 (x3, 
E_V2HImode) != 0)
            return -1;
          return 38;

        case E_V4HImode:
          if (pattern9 (x3, 
E_V4HImode) != 0)
            return -1;
          return 39;

        case E_V8HImode:
          if (pattern9 (x3, 
E_V8HImode) != 0)
            return -1;
          return 40;

        case E_V1SImode:
          if (pattern9 (x3, 
E_V1SImode) != 0)
            return -1;
          return 41;

        case E_V2SImode:
          if (pattern9 (x3, 
E_V2SImode) != 0)
            return -1;
          return 42;

        case E_V4SImode:
          if (pattern9 (x3, 
E_V4SImode) != 0)
            return -1;
          return 43;

        case E_V1DImode:
          if (pattern9 (x3, 
E_V1DImode) != 0)
            return -1;
          return 44;

        case E_V2DImode:
          if (pattern9 (x3, 
E_V2DImode) != 0)
            return -1;
          return 45;

        case E_V1TImode:
          if (pattern9 (x3, 
E_V1TImode) != 0)
            return -1;
          return 46;

        case E_TImode:
          if (pattern9 (x3, 
E_TImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  return pattern72 (x2); /* [-1, 23] */
}

int
pattern80 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern87 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern98 (x5); /* [-1, 1] */
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  switch (GET_CODE (x9))
    {
    case LABEL_REF:
      x10 = XEXP (x5, 2);
      if (GET_CODE (x10) != PC)
        return -1;
      x11 = XEXP (x9, 0);
      operands[3] = x11;
      return pattern120 (); /* [-1, 1] */

    case PC:
      x10 = XEXP (x5, 2);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x12 = XEXP (x10, 0);
      operands[3] = x12;
      res = pattern120 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 4)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern152 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          return 6;

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode))
            return -1;
          return 7;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode))
            return -1;
          return 8;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern174 (); /* [-1, 1] */
}

int
pattern181 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern180 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern180 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern180 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern180 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern219 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern219 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x11, 1);
  x16 = XEXP (x15, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x15, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      return pattern231 (x15, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern231 (x15, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern256 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonsym_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 73; /* vstlv1qi */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 74; /* vstlv2qi */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 75; /* vstlv4qi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 76; /* vstlv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 77; /* vstlv16qi */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 78; /* vstlv1hi */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 79; /* vstlv2hi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 80; /* vstlv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 81; /* vstlv8hi */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 82; /* vstlv1si */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 83; /* vstlv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 84; /* vstlv4si */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 85; /* vstlv1di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 86; /* vstlv2di */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 87; /* vstlv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 88; /* vstlv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 89; /* vstlv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 90; /* vstlv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 91; /* vstlv2df */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern167 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern167 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern269 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern269 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern270 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern270 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6142 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2221; /* *adddi3_zero_cconly */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[1], E_DImode)
              && general_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && (
#line 6268 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2229; /* *adddi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && (
#line 6308 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2233; /* *adddi3_carry2_cconly */
                }
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[1], E_SImode)
              && general_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && 
#line 6268 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2230; /* *addsi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && 
#line 6308 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2234; /* *addsi3_carry2_cconly */
                }
            }
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[1], E_TFmode)
              && general_operand (operands[2], E_TFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TFmode)
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2260; /* *addtf3_cconly */
                }
            }
          break;

        case E_FPRX2mode:
          if (nonimmediate_operand (operands[1], E_FPRX2mode)
              && general_operand (operands[2], E_FPRX2mode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_FPRX2mode)
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2261; /* *addfprx23_cconly */
                }
            }
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[1], E_DFmode)
              && general_operand (operands[2], E_DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DFmode)
                  && 
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2262; /* *adddf3_cconly */
                }
            }
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[1], E_SFmode)
              && general_operand (operands[2], E_SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_SFmode)
                  && 
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2263; /* *addsf3_cconly */
                }
            }
          break;

        case E_TDmode:
          if (nonimmediate_operand (operands[1], E_TDmode)
              && general_operand (operands[2], E_TDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TDmode)
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2264; /* *addtd3_cconly */
                }
            }
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[1], E_DDmode)
              && general_operand (operands[2], E_DDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DDmode)
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2265; /* *adddd3_cconly */
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern157 (x3))
        {
        case 0:
          if (!(
#line 6348 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2237; /* *adddi3_cconly */

        case 1:
          if (!
#line 6348 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2238; /* *addsi3_cconly */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (pattern189 (x4, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && (
#line 7044 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2310; /* *adddi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !(
#line 7078 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2314; /* *adddi3_alc_carry2_cconly */

        case E_SImode:
          if (pattern189 (x4, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && 
#line 7044 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            {
              *pnum_clobbers = 1;
              return 2311; /* *addsi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !
#line 7078 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2315; /* *addsi3_alc_carry2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern206 (x2, 
E_V1QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1QImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1441; /* vec_sel0v1qi */
      if (!all_ones_operand (operands[4], E_V1QImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1482; /* *vec_sel1v1qi */

    case E_V2QImode:
      if (pattern206 (x2, 
E_V2QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2QImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1442; /* vec_sel0v2qi */
      if (!all_ones_operand (operands[4], E_V2QImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1483; /* *vec_sel1v2qi */

    case E_V4QImode:
      if (pattern206 (x2, 
E_V4QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4QImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1443; /* vec_sel0v4qi */
      if (!all_ones_operand (operands[4], E_V4QImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1484; /* *vec_sel1v4qi */

    case E_V8QImode:
      if (pattern206 (x2, 
E_V8QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8QImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1444; /* vec_sel0v8qi */
      if (!all_ones_operand (operands[4], E_V8QImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1485; /* *vec_sel1v8qi */

    case E_V16QImode:
      if (pattern206 (x2, 
E_V16QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V16QImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1445; /* vec_sel0v16qi */
      if (!all_ones_operand (operands[4], E_V16QImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1486; /* *vec_sel1v16qi */

    case E_V1HImode:
      if (pattern206 (x2, 
E_V1HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1HImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1446; /* vec_sel0v1hi */
      if (!all_ones_operand (operands[4], E_V1HImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1487; /* *vec_sel1v1hi */

    case E_V2HImode:
      if (pattern206 (x2, 
E_V2HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2HImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1447; /* vec_sel0v2hi */
      if (!all_ones_operand (operands[4], E_V2HImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1488; /* *vec_sel1v2hi */

    case E_V4HImode:
      if (pattern206 (x2, 
E_V4HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4HImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1448; /* vec_sel0v4hi */
      if (!all_ones_operand (operands[4], E_V4HImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1489; /* *vec_sel1v4hi */

    case E_V8HImode:
      if (pattern206 (x2, 
E_V8HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8HImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1449; /* vec_sel0v8hi */
      if (!all_ones_operand (operands[4], E_V8HImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1490; /* *vec_sel1v8hi */

    case E_V1SImode:
      if (pattern206 (x2, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1450; /* vec_sel0v1si */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1491; /* *vec_sel1v1si */

    case E_V2SImode:
      if (pattern206 (x2, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1451; /* vec_sel0v2si */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1492; /* *vec_sel1v2si */

    case E_V4SImode:
      if (pattern206 (x2, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1452; /* vec_sel0v4si */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1493; /* *vec_sel1v4si */

    case E_V1DImode:
      if (pattern206 (x2, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1453; /* vec_sel0v1di */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1494; /* *vec_sel1v1di */

    case E_V2DImode:
      if (pattern206 (x2, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1454; /* vec_sel0v2di */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1495; /* *vec_sel1v2di */

    case E_V1SFmode:
      if (pattern207 (x2, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1455; /* vec_sel0v1sf */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1496; /* *vec_sel1v1sf */

    case E_V2SFmode:
      if (pattern207 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1456; /* vec_sel0v2sf */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1497; /* *vec_sel1v2sf */

    case E_V4SFmode:
      if (pattern207 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1457; /* vec_sel0v4sf */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1498; /* *vec_sel1v4sf */

    case E_V1DFmode:
      if (pattern207 (x2, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1458; /* vec_sel0v1df */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1499; /* *vec_sel1v1df */

    case E_V2DFmode:
      if (pattern207 (x2, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1459; /* vec_sel0v2df */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2728 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1500; /* *vec_sel1v2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[3], E_V1TImode)
          || !const0_operand (operands[4], E_V1TImode)
          || !register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode)
          || !
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1460; /* vec_sel0v1tf */

    case E_V1TImode:
      if (pattern208 (x2, 
E_V1TImode) != 0
          || !
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1461; /* vec_sel0v1ti */

    case E_TImode:
      if (pattern208 (x2, 
E_TImode) != 0
          || !
#line 2704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1462; /* vec_sel0ti */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4489 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1978; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4489 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1979; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4489 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1980; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4489 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1981; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (subreg_register_operand (operands[0], E_QImode)
              && memory_operand (operands[1], E_QImode))
            return 1883; /* movstrictqi */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && subreg_register_operand (operands[0], E_HImode)
              && memory_operand (operands[1], E_HImode))
            {
              *pnum_clobbers = 1;
              return 1884; /* movstricthi */
            }
          break;

        case E_SImode:
          if (subreg_register_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 2776 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1885; /* movstrictsi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          return 2568; /* *jump64 */
        }
      break;

    default:
      break;
    }
  operands[1] = x4;
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode)
          || !
#line 1772 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1838; /* movti */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode))
        return -1;
      if ((
#line 2800 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return 1886; /* *movtf_64 */
      if (!(
#line 2817 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1889; /* *movtf_31 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x3;
      if (address_operand (operands[1], E_QImode))
        {
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == CONST_INT
              && XWINT (x4, 0) == 2147483647L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              if (
#line 2578 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1878; /* *la_31_and */
              if (pnum_clobbers != NULL
                  && 
#line 2592 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 1879; /* *la_31_and_cc */
                }
            }
        }
      if (GET_CODE (x3) == SUBREG)
        {
          res = recog_49 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && XWINT (x4, 0) == 2147483647L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 5192 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2050; /* *llgt_sisi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5203 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2051; /* *llgt_didi */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern160 (x2))
        {
        case 0:
          if (!
#line 7964 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2370; /* *anddi3 */

        case 1:
          if (
#line 8093 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2381; /* *andsi3_zarch */
            }
          if (!
#line 8127 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2382; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern69 (x2, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!contiguous_bitmask_operand (operands[3], E_DImode))
        return -1;
      if (
#line 4407 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
        return 1972; /* *risbgn_di_and_rot */
      if (pnum_clobbers == NULL
          || !
#line 4407 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      *pnum_clobbers = 1;
      return 1973; /* *risbg_di_and_rot */

    case LSHIFTRT:
      switch (pattern119 (x2))
        {
        case 0:
          if ((
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2371; /* *extzv_di_srl_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2372; /* *extzv_di_srl_clobbercc */

        case 1:
          if (
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2373; /* *extzv_si_srl_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2374; /* *extzv_si_srl_clobbercc */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern119 (x2))
        {
        case 0:
          if ((
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2375; /* *extzv_di_sll_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2376; /* *extzv_di_sll_clobbercc */

        case 1:
          if (
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2377; /* *extzv_si_sll_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2378; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2387; /* *andc_split_di */
                }
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2409; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 2388; /* *andc_split_si */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2411; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern133 (x2, 
E_DImode) != 0
                  || !(
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2421; /* *nordi */

            case E_SImode:
              if (pattern133 (x2, 
E_SImode) != 0
                  || !
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2423; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 882; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 883; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 884; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 885; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 886; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 887; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 888; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 889; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 890; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 891; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 892; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 893; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 894; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 895; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 896; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 897; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 898; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 899; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 900; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 901; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 902; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1424 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 903; /* xorti3 */
          break;

        case 22:
          if (
#line 8795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2430; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8898 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2434; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8928 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2435; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern134 (x3) == 0
          && 
#line 4795 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 2025; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8865 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2433; /* *xorsi3 */

    case AND:
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern9 (x3, 
E_V1QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1607; /* *vevalv1qi_xorand */

                case E_V2QImode:
                  if (pattern9 (x3, 
E_V2QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1616; /* *vevalv2qi_xorand */

                case E_V4QImode:
                  if (pattern9 (x3, 
E_V4QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1625; /* *vevalv4qi_xorand */

                case E_V8QImode:
                  if (pattern9 (x3, 
E_V8QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1634; /* *vevalv8qi_xorand */

                case E_V16QImode:
                  if (pattern9 (x3, 
E_V16QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1643; /* *vevalv16qi_xorand */

                case E_V1HImode:
                  if (pattern9 (x3, 
E_V1HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1652; /* *vevalv1hi_xorand */

                case E_V2HImode:
                  if (pattern9 (x3, 
E_V2HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1661; /* *vevalv2hi_xorand */

                case E_V4HImode:
                  if (pattern9 (x3, 
E_V4HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1670; /* *vevalv4hi_xorand */

                case E_V8HImode:
                  if (pattern9 (x3, 
E_V8HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1679; /* *vevalv8hi_xorand */

                case E_V1SImode:
                  if (pattern9 (x3, 
E_V1SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1688; /* *vevalv1si_xorand */

                case E_V2SImode:
                  if (pattern9 (x3, 
E_V2SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1697; /* *vevalv2si_xorand */

                case E_V4SImode:
                  if (pattern9 (x3, 
E_V4SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1706; /* *vevalv4si_xorand */

                case E_V1DImode:
                  if (pattern9 (x3, 
E_V1DImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1715; /* *vevalv1di_xorand */

                case E_V2DImode:
                  if (pattern9 (x3, 
E_V2DImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1724; /* *vevalv2di_xorand */

                case E_V1TImode:
                  if (pattern9 (x3, 
E_V1TImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1733; /* *vevalv1ti_xorand */

                case E_TImode:
                  if (pattern9 (x3, 
E_TImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1742; /* *vevalti_xorand */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern191 (x3, 
E_DImode) != 0
                      || !(
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2003; /* *rxsbg_di_noshift */

                case E_SImode:
                  if (pattern191 (x3, 
E_SImode) != 0
                      || !
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2005; /* *rxsbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern63 (x3, pnum_clobbers) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4703 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2007; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern89 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2009; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 2011; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern89 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2013; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 2015; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1608; /* *vevalv1qi_xorior */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1617; /* *vevalv2qi_xorior */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1626; /* *vevalv4qi_xorior */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1635; /* *vevalv8qi_xorior */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1644; /* *vevalv16qi_xorior */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1653; /* *vevalv1hi_xorior */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1662; /* *vevalv2hi_xorior */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1671; /* *vevalv4hi_xorior */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1680; /* *vevalv8hi_xorior */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1689; /* *vevalv1si_xorior */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1698; /* *vevalv2si_xorior */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1707; /* *vevalv4si_xorior */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1716; /* *vevalv1di_xorior */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1725; /* *vevalv2di_xorior */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1734; /* *vevalv1ti_xorior */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1743; /* *vevalti_xorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1609; /* *vevalv1qi_xorxor */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1618; /* *vevalv2qi_xorxor */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1627; /* *vevalv4qi_xorxor */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1636; /* *vevalv8qi_xorxor */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1645; /* *vevalv16qi_xorxor */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1654; /* *vevalv1hi_xorxor */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1663; /* *vevalv2hi_xorxor */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1672; /* *vevalv4hi_xorxor */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1681; /* *vevalv8hi_xorxor */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1690; /* *vevalv1si_xorxor */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1699; /* *vevalv2si_xorxor */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1708; /* *vevalv4si_xorxor */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1717; /* *vevalv1di_xorxor */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1726; /* *vevalv2di_xorxor */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1735; /* *vevalv1ti_xorxor */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1744; /* *vevalti_xorxor */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern32 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2017; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2019; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern32 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2021; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2023; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern139 (x3, 
E_V4SFmode) != 0
              || !(
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1269; /* fmav4sf4 */

        case E_V2DFmode:
          if (pattern139 (x3, 
E_V2DFmode) != 0
              || !
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1270; /* fmav2df4 */

        case E_V1TFmode:
          if (pattern139 (x3, 
E_V1TFmode) != 0
              || !(
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1271; /* fmav1tf4 */

        case E_TFmode:
          if (pattern139 (x3, 
E_TFmode) != 0
              || !(
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1272; /* fmatf4 */

        case E_DFmode:
          if (pattern140 (x3, 
E_DFmode) != 0
              || !
#line 7601 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2353; /* fmadf4 */

        case E_SFmode:
          if (pattern140 (x3, 
E_SFmode) != 0
              || !
#line 7601 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2354; /* fmasf4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern141 (x3, 
E_V4SFmode) != 0
              || !(
#line 2070 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1273; /* fmsv4sf4 */

        case E_V2DFmode:
          if (pattern141 (x3, 
E_V2DFmode) != 0
              || !
#line 2070 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1274; /* fmsv2df4 */

        case E_V1TFmode:
          if (pattern141 (x3, 
E_V1TFmode) != 0
              || !(
#line 2070 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1275; /* fmsv1tf4 */

        case E_TFmode:
          if (pattern141 (x3, 
E_TFmode) != 0
              || !(
#line 2070 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1276; /* fmstf4 */

        case E_DFmode:
          if (pattern142 (x3, 
E_DFmode) != 0
              || !
#line 7618 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2355; /* fmsdf4 */

        case E_SFmode:
          if (pattern142 (x3, 
E_SFmode) != 0
              || !
#line 7618 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2356; /* fmssf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9319 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2473; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9319 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2474; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern194 (x1))
        {
        case 0:
          if (!(
#line 9330 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2475; /* *absdi2_cconly */

        case 1:
          if (!
#line 9330 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2476; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
    {
      switch (pattern121 (x1))
        {
        case 0:
          if ((
#line 1647 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1829; /* *cmp_and_br_signed_di */
          break;

        case 1:
          if (
#line 1647 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1830; /* *cmp_and_br_signed_si */
          break;

        case 2:
          if ((
#line 1705 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1833; /* *icmp_and_br_signed_di */
          break;

        case 3:
          if (
#line 1705 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1834; /* *icmp_and_br_signed_si */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  switch (GET_CODE (x4))
    {
    case GT:
    case LE:
      if (pnum_clobbers == NULL
          || !s390_brx_operator (x4, E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      operands[6] = x4;
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != SUBREG)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != SUBREG)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      operands[5] = x4;
      x16 = XEXP (x13, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 0);
      operands[3] = x17;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x15, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x13))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x15), 0))
            return -1;
          switch (SUBREG_BYTE (x14))
            {
            case 8:
              if (pattern299 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 10074 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2563; /* *brxg_64bit */

            case 4:
              if (pattern299 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 10160 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2565; /* *brx_31bit */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x13) != E_SImode
              || maybe_ne (SUBREG_BYTE (x14), 12)
              || GET_MODE (x14) != E_SImode
              || maybe_ne (SUBREG_BYTE (x15), 4)
              || GET_MODE (x15) != E_SImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x9) != E_SImode
              || !
#line 10117 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 2;
          return 2564; /* *brx_64bit */

        default:
          return -1;
        }

    case NE:
    case EQ:
      if (pnum_clobbers != NULL)
        {
          res = recog_89 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x4;
      if (!s390_eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 33
          || GET_MODE (x8) != E_CCRAWmode
          || pattern234 (x1) != 0)
        return -1;
      return 2677; /* *ccraw_to_int */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern216 (x5, 
E_DImode) != 0
          || !
#line 7419 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2336; /* *muldi3 */

    case E_SImode:
      if (pattern216 (x5, 
E_SImode) != 0)
        return -1;
      return 2341; /* *mulsi3 */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          operands[1] = x5;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (pattern226 (x6, 
E_DImode) != 0
                  || !(
#line 6364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2239; /* *adddi3_cconly2 */

            case E_SImode:
              if (pattern226 (x6, 
E_SImode) != 0
                  || !
#line 6364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
                return -1;
              return 2240; /* *addsi3_cconly2 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x5;
          res = recog_79 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[2] = x6;
          operands[1] = x5;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != MINUS)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (pattern254 (x10, 
E_DImode) != 0
                      || !(
#line 6838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2281; /* *subdi3_cc2 */

                case E_SImode:
                  if (pattern254 (x10, 
E_SImode) != 0
                      || !
#line 6838 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 2282; /* *subsi3_cc2 */

                default:
                  return -1;
                }

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !general_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[0], E_DImode)
                      || !(
#line 6872 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2285; /* *subdi3_cconly2 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !general_operand (operands[2], E_SImode)
                      || !scratch_operand (operands[0], E_SImode)
                      || !
#line 6872 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
                    return -1;
                  return 2286; /* *subsi3_cconly2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFT:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != SUBREG
              || maybe_ne (SUBREG_BYTE (x14), 0)
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x13, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x16 = XEXP (x5, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (!register_operand (x9, E_DImode))
            return -1;
          x17 = XEXP (x14, 0);
          switch (GET_CODE (x17))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x17;
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x4, 1);
              operands[1] = x6;
              if (!const0_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[0])
                  || !
#line 1087 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1766; /* *tstdi_sign */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 1
                  || XINT (x17, 1) != 4
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x6 = XEXP (x4, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern296 (x1) != 0)
                return -1;
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              x18 = XVECEXP (x11, 0, 0);
              if (!rtx_equal_p (x18, operands[1])
                  || !
#line 4231 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH))
                return -1;
              return 1944; /* *cmpint_sign_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x16 = XEXP (x5, 1);
          operands[2] = x16;
          if (!shift_count_operand (operands[2], E_QImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              switch (pattern194 (x1))
                {
                case 0:
                  if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9737 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2539; /* *ashrdi3_31_cconly */
                  if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2542; /* *ashrdi3_cconly */

                case 1:
                  if (!
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2545; /* *ashrsi3_cconly */

                default:
                  return -1;
                }

            case SET:
              x10 = XEXP (x7, 1);
              if (GET_CODE (x10) != ASHIFTRT)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x10, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (pattern241 (x1))
                {
                case 0:
                  if ((
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9737 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
                    return 2540; /* *ashrdi3_31_cc */
                  if (!(
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2543; /* *ashrdi3_cc */

                case 1:
                  if (!
#line 31 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
                    return -1;
                  return 2546; /* *ashrsi3_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 4
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET
          || pattern214 (x1) != 0)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      x19 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x19, operands[1])
          || !
#line 4196 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)))
        return -1;
      return 1942; /* *cmpint_cc */

    case IOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case AND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x16 = XEXP (x5, 1);
          if (GET_CODE (x16) != AND
              || GET_MODE (x16) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[2] = x15;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x20 = XEXP (x16, 0);
          operands[3] = x20;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x21 = XEXP (x16, 1);
          operands[4] = x21;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case SET:
              x10 = XEXP (x7, 1);
              if (pattern255 (x10, 
AND, 
IOR) != 0)
                return -1;
              x12 = XEXP (x10, 1);
              if (GET_CODE (x12) != AND
                  || GET_MODE (x12) != E_DImode)
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x22 = XEXP (x11, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x11, 1);
              if (!rtx_equal_p (x23, operands[2]))
                return -1;
              x24 = XEXP (x12, 0);
              if (!rtx_equal_p (x24, operands[3]))
                return -1;
              x25 = XEXP (x12, 1);
              if (!rtx_equal_p (x25, operands[4])
                  || !
#line 4524 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1986; /* *insv_z10_noshift_cc */

            case CLOBBER:
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 4543 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                return -1;
              return 1987; /* *insv_z10_noshift_cconly */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern150 (x1, 
IOR))
            {
            case 0:
              if (!
#line 8341 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2390; /* *iordi3_cc */

            case 1:
              if (!
#line 8421 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2393; /* *iorsi3_cc */

            case 2:
              if (!
#line 8356 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              return 2391; /* *iordi3_cconly */

            case 3:
              if (!
#line 8438 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2394; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern165 (x1, 
IOR))
            {
            case 0:
              if (!(
#line 8593 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2402; /* *orcdi_cc */

            case 1:
              if (!
#line 8593 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2404; /* *orcsi_cc */

            case 2:
              if (!(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2406; /* *orcdi_cconly */

            case 3:
              if (!
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2408; /* *orcsi_cconly */

            case 4:
              if (!(
#line 8633 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2414; /* *nanddi_cc */

            case 5:
              if (!
#line 8633 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2416; /* *nandsi_cc */

            case 6:
              if (!(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2418; /* *nanddi_cconly */

            case 7:
              if (!
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2420; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_84 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_85 (x1, insn, pnum_clobbers);

    case MULT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != SIGN_EXTEND)
        return -1;
      switch (pattern147 (x1, 
MULT))
        {
        case 0:
          if (pattern290 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 7549 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2343; /* *mulvdi3_ccoverflow */

        case 1:
          if (pattern290 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 7549 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode) && TARGET_Z14))
            return -1;
          return 2344; /* *mulvsi3_ccoverflow */

        default:
          return -1;
        }

    case AND:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern150 (x1, 
AND))
            {
            case 0:
              if (!
#line 7925 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2368; /* *anddi3_cc */

            case 1:
              if (!
#line 8049 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2379; /* *andsi3_cc */

            case 2:
              if (!
#line 7942 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              return 2369; /* *anddi3_cconly */

            case 3:
              if (!
#line 8070 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              return 2380; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern165 (x1, 
AND))
            {
            case 0:
              if (!(
#line 8593 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2401; /* *andcdi_cc */

            case 1:
              if (!
#line 8593 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2403; /* *andcsi_cc */

            case 2:
              if (!(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2405; /* *andcdi_cconly */

            case 3:
              if (!
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2407; /* *andcsi_cconly */

            case 4:
              if (!(
#line 8633 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2413; /* *nordi_cc */

            case 5:
              if (!
#line 8633 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2415; /* *norsi_cc */

            case 6:
              if (!(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2417; /* *nordi_cconly */

            case 7:
              if (!
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2419; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern150 (x1, 
XOR))
        {
        case 0:
          if (!
#line 8766 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2428; /* *xordi3_cc */

        case 1:
          if (!
#line 8830 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2431; /* *xorsi3_cc */

        case 2:
          if (!
#line 8781 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          return 2429; /* *xordi3_cconly */

        case 3:
          if (!
#line 8848 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2432; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != XOR)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x15 = XEXP (x13, 1);
      operands[2] = x15;
      switch (pattern193 (x1, 
NOT, 
XOR))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (pattern273 (x1, 
E_DImode) != 0
                  || !(
#line 9047 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2438; /* *nxordi_cc */

            case E_SImode:
              if (pattern273 (x1, 
E_SImode) != 0
                  || !
#line 9047 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              return 2439; /* *nxorsi_cc */

            default:
              return -1;
            }

        case 1:
          if (pattern240 (x13, 
E_DImode) != 0
              || !(
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2440; /* *nxordi_cconly */

        case 2:
          if (pattern240 (x13, 
E_SImode) != 0
              || !
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2441; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      return recog_86 (x1, insn, pnum_clobbers);

    case ABS:
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case ASHIFTRT:
          if (pattern151 (x1, 
ABS) != 0
              || !
#line 9298 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2471; /* *absdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x13;
          x6 = XEXP (x4, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_83 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x6;
          switch (pattern181 (x1, 
ABS))
            {
            case 0:
              if (!(
#line 9364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2479; /* *abstf2_cc */

            case 1:
              if (!(
#line 9364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2480; /* *absfprx22_cc */

            case 2:
              if (!
#line 9364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2481; /* *absdf2_cc */

            case 3:
              if (!
#line 9364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2482; /* *abssf2_cc */

            case 4:
              if (!(
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2483; /* *abstf2_cconly */

            case 5:
              if (!(
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2484; /* *absfprx22_cconly */

            case 6:
              if (!
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2485; /* *absdf2_cconly */

            case 7:
              if (!
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              return 2486; /* *abssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x10 = XEXP (x7, 1);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 12129 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode (insn, CCTmode)))
            return -1;
          return 2664; /* *popcountdi_z15_cc */

        case CLOBBER:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 12138 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          return 2665; /* *popcountdi_z15_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      switch (pattern39 (x1))
        {
        case 0:
          if (!(
#line 1135 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1140 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_48 (insn, operands);

        case 1:
          if (!(
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1210 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_50 (insn, operands);

        case 2:
          if (!(
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1210 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
            return NULL;
          return gen_split_51 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return NULL;
      switch (pattern166 (x3))
        {
        case 0:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V8HImode)
   && !memory_operand (operands[1], V8HImode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SImode)
   && !memory_operand (operands[1], V4SImode))))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V4SFmode)
   && !memory_operand (operands[1], V4SFmode))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 3:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DImode)
   && !memory_operand (operands[1], V2DImode))))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V2DFmode)
   && !memory_operand (operands[1], V2DFmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 5:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TImode)
   && !memory_operand (operands[1], V1TImode))))
            return NULL;
          return gen_split_141 (insn, operands);

        case 6:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], V1TFmode)
   && !memory_operand (operands[1], V1TFmode))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 7:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TImode)
   && !memory_operand (operands[1], TImode))))
            return NULL;
          return gen_split_143 (insn, operands);

        case 8:
          if (!(
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 3485 "../../gcc/config/s390/vector.md"
( reload_completed
   && !memory_operand (operands[0], TFmode)
   && !memory_operand (operands[1], TFmode))))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (pattern41 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (GET_CODE (x8) == CONST_INT
                  && XWINT (x8, 0) == 2147483647L
                  && register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode)
                {
                  operands[1] = x6;
                  if (address_operand (operands[1], E_QImode)
                      && (
#line 2592 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT) && 
#line 2594 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_302 (insn, operands);
                  if (nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5215 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                    return gen_split_354 (insn, operands);
                }
              operands[1] = x8;
              if (rtx_equal_p (x6, operands[0]))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (s_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && immediate_operand (operands[1], E_SImode)
                          && 
#line 8141 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_370 (insn, operands);
                      break;

                    case E_HImode:
                      if (s_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && immediate_operand (operands[1], E_HImode)
                          && 
#line 8186 "../../gcc/config/s390/s390.md"
(reload_completed))
                        return gen_split_371 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case SUBREG:
            case MEM:
              operands[1] = x8;
              if (memory_operand (operands[1], E_VOIDmode)
                  && memory_operand (operands[0], E_VOIDmode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 8278 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return gen_split_374 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == 2147483647L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 0)
                  && GET_MODE (x6) == E_DImode)
                {
                  x9 = XEXP (x6, 0);
                  operands[1] = x9;
                  if (memory_operand (operands[1], E_SImode)
                      && (
#line 5180 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 5182 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return gen_split_352 (insn, operands);
                }
              operands[1] = x6;
              if (nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5215 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed))
                return gen_split_353 (insn, operands);
            }
          if (!rtx_equal_p (x6, operands[0])
              || !s_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          operands[1] = x8;
          if (!immediate_operand (operands[1], E_DImode)
              || !
#line 8001 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case NOT:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern233 (x3, 
E_DImode) != 0
                  || !((
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 8243 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_372 (insn, operands);

            case E_SImode:
              if (pattern233 (x3, 
E_SImode) != 0
                  || !(
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 8243 "../../gcc/config/s390/s390.md"
( 1)))
                return NULL;
              return gen_split_373 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 4
          || pattern105 (x1) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_CCUmode)
          || !
#line 4183 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_338 (insn, operands);

    case COMPARE:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 33)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 4
              || GET_MODE (x6) != E_SImode
              || pattern214 (x1) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 1);
          x12 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 4196 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)) && 
#line 4198 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_339 (insn, operands);

        case ASHIFTRT:
          if (GET_MODE (x6) != E_DImode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_DImode)
            return NULL;
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != SUBREG
              || maybe_ne (SUBREG_BYTE (x13), 0)
              || GET_MODE (x13) != E_DImode)
            return NULL;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != UNSPEC
              || XVECLEN (x14, 0) != 1
              || XINT (x14, 1) != 4
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x15 = XEXP (x9, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x16 = XEXP (x6, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return NULL;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode
              || pattern296 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x17 = XEXP (x11, 0);
          x18 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !(
#line 4231 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_ZARCH) && 
#line 4233 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_341 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern75 (x1))
        {
        case 0:
          if (!((
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 4420 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_342 (insn, operands);

        case 1:
          if (!(
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 4420 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_343 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x19 = XEXP (x3, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern75 (x1))
        {
        case 0:
          if (!(
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4445 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_344 (insn, operands);

        case 1:
          if (!
#line 4445 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_345 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      if (pattern41 (x1) != 0)
        return NULL;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x16 = XEXP (x6, 1);
          operands[2] = x16;
          x20 = XEXP (x8, 0);
          operands[3] = x20;
          x21 = XEXP (x8, 1);
          operands[4] = x21;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern261 (x3, 
E_DImode) != 0
                  || !(
#line 4660 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return NULL;
              return gen_split_348 (insn, operands);

            case E_SImode:
              if (pattern261 (x3, 
E_SImode) != 0
                  || !
#line 4660 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
                return NULL;
              return gen_split_349 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x6, operands[0]))
            return NULL;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          switch (pattern197 (x3))
            {
            case 0:
              if (!
#line 8404 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_375 (insn, operands);

            case 1:
              if (!
#line 8495 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_376 (insn, operands);

            case 2:
              if (!
#line 8538 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_377 (insn, operands);

            case 3:
              if (!
#line 8688 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
                return NULL;
              return gen_split_378 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern49 (x1))
        {
        case 0:
          if (pattern216 (x3, 
E_TImode) != 0
              || !(
#line 6075 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6077 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_358 (insn, operands);

        case 1:
          if (pattern124 (x3, 
E_DImode) != 0
              || !(
#line 6166 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6168 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_359 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern49 (x1))
        {
        case 0:
          if (pattern221 (x3, 
E_TImode) != 0
              || !(
#line 6622 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 6624 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_360 (insn, operands);

        case 1:
          if (pattern221 (x3, 
E_DImode) != 0
              || !(
#line 6713 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 6715 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_361 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern41 (x1) != 0)
        return NULL;
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          switch (pattern186 (x3))
            {
            case 0:
              if ((
#line 4214 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 4216 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_340 (insn, operands);
              break;

            case 1:
              if (((
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 5117 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_350 (insn, operands);
              break;

            case 2:
              if ((
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 5117 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_351 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_SImode
              && register_operand (operands[0], E_SImode))
            {
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (s_operand (operands[1], E_HImode)
                  && (
#line 5300 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5302 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return gen_split_355 (insn, operands);
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_DImode)
              && (
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 7207 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return gen_split_362 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_DImode)
              || !(
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 7221 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_364 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          if (s390_alc_comparison (operands[1], E_SImode)
              && 
#line 7207 "../../gcc/config/s390/s390.md"
( reload_completed))
            return gen_split_363 (insn, operands);
          if (!s390_slb_comparison (operands[1], E_SImode)
              || !
#line 7221 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_365 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern42 (x4) != 0)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !
#line 7279 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_366 (insn, operands);

    case XOR:
      if (pattern41 (x1) != 0)
        return NULL;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      switch (pattern197 (x3))
        {
        case 0:
          if (!
#line 8813 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_383 (insn, operands);

        case 1:
          if (!
#line 8883 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_384 (insn, operands);

        case 2:
          if (!
#line 8913 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_385 (insn, operands);

        case 3:
          if (!
#line 8960 "../../gcc/config/s390/s390.md"
(reload_completed
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
            return NULL;
          return gen_split_386 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (pattern43 (x1) != 0)
        return NULL;
      if (
#line 9161 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && reload_completed
   && ((REG_P (operands[0]) && REG_P (operands[1])
       && REGNO (operands[0]) == REGNO (operands[1]))
      || s390_split_ok_p (operands[0], operands[1], DImode, 0))))
        return gen_split_387 (insn, operands);
      if (!
#line 9194 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)
   && reload_completed))
        return NULL;
      return gen_split_388 (insn, operands);

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!s390_eqne_operator (x6, E_VOIDmode))
        return NULL;
      operands[0] = x6;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 33
          || GET_MODE (x9) != E_CCRAWmode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return NULL;
      x19 = XEXP (x3, 2);
      if (GET_CODE (x19) != PC)
        return NULL;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern234 (x1) != 0)
        return NULL;
      return gen_split_399 (insn, operands);

    default:
      return NULL;
    }
}
