/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern23 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern23 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern23 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern23 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern23 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern23 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern23 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern23 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern23 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern23 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern33 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern33 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern33 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern54 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern54 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern54 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern54 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern54 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern64 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern64 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern67 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern67 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern67 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern136 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern136 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern152 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      return 0;

    case SUBREG:
    case MEM:
      operands[1] = x2;
      if (!s_operand (operands[1], E_QImode))
        return -1;
      res = pattern74 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  return 0;
}

int
pattern225 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern301 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1221; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1222; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1223; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1224; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1225; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1226; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1227; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1228; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1229; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1230; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1231; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1232; /* vec_widen_smult_odd_v4si */

    case 12:
      if (!
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1233; /* vec_widen_smult_odd_v1di */

    case 13:
      if (!(
#line 1865 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1234; /* vec_widen_smult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 59:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !memory_operand (operands[1], E_QImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 5; /* vec_insert_and_zerov16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_HImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 6; /* vec_insert_and_zerov8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 7; /* vec_insert_and_zerov4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 8; /* vec_insert_and_zerov2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !memory_operand (operands[1], E_DFmode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 9; /* vec_insert_and_zerov2df */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_SFmode)
              || !(
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 27 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 10; /* vec_insert_and_zerov4sf */

        default:
          return -1;
        }

    case 71:
      switch (pattern50 (x3))
        {
        case 0:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 70; /* vec_extendv16qi */

        case 1:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 71; /* vec_extendv8hi */

        case 2:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 72; /* vec_extendv4si */

        default:
          return -1;
        }

    case 75:
      switch (pattern51 (x3))
        {
        case 0:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 94; /* vec_unpackhv16qi */

        case 1:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 95; /* vec_unpackhv8hi */

        case 2:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 96; /* vec_unpackhv4si */

        case 3:
          if (!(
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 97; /* vec_unpackhv2di */

        default:
          return -1;
        }

    case 76:
      switch (pattern51 (x3))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 98; /* vec_unpackh_lv16qi */

        case 1:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 99; /* vec_unpackh_lv8hi */

        case 2:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 100; /* vec_unpackh_lv4si */

        case 3:
          if (!(
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 101; /* vec_unpackh_lv2di */

        default:
          return -1;
        }

    case 77:
      switch (pattern51 (x3))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 102; /* vec_unpacklv16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 103; /* vec_unpacklv8hi */

        case 2:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 104; /* vec_unpacklv4si */

        case 3:
          if (!(
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 105; /* vec_unpacklv2di */

        default:
          return -1;
        }

    case 78:
      switch (pattern51 (x3))
        {
        case 0:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 106; /* vec_unpackl_lv16qi */

        case 1:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 107; /* vec_unpackl_lv8hi */

        case 2:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 108; /* vec_unpackl_lv4si */

        case 3:
          if (!(
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 109; /* vec_unpackl_lv2di */

        default:
          return -1;
        }

    case 113:
      switch (pattern50 (x3))
        {
        case 0:
          if (!
#line 1500 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 377; /* vistrv16qi */

        case 1:
          if (!
#line 1500 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 378; /* vistrv8hi */

        case 2:
          if (!
#line 1500 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 379; /* vistrv4si */

        default:
          return -1;
        }

    case 124:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 1852 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 403; /* vflls */

    case 131:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2280 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 525; /* vgemv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2289 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 526; /* vgemv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2289 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 527; /* vgemv4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2289 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 528; /* vgemv2di */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2289 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 529; /* vgemv1ti */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2289 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 530; /* vgemti */

        default:
          return -1;
        }

    case 132:
      if (GET_MODE (x3) != E_FPRX2mode
          || !register_operand (operands[0], E_FPRX2mode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_TFmode)
          || !
#line 1059 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 699; /* tf_to_fprx2 */

    case 37:
      return recog_1 (x1, insn, pnum_clobbers);

    case 40:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1561; /* floorv4sf2 */

        case 1:
          if (!
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1566; /* floorv2df2 */

        case 2:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1571; /* floorv1tf2 */

        case 3:
          if ((
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1576; /* floortf2_vr */
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2134; /* floortf2_fpr */

        case 4:
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2139; /* floorfprx22 */

        case 5:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2144; /* floordf2 */

        case 6:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2149; /* floorsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2158; /* floortd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2163; /* floordd2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1562; /* btruncv4sf2 */

        case 1:
          if (!
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1567; /* btruncv2df2 */

        case 2:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1572; /* btruncv1tf2 */

        case 3:
          if ((
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1577; /* btrunctf2_vr */
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2135; /* btrunctf2_fpr */

        case 4:
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2140; /* btruncfprx22 */

        case 5:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2145; /* btruncdf2 */

        case 6:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2150; /* btruncsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2159; /* btrunctd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2164; /* btruncdd2 */

        default:
          return -1;
        }

    case 42:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1563; /* roundv4sf2 */

        case 1:
          if (!
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1568; /* roundv2df2 */

        case 2:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1573; /* roundv1tf2 */

        case 3:
          if ((
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1578; /* roundtf2_vr */
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2136; /* roundtf2_fpr */

        case 4:
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2141; /* roundfprx22 */

        case 5:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2146; /* rounddf2 */

        case 6:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2151; /* roundsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2160; /* roundtd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2165; /* rounddd2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1564; /* ceilv4sf2 */

        case 1:
          if (!
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1569; /* ceilv2df2 */

        case 2:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1574; /* ceilv1tf2 */

        case 3:
          if ((
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1579; /* ceiltf2_vr */
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2137; /* ceiltf2_fpr */

        case 4:
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2142; /* ceilfprx22 */

        case 5:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2147; /* ceildf2 */

        case 6:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2152; /* ceilsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2161; /* ceiltd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2166; /* ceildd2 */

        default:
          return -1;
        }

    case 44:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1565; /* nearbyintv4sf2 */

        case 1:
          if (!
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1570; /* nearbyintv2df2 */

        case 2:
          if (!(
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1575; /* nearbyintv1tf2 */

        case 3:
          if ((
#line 3215 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1580; /* nearbyinttf2_vr */
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2138; /* nearbyinttf2_fpr */

        case 4:
          if (!(
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2143; /* nearbyintfprx22 */

        case 5:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2148; /* nearbyintdf2 */

        case 6:
          if (!
#line 5846 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2153; /* nearbyintsf2 */

        case 7:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2162; /* nearbyinttd2 */

        case 8:
          if (!
#line 5872 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2167; /* nearbyintdd2 */

        default:
          return -1;
        }

    case 45:
      switch (pattern52 (x3))
        {
        case 0:
          if (!(
#line 3232 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1581; /* rintv4sf2 */

        case 1:
          if (!
#line 3232 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1582; /* rintv2df2 */

        case 2:
          if (!(
#line 3232 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1583; /* rintv1tf2 */

        case 3:
          if ((
#line 3232 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1584; /* rinttf2_vr */
          if (!
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE))
            return -1;
          return 2154; /* rinttf2_fpr */

        case 4:
          if (!
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE))
            return -1;
          return 2155; /* rintfprx22 */

        case 5:
          return 2156; /* rintdf2 */

        case 6:
          return 2157; /* rintsf2 */

        case 7:
          if (!
#line 5882 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2168; /* rinttd2 */

        case 8:
          if (!
#line 5882 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2169; /* rintdd2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern83 (x3))
        {
        case 0:
          return 1870; /* *get_tp_31 */

        case 1:
          if (!
#line 2181 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1871; /* *get_tp_64 */

        default:
          return -1;
        }

    case 5:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      return 1920; /* *cc_to_int */

    case 4:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      *pnum_clobbers = 1;
      return 1941; /* cmpint */

    case 20:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 2614; /* mem_thread_fence_1 */

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 11235 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2615; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 11282 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2617; /* atomic_storedi_1 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          if (register_operand (operands[0], E_TImode)
              && memory_operand (operands[1], E_TImode)
              && 
#line 11249 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2616; /* atomic_loadti_1 */
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 11296 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2618; /* atomic_storeti_1 */

        default:
          return -1;
        }

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11747 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2641; /* main_base_64 */

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11767 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2643; /* reload_base_64 */

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2653; /* stack_protect_setdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2654; /* stack_protect_setsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16L:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4904 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 2031; /* *insvdi_reg_imm */

    case 32L:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          if (!
#line 4928 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2032; /* *insv_h_di_reg_extimm */

        case 32L:
          if (!
#line 4939 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2033; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2788 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1529; /* extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2788 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1531; /* extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2788 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1533; /* extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2788 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1535; /* extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2788 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1537; /* extendv4hiv4si2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern117 (x3))
        {
        case 0:
          if (!
#line 2820 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1539; /* vec_unpacks_hi_v16qi */

        case 1:
          if (!
#line 2831 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1540; /* vec_unpacks_lo_v16qi */

        case 2:
          if (!
#line 2869 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1543; /* vec_unpacks_hi_v8hi */

        case 3:
          if (!
#line 2879 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1544; /* vec_unpacks_lo_v8hi */

        case 4:
          if (!
#line 2915 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1547; /* vec_unpacks_hi_v4si */

        case 5:
          if (!
#line 2925 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1548; /* vec_unpacks_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2326; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2328; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2327; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2329; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 760; /* negv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 761; /* negv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 762; /* negv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 763; /* negv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 764; /* negv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 765; /* negv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 766; /* negv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 767; /* negv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* negv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* negv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* negv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* negv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 772; /* negv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1318 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 773; /* negv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1285; /* negv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1286; /* negv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1287; /* negv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1288; /* negv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1289; /* negv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1290; /* negv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 2100 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1291; /* negtf2_vr */
          if ((
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2461; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2467; /* *negtf2 */

        case E_DImode:
          if (pattern86 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          if (
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2450; /* *negdi2 */
            }
          if (!
#line 9148 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2452; /* *negdi2_31 */

        case E_SImode:
          if (pattern86 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2451; /* *negsi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2462; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2468; /* *negfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2463; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2469; /* *negdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2464; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2470; /* *negsf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2465; /* *negtd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9259 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2466; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern158 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2081 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1277; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern158 (x3, 
E_V2DFmode) != 0
                  || !
#line 2081 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1278; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern158 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2081 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1279; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern158 (x3, 
E_TFmode) != 0
                  || !(
#line 2081 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1280; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern159 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2092 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1281; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern159 (x3, 
E_V2DFmode) != 0
                  || !
#line 2092 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1282; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern159 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2092 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1283; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern159 (x3, 
E_TFmode) != 0
                  || !(
#line 2092 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1284; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern112 (x3, 
E_V1SFmode) != 0
                  || !(
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1299; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern112 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1300; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern112 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1301; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern112 (x3, 
E_V1DFmode) != 0
                  || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1302; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern112 (x3, 
E_V2DFmode) != 0
                  || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1303; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern112 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1304; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern112 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1305; /* negabstf2 */
              if ((
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2513; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2519; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern112 (x3, 
E_DImode) != 0
                  || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2503; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern112 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2504; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern112 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2514; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2520; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern112 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2515; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2521; /* *negabsdf2 */

            case E_SFmode:
              if (pattern112 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2516; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2522; /* *negabssf2 */

            case E_TDmode:
              if (pattern112 (x3, 
E_TDmode) != 0
                  || !(
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2517; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern112 (x3, 
E_DDmode) != 0
                  || !(
#line 9523 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2518; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9454 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2498; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern69 (x3, 
E_SImode) != 0
          || !
#line 9106 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2445; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern143 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2960 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1551; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern143 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 3004 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1552; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3327 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1586; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2124; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2128; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5779 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 2123; /* *extendsfdf2_z13 */
              if (!
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2130; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2126; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern90 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2125; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2129; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern90 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2127; /* *extenddfsf2 */

            case 1:
              if (!
#line 5791 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2131; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5813 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2132; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5821 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2133; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern172 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 727 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 628; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern172 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 727 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 629; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern111 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1432; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern111 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2566 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1433; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern34 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2754 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1520; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2754 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2754 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern34 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2766 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1523; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2766 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1524; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2766 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1525; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern34 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1526; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1527; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1528; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != NEG)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern241 (x1))
        {
        case 0:
          if (!(
#line 9118 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2446; /* *negdi2_cc */

        case 1:
          if (!
#line 9118 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2447; /* *negsi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern194 (x1))
        {
        case 0:
          if (!(
#line 9129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2448; /* *negdi2_cconly */

        case 1:
          if (!
#line 9129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2449; /* *negsi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      *pnum_clobbers = 2;
      return 2566; /* doloop_si64 */

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !
#line 10258 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 2;
      return 2567; /* doloop_di */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (SUBREG_BYTE (x4))
    {
    case 0:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1961; /* *risbg_and_subregdi_rotr */
              if (!
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1967; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1963; /* *risbg_and_subregdi_rotr */
              if (!
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1969; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1965; /* *risbg_and_subregdi_rotr */
              if (!
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1971; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 2147483647L
              || !
#line 5180 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2049; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!nonzero_shift_count_operand (operands[2], E_DImode)
              || !
#line 4605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1999; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 2);
          operands[2] = x9;
          if (!nonzero_shift_count_operand (operands[2], E_SImode)
              || !
#line 4619 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 2001; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 66:
          switch (pattern146 (x1, 
65))
            {
            case 0:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 69:
          switch (pattern146 (x1, 
68))
            {
            case 0:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 127:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 405; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 406; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 407; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_TImode)
                  || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 408; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 126:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern47 (x7, 
127, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1951 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 409; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1951 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 410; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1951 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 411; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1951 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 412; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern41 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1945; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4267 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1946; /* *sethighpartdi_64 */
              if (!
#line 4277 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1947; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 46:
          if (pattern105 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12590 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2690; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern71 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 107:
          switch (pattern283 (x1, 
108))
            {
            case 0:
              if (!
#line 1309 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 362; /* *vfaesv16qi */

            case 1:
              if (!
#line 1309 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 363; /* *vfaesv8hi */

            case 2:
              if (!
#line 1309 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 364; /* *vfaesv4si */

            default:
              return -1;
            }

        case 109:
          switch (pattern283 (x1, 
110))
            {
            case 0:
              if (!
#line 2594 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1435; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2594 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1436; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2594 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1437; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 111:
          switch (pattern283 (x1, 
112))
            {
            case 0:
              if (!
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1438; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1439; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1440; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 113:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern155 (x9, 
E_CCRAWmode, 
114, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1511 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 380; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1511 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 381; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1511 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 382; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern92 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1941; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern92 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 798 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2667; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2668; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2669; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2670; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern71 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 115:
          if (XINT (x9, 1) != 116)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern297 (x3, 
E_V16QImode) != 0
                  || !
#line 1568 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 386; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern297 (x3, 
E_V8HImode) != 0
                  || !
#line 1568 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 387; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern297 (x3, 
E_V4SImode) != 0
                  || !
#line 1568 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 388; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 117:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 118
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1689 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 389; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1689 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 390; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1689 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 391; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 302 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 104 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 322 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 104 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 336 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 104 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 356 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 104 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1799 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_290 (insn, operands);
          if (
#line 1813 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_291 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1830 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_292 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1848 "../../gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_293 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 2195 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_296 (insn, operands);
              if (
#line 2206 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_297 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2244 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_298 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2257 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_299 (insn, operands);
          if (
#line 2273 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_300 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2289 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_301 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2832 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_304 (insn, operands);
          if ((
#line 2848 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_307 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2864 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_310 (insn, operands);
          if ((
#line 2880 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_313 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2896 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_316 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2832 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_305 (insn, operands);
          if (
#line 2848 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_308 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2864 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_311 (insn, operands);
          if (
#line 2880 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_314 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2896 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_317 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 3004 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_318 (insn, operands);
          if (
#line 3020 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_320 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 3036 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_322 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 3004 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_319 (insn, operands);
          if (
#line 3020 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_321 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 3036 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_323 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 3126 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_324 (insn, operands);

    default:
      return NULL;
    }
}
