/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern0 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern17 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern17 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern145 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern145 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern145 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern174 (); /* [-1, 1] */
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          operands[3] = x5;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (!scratch_operand (operands[4], E_VOIDmode))
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x5) != E_BLKmode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern282 (x5, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern282 (x5, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern282 (x5, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 307; /* vec_srlv16qiv16qi */

    case 1:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 317; /* vec_srlv16qiv8hi */

    case 2:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 327; /* vec_srlv16qiv4si */

    case 3:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 308; /* vec_srlv8hiv16qi */

    case 4:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 318; /* vec_srlv8hiv8hi */

    case 5:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 328; /* vec_srlv8hiv4si */

    case 6:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 309; /* vec_srlv4siv16qi */

    case 7:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 319; /* vec_srlv4siv8hi */

    case 8:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 329; /* vec_srlv4siv4si */

    case 9:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 310; /* vec_srlv2div16qi */

    case 10:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 320; /* vec_srlv2div8hi */

    case 11:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 330; /* vec_srlv2div4si */

    case 12:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 311; /* vec_srlv1tiv16qi */

    case 13:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 321; /* vec_srlv1tiv8hi */

    case 14:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 331; /* vec_srlv1tiv4si */

    case 15:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 312; /* vec_srltiv16qi */

    case 16:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 322; /* vec_srltiv8hi */

    case 17:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 332; /* vec_srltiv4si */

    case 18:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 313; /* vec_srlv4sfv16qi */

    case 19:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vec_srlv4sfv8hi */

    case 20:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 333; /* vec_srlv4sfv4si */

    case 21:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 314; /* vec_srlv2dfv16qi */

    case 22:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 324; /* vec_srlv2dfv8hi */

    case 23:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 334; /* vec_srlv2dfv4si */

    case 24:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 315; /* vec_srlv1tfv16qi */

    case 25:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 325; /* vec_srlv1tfv8hi */

    case 26:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 335; /* vec_srlv1tfv4si */

    case 27:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 316; /* vec_srltfv16qi */

    case 28:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 326; /* vec_srltfv8hi */

    case 29:
      if (!
#line 1140 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 336; /* vec_srltfv4si */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PARALLEL:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) == MEM)
            {
              res = recog_17 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1QImode:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 592; /* *vec_extractv1qi */

                case E_V2QImode:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 593; /* *vec_extractv2qi */

                case E_V4QImode:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 594; /* *vec_extractv4qi */

                case E_V8QImode:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 595; /* *vec_extractv8qi */

                case E_V16QImode:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 596; /* *vec_extractv16qi */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1HImode:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 597; /* *vec_extractv1hi */

                case E_V2HImode:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 598; /* *vec_extractv2hi */

                case E_V4HImode:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 599; /* *vec_extractv4hi */

                case E_V8HImode:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 600; /* *vec_extractv8hi */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1SImode:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 601; /* *vec_extractv1si */

                case E_V2SImode:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 602; /* *vec_extractv2si */

                case E_V4SImode:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 603; /* *vec_extractv4si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1DImode:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 604; /* *vec_extractv1di */

                case E_V2DImode:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 605; /* *vec_extractv2di */

                default:
                  return -1;
                }

            case E_SFmode:
              if (!nonimmediate_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 606; /* *vec_extractv2sf */

                case E_V4SFmode:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 607; /* *vec_extractv4sf */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!nonimmediate_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !nonmemory_operand (operands[1], E_V2DFmode)
                  || !
#line 657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 608; /* *vec_extractv2df */

            default:
              return -1;
            }

        case 8:
          if (pattern62 (x3, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
            return -1;
          x7 = XVECEXP (x3, 0, 4);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XVECEXP (x3, 0, 5);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x9 = XVECEXP (x3, 0, 6);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XVECEXP (x3, 0, 7);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !
#line 1166 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          *pnum_clobbers = 2;
          return 701; /* eltswapv8hi */

        case 4:
          if (pattern62 (x3, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode
                  || !nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 702; /* eltswapv4si */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 703; /* eltswapv4sf */

            default:
              return -1;
            }

        case 2:
          x6 = XVECEXP (x3, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x3, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !nonimmediate_operand (operands[1], E_V2DImode)
                  || !
#line 1235 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 704; /* eltswapv2di */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 1235 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 705; /* eltswapv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x13 = XEXP (x3, 0);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x14 = XVECEXP (x12, 0, 0);
      operands[3] = x14;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 609; /* *vec_extractv1qi_plus */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 610; /* *vec_extractv2qi_plus */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 611; /* *vec_extractv4qi_plus */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 612; /* *vec_extractv8qi_plus */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 613; /* *vec_extractv16qi_plus */

            default:
              return -1;
            }

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 614; /* *vec_extractv1hi_plus */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 615; /* *vec_extractv2hi_plus */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 616; /* *vec_extractv4hi_plus */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 617; /* *vec_extractv8hi_plus */

            default:
              return -1;
            }

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 618; /* *vec_extractv1si_plus */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 619; /* *vec_extractv2si_plus */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 620; /* *vec_extractv4si_plus */

            default:
              return -1;
            }

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1DImode:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 621; /* *vec_extractv1di_plus */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 622; /* *vec_extractv2di_plus */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1SFmode:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 623; /* *vec_extractv1sf_plus */

            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 624; /* *vec_extractv2sf_plus */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 625; /* *vec_extractv4sf_plus */

            default:
              return -1;
            }

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1DFmode:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 626; /* *vec_extractv1df_plus */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 627; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1317; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1320; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1323; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1326; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1329; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1332; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1335; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1338; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1341; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1344; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1404; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1411; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1347; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1405; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1412; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1350; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1406; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1413; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1353; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1407; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1414; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1356; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1408; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1415; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1TImode)
              && (
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1359; /* *vec_cmpgtv1tiv1ti_nocc */
        }
      operands[0] = x2;
      switch (pattern113 (x3))
        {
        case 0:
          if (!
#line 2278 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1366; /* *vec_cmpgtv1tiv1ti_nocc_emu */

        case 1:
          if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1409; /* *vec_cmpgtv1tf_signaling_nocc */
          if (!(
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1416; /* *vec_cmpgtv1tf_signaling_finite_nocc */

        default:
          return -1;
        }

    case 15:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_TImode)
              && (
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1362; /* *vec_cmpgttiti_nocc */
        }
      operands[0] = x2;
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2278 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1367; /* *vec_cmpgttiti_nocc_emu */

        case 1:
          if (
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1410; /* *vec_cmpgttf_signaling_nocc */
          if (!(
#line 2435 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1417; /* *vec_cmpgttf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1960; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1961; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1966; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1967; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1962; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1963; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1968; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1969; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1964; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4382 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1965; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1970; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4395 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1971; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 5170 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2048; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 5180 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2049; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4605 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1998; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4605 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1999; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4619 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 2000; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4619 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 2001; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 774; /* *absv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 775; /* *absv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 776; /* *absv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 777; /* *absv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 778; /* *absv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 779; /* *absv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 780; /* *absv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 781; /* *absv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 782; /* *absv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 783; /* *absv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 784; /* *absv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 785; /* *absv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 786; /* *absv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 787; /* *absv2di2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !(
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 788; /* *absv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !(
#line 1345 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 789; /* *absti2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1292; /* absv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1293; /* absv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1294; /* absv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1295; /* absv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1296; /* absv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1297; /* absv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 2114 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1298; /* abstf2_vr */
          if ((
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2487; /* *abstf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2493; /* *abstf2 */

        case E_DImode:
          if (pattern86 (x3, pnum_clobbers, 
E_DImode) != 0
              || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2477; /* absdi2 */

        case E_SImode:
          if (pattern86 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2478; /* abssi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2488; /* *absfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2494; /* *absfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2489; /* *absdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2495; /* *absdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2490; /* *abssf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2496; /* *abssf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2491; /* *abstd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9384 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2492; /* *absdd2_nocc */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern69 (x3, 
E_SImode) != 0
          || !
#line 9307 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2472; /* *absdi2_sign */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern173 (x3, 
E_V1QImode, 
E_QImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode)))
            return -1;
          return 630; /* *vec_splatv1qi */

        case E_V2QImode:
          if (pattern173 (x3, 
E_V2QImode, 
E_QImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode)))
            return -1;
          return 631; /* *vec_splatv2qi */

        case E_V4QImode:
          if (pattern173 (x3, 
E_V4QImode, 
E_QImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode)))
            return -1;
          return 632; /* *vec_splatv4qi */

        case E_V8QImode:
          if (pattern173 (x3, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode)))
            return -1;
          return 633; /* *vec_splatv8qi */

        case E_V16QImode:
          if (pattern173 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 634; /* *vec_splatv16qi */

        case E_V1HImode:
          if (pattern173 (x3, 
E_V1HImode, 
E_HImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode)))
            return -1;
          return 635; /* *vec_splatv1hi */

        case E_V2HImode:
          if (pattern173 (x3, 
E_V2HImode, 
E_HImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode)))
            return -1;
          return 636; /* *vec_splatv2hi */

        case E_V4HImode:
          if (pattern173 (x3, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode)))
            return -1;
          return 637; /* *vec_splatv4hi */

        case E_V8HImode:
          if (pattern173 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 638; /* *vec_splatv8hi */

        case E_V1SImode:
          if (pattern173 (x3, 
E_V1SImode, 
E_SImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode)))
            return -1;
          return 639; /* *vec_splatv1si */

        case E_V2SImode:
          if (pattern173 (x3, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode)))
            return -1;
          return 640; /* *vec_splatv2si */

        case E_V4SImode:
          if (pattern173 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 641; /* *vec_splatv4si */

        case E_V1DImode:
          if (pattern173 (x3, 
E_V1DImode, 
E_DImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode)))
            return -1;
          return 642; /* *vec_splatv1di */

        case E_V2DImode:
          if (pattern173 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 643; /* *vec_splatv2di */

        case E_V1SFmode:
          if (pattern173 (x3, 
E_V1SFmode, 
E_SFmode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode)))
            return -1;
          return 644; /* *vec_splatv1sf */

        case E_V2SFmode:
          if (pattern173 (x3, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode)))
            return -1;
          return 645; /* *vec_splatv2sf */

        case E_V4SFmode:
          if (pattern173 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 646; /* *vec_splatv4sf */

        case E_V1DFmode:
          if (pattern173 (x3, 
E_V1DFmode, 
E_DFmode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode)))
            return -1;
          return 647; /* *vec_splatv1df */

        case E_V2DFmode:
          if (pattern173 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 740 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 648; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 649; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 650; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 651; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 652; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 653; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 748 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 654; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 665; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 794 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 666; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 824 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 668; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern87 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 772 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 660; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern87 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 772 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 661; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern87 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 772 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 662; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern87 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 772 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 663; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern87 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 772 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 664; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 3092 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1553; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 3092 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 108 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1554; /* floatv4siv4sf2 */

    case E_TFmode:
      switch (pattern70 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2092; /* floatditf2_fpr */

        case 1:
          if (!(
#line 5649 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2098; /* floatsitf2_fpr */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern70 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2093; /* floatdifprx22 */

        case 1:
          if (!(
#line 5649 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2099; /* floatsifprx22 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern70 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2094; /* floatdidf2 */

        case 1:
          if (!
#line 5649 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2100; /* floatsidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern70 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2095; /* floatdisf2 */

        case 1:
          if (!
#line 5649 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2101; /* floatsisf2 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern70 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2096; /* floatditd2 */

        case 1:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2102; /* floatsitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern70 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5636 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2097; /* floatdidd2 */

        case 1:
          if (!
#line 5662 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2103; /* floatsidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern255 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 6129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2220; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 6142 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2221; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6268 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2229; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6308 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2233; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6268 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2230; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6308 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2234; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_TFmode) == 0
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2260; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2261; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_DFmode) == 0
                  && 
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2262; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_SFmode) == 0
                  && 
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2263; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_TDmode) == 0
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2264; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern227 (x6, 
E_DDmode) == 0
                  && (
#line 6529 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2265; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6326 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2235; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2241; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6326 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 2236; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 2242; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern149 (x1))
            {
            case 0:
              if (!(
#line 6348 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2237; /* *adddi3_cconly */

            case 1:
              if (!
#line 6348 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2238; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern285 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6449 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2244; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern285 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6449 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2245; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern286 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6472 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2246; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern286 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6472 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2247; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_81 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern239 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 7044 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2310; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 7078 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2314; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern239 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 7044 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2311; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 7078 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2315; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET
          || pattern215 (x9) != 0)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern279 (x1, 
E_DImode) != 0
              || !(
#line 7094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2316; /* *adddi3_alc_cc */

        case E_SImode:
          if (pattern279 (x1, 
E_SImode) != 0
              || !
#line 7094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 2317; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_107 (x1, insn, pnum_clobbers);

    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != EQ)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !(
#line 10005 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2559; /* *load_and_trapdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 10005 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return -1;
          return 2560; /* *load_and_trapsi */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern15 (x1) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 1);
      operands[0] = x9;
      x12 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10446 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2574; /* indirect_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10446 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2575; /* indirect_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[2] = x12;
          if (register_operand (operands[2], E_DImode)
              && larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10462 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2576; /* indirect_jump_via_inlinethunkdi */
          if (!register_operand (operands[2], E_SImode)
              || !larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10462 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2577; /* indirect_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (register_operand (operands[2], E_VOIDmode))
        {
          if (bras_sym_operand (operands[0], E_VOIDmode))
            {
              if (
#line 10872 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[2]) == Pmode))
                return 2595; /* *bras */
              if (
#line 10884 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[2]) == Pmode))
                return 2596; /* *brasl */
            }
          if (address_operand (operands[0], E_VOIDmode)
              && 
#line 10897 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[2]) == Pmode))
            return 2597; /* *basr */
        }
      if (register_operand (operands[2], E_DImode)
          && register_operand (operands[0], E_DImode))
        {
          if ((
#line 10920 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2598; /* *basr_via_thunkdi_z10 */
          if (pnum_clobbers != NULL
              && (
#line 10941 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2600; /* *basr_via_thunkdi */
            }
        }
      if (!register_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      if ((
#line 10920 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2599; /* *basr_via_thunksi_z10 */
      if (pnum_clobbers == NULL
          || !(
#line 10941 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2601; /* *basr_via_thunksi */

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if ((
#line 11851 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2647; /* *returndi */
          if (pnum_clobbers == NULL
              || !(
#line 11879 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2649; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          if ((
#line 11851 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return 2648; /* *returnsi */
          if (pnum_clobbers == NULL
              || !(
#line 11879 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2650; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3249 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1902; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3262 "../../gcc/config/s390/s390.md"
(reload_completed))
                return 1903; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3341 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1904; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3355 "../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1905; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3374 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1906; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3386 "../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1907; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern104 (x2))
    {
    case 0:
      if (all_ones_operand (operands[1], E_V1QImode)
          && const0_operand (operands[2], E_V1QImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_98 (insn, operands);
      if (!const0_operand (operands[1], E_V1QImode)
          || !all_ones_operand (operands[2], E_V1QImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_117 (insn, operands);

    case 1:
      if (all_ones_operand (operands[1], E_V2QImode)
          && const0_operand (operands[2], E_V2QImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_99 (insn, operands);
      if (!const0_operand (operands[1], E_V2QImode)
          || !all_ones_operand (operands[2], E_V2QImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_118 (insn, operands);

    case 2:
      if (all_ones_operand (operands[1], E_V4QImode)
          && const0_operand (operands[2], E_V4QImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_100 (insn, operands);
      if (!const0_operand (operands[1], E_V4QImode)
          || !all_ones_operand (operands[2], E_V4QImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_119 (insn, operands);

    case 3:
      if (all_ones_operand (operands[1], E_V8QImode)
          && const0_operand (operands[2], E_V8QImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_101 (insn, operands);
      if (!const0_operand (operands[1], E_V8QImode)
          || !all_ones_operand (operands[2], E_V8QImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_120 (insn, operands);

    case 4:
      if (all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_102 (insn, operands);
      if (!const0_operand (operands[1], E_V16QImode)
          || !all_ones_operand (operands[2], E_V16QImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_121 (insn, operands);

    case 5:
      if (all_ones_operand (operands[1], E_V1HImode)
          && const0_operand (operands[2], E_V1HImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_103 (insn, operands);
      if (!const0_operand (operands[1], E_V1HImode)
          || !all_ones_operand (operands[2], E_V1HImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_122 (insn, operands);

    case 6:
      if (all_ones_operand (operands[1], E_V2HImode)
          && const0_operand (operands[2], E_V2HImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_104 (insn, operands);
      if (!const0_operand (operands[1], E_V2HImode)
          || !all_ones_operand (operands[2], E_V2HImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_123 (insn, operands);

    case 7:
      if (all_ones_operand (operands[1], E_V4HImode)
          && const0_operand (operands[2], E_V4HImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_105 (insn, operands);
      if (!const0_operand (operands[1], E_V4HImode)
          || !all_ones_operand (operands[2], E_V4HImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_124 (insn, operands);

    case 8:
      if (all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_106 (insn, operands);
      if (!const0_operand (operands[1], E_V8HImode)
          || !all_ones_operand (operands[2], E_V8HImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_125 (insn, operands);

    case 9:
      if (all_ones_operand (operands[1], E_V1SImode)
          && const0_operand (operands[2], E_V1SImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_107 (insn, operands);
      if (!const0_operand (operands[1], E_V1SImode)
          || !all_ones_operand (operands[2], E_V1SImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_126 (insn, operands);

    case 10:
      if (all_ones_operand (operands[1], E_V2SImode)
          && const0_operand (operands[2], E_V2SImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_108 (insn, operands);
      if (!const0_operand (operands[1], E_V2SImode)
          || !all_ones_operand (operands[2], E_V2SImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_127 (insn, operands);

    case 11:
      if (all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_109 (insn, operands);
      if (!const0_operand (operands[1], E_V4SImode)
          || !all_ones_operand (operands[2], E_V4SImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_128 (insn, operands);

    case 12:
      if (all_ones_operand (operands[1], E_V1DImode)
          && const0_operand (operands[2], E_V1DImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_110 (insn, operands);
      if (!const0_operand (operands[1], E_V1DImode)
          || !all_ones_operand (operands[2], E_V1DImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_129 (insn, operands);

    case 13:
      if (all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_111 (insn, operands);
      if (!const0_operand (operands[1], E_V2DImode)
          || !all_ones_operand (operands[2], E_V2DImode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_130 (insn, operands);

    case 14:
      if (all_ones_operand (operands[1], E_V1SFmode)
          && const0_operand (operands[2], E_V1SFmode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_112 (insn, operands);
      if (!const0_operand (operands[1], E_V1SFmode)
          || !all_ones_operand (operands[2], E_V1SFmode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_131 (insn, operands);

    case 15:
      if (all_ones_operand (operands[1], E_V2SFmode)
          && const0_operand (operands[2], E_V2SFmode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_113 (insn, operands);
      if (!const0_operand (operands[1], E_V2SFmode)
          || !all_ones_operand (operands[2], E_V2SFmode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_132 (insn, operands);

    case 16:
      if (all_ones_operand (operands[1], E_V4SFmode)
          && const0_operand (operands[2], E_V4SFmode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_114 (insn, operands);
      if (!const0_operand (operands[1], E_V4SFmode)
          || !all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_133 (insn, operands);

    case 17:
      if (all_ones_operand (operands[1], E_V1DFmode)
          && const0_operand (operands[2], E_V1DFmode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_115 (insn, operands);
      if (!const0_operand (operands[1], E_V1DFmode)
          || !all_ones_operand (operands[2], E_V1DFmode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_134 (insn, operands);

    case 18:
      if (all_ones_operand (operands[1], E_V2DFmode)
          && const0_operand (operands[2], E_V2DFmode)
          && 
#line 2676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_116 (insn, operands);
      if (!const0_operand (operands[1], E_V2DFmode)
          || !all_ones_operand (operands[2], E_V2DFmode)
          || !
#line 2690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_135 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_TFmode))
        {
          if (GET_CODE (x2) == SUBREG
              && known_eq (SUBREG_BYTE (x2), 0)
              && GET_MODE (x2) == E_TFmode)
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (general_operand (operands[1], E_FPRX2mode)
                  && 
#line 810 "../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                return gen_split_41 (insn, operands);
            }
          operands[1] = x2;
          if (general_operand (operands[1], E_TFmode))
            {
              if ((
#line 2832 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_303 (insn, operands);
              if ((
#line 2848 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_306 (insn, operands);
            }
        }
      operands[1] = x2;
      if (memory_operand (operands[1], E_TFmode)
          && register_operand (operands[0], E_TFmode))
        {
          if ((
#line 2864 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_309 (insn, operands);
          if ((
#line 2880 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_312 (insn, operands);
        }
      if (!register_operand (operands[1], E_TFmode)
          || !memory_operand (operands[0], E_TFmode)
          || !(
#line 2896 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 767 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return NULL;
      return gen_split_315 (insn, operands);

    case UNSPEC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 3:
          if (XINT (x2, 1) != 89
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[0], E_V2DFmode))
            return NULL;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DFmode))
            return NULL;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!register_operand (operands[3], E_V2DFmode)
              || !
#line 580 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))
   && reload_completed
   && VECTOR_REGNO_P (REGNO (operands[1]))))
            return NULL;
          return gen_split_37 (insn, operands);

        case 1:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          switch (XINT (x2, 1))
            {
            case 30:
              switch (pattern83 (x2))
                {
                case 0:
                  if (!
#line 2174 "../../gcc/config/s390/s390.md"
( reload_completed))
                    return NULL;
                  return gen_split_294 (insn, operands);

                case 1:
                  if (!(
#line 2181 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 2183 "../../gcc/config/s390/s390.md"
( reload_completed)))
                    return NULL;
                  return gen_split_295 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              if (GET_MODE (x2) != E_SImode
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 3795 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_329 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case VEC_SELECT:
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x9 = XVECEXP (x8, 0, 0);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 677 "../../gcc/config/s390/vector.md"
(TARGET_VX && reload_completed && VECTOR_REGNO_P (REGNO (operands[0]))))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 677 "../../gcc/config/s390/vector.md"
(TARGET_VX && reload_completed && VECTOR_REGNO_P (REGNO (operands[0]))))
                return NULL;
              return gen_split_39 (insn, operands);

            default:
              return NULL;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 677 "../../gcc/config/s390/vector.md"
(TARGET_VX && reload_completed && VECTOR_REGNO_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_40 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_43 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_44 (insn, operands);

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_45 (insn, operands);

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_46 (insn, operands);

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 841 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_47 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      if (pattern8 (x1) != 0
          || !(
#line 2152 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2154 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_52 (insn, operands);

    case SMIN:
      if (pattern8 (x1) != 0
          || !(
#line 2188 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2190 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_53 (insn, operands);

    case IF_THEN_ELSE:
      return split_3 (x1, insn);

    case AND:
      switch (pattern10 (x1))
        {
        case 0:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_145 (insn, operands);

        case 1:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_154 (insn, operands);

        case 2:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_163 (insn, operands);

        case 3:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 5:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 6:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 7:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 8:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 9:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 10:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 11:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 12:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 13:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_262 (insn, operands);

        case 14:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_271 (insn, operands);

        case 15:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_280 (insn, operands);

        case 16:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 17:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 18:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_164 (insn, operands);

        case 19:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_173 (insn, operands);

        case 20:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 21:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 22:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 23:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 24:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 25:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 26:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 27:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 28:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 29:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_263 (insn, operands);

        case 30:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 31:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_281 (insn, operands);

        case 32:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_147 (insn, operands);

        case 33:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 34:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_165 (insn, operands);

        case 35:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_174 (insn, operands);

        case 36:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_183 (insn, operands);

        case 37:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 38:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 39:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 40:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 41:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_228 (insn, operands);

        case 42:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_237 (insn, operands);

        case 43:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_246 (insn, operands);

        case 44:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_255 (insn, operands);

        case 45:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_264 (insn, operands);

        case 46:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_273 (insn, operands);

        case 47:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_282 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      return split_4 (x1, insn);

    case XOR:
      return split_5 (x1, insn);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_VOIDmode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      if (!memory_operand (operands[1], E_VOIDmode)
          || !
#line 1512 "../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
        return NULL;
      return gen_split_289 (insn, operands);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 5312 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5314 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_356 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !(
#line 5344 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5346 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_357 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2256 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2258 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_54 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2256 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2258 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_55 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GT:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2278 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2280 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_56 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2278 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2280 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_57 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2312 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2314 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_58 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2312 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2314 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_59 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern48 (x2))
        {
        case 0:
          if (!(
#line 7292 "../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_367 (insn, operands);

        case 1:
          if (!
#line 7292 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 798 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return NULL;
          return gen_split_379 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          return gen_split_380 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_381 (insn, operands);

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return NULL;
          return gen_split_382 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 28)
        return NULL;
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 11942 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_396 (insn, operands);

        case 1:
          if (!
#line 11950 "../../gcc/config/s390/s390.md"
( reload_completed))
            return NULL;
          return gen_split_397 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_HImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return NULL;
      return gen_split_398 (insn, operands);

    default:
      return NULL;
    }
}
