/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern0 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern27 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[2] = x11;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_TImode
      || !register_operand (operands[0], E_TImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern20 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern20 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern20 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern20 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern20 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern20 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern20 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern20 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern20 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern20 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern79 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern79 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern80 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern80 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1, machine_mode i1, int i2, rtx_code i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i4
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1
      || GET_MODE (x3) != i2)
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  x8 = XVECEXP (x6, 0, 0);
  operands[3] = x8;
  if (!const_mask_operand (operands[3], E_QImode)
      || !address_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 1);
  x11 = XVECEXP (x10, 0, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  return 0;
}

int
pattern177 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i2)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_DImode:
          return 1;

        case E_SImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !loc_operand (operands[3], i1)
      || !loc_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern284 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern26 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1921; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1922; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1923; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1924; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1925; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1926; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3808 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 753 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1927; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern187 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2166 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 491; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern187 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2166 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 492; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern187 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2166 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 493; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern187 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2166 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 494; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern187 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2166 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 495; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern201 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 553; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern201 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 554; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern201 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 555; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern201 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 556; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern201 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 557; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern201 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 558; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern201 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 559; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern201 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 560; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern201 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 561; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern201 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 562; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern201 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 563; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern201 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 564; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern201 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 565; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern201 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 566; /* *vec_setv2di */

            case E_V2SFmode:
              if (pattern201 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 567; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern201 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 536 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 568; /* *vec_setv4sf */

            case E_V1SFmode:
              if (pattern201 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 552 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 569; /* *vec_setv1sf */

            case E_V1DFmode:
              if (pattern201 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 552 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 570; /* *vec_setv1df */

            case E_V1TFmode:
              if (pattern201 (x2, 
E_V1TFmode, 
E_TFmode) != 0
                  || !(
#line 552 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 522 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 571; /* *vec_setv1tf */

            case E_V2DFmode:
              if (pattern201 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 564 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 572; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern201 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 573; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern201 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 574; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern201 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 575; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern201 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 576; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern201 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 577; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern201 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 578; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern201 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 579; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern201 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 580; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern201 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 581; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern201 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 582; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern201 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 583; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern201 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 584; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern201 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 585; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern201 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 586; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern201 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 587; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern201 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 588; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern201 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 589; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern201 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 590; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern201 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 609 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 591; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return recog_27 (x1, insn, pnum_clobbers);

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern209 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1463; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1501; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern209 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1464; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern209 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1465; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1503; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern209 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1466; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern209 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1467; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1505; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern209 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1468; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern209 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1469; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1507; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern209 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1470; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern209 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1471; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1509; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern209 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1472; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern209 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1473; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1511; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern209 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1474; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1512; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern209 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1475; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern209 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1476; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern210 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1477; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1515; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern210 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1478; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1516; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern210 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1479; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern210 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1480; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern210 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2716 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1481; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2740 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1519; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4864 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 786 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2028; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4864 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 786 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 2029; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern67 (x3, 
E_V1QImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 706; /* addv1qi3 */

        case E_V2QImode:
          if (pattern67 (x3, 
E_V2QImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 707; /* addv2qi3 */

        case E_V4QImode:
          if (pattern67 (x3, 
E_V4QImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 708; /* addv4qi3 */

        case E_V8QImode:
          if (pattern67 (x3, 
E_V8QImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 709; /* addv8qi3 */

        case E_V16QImode:
          if (pattern67 (x3, 
E_V16QImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 710; /* addv16qi3 */

        case E_V1HImode:
          if (pattern67 (x3, 
E_V1HImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 711; /* addv1hi3 */

        case E_V2HImode:
          if (pattern67 (x3, 
E_V2HImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 712; /* addv2hi3 */

        case E_V4HImode:
          if (pattern67 (x3, 
E_V4HImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 713; /* addv4hi3 */

        case E_V8HImode:
          if (pattern67 (x3, 
E_V8HImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 714; /* addv8hi3 */

        case E_V1SImode:
          if (pattern67 (x3, 
E_V1SImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 715; /* addv1si3 */

        case E_V2SImode:
          if (pattern67 (x3, 
E_V2SImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 716; /* addv2si3 */

        case E_V4SImode:
          if (pattern67 (x3, 
E_V4SImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 717; /* addv4si3 */

        case E_V1DImode:
          if (pattern67 (x3, 
E_V1DImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 718; /* addv1di3 */

        case E_V2DImode:
          if (pattern67 (x3, 
E_V2DImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 719; /* addv2di3 */

        case E_V1TImode:
          if (pattern67 (x3, 
E_V1TImode) != 0
              || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 720; /* addv1ti3 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || !nonimmediate_operand (operands[1], E_TImode)
              || !general_operand (operands[2], E_TImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 721; /* *addti3 */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 6075 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2218; /* *addti3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1981 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1249; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1981 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1250; /* addv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1981 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1251; /* addv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1981 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1252; /* addtf3_vr */
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2248; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pnum_clobbers == NULL
              || pattern178 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2249; /* addfprx23 */

        case E_DFmode:
          if (pnum_clobbers == NULL
              || pattern178 (x3, 
E_DFmode) != 0
              || !
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2250; /* adddf3 */

        case E_SFmode:
          if (pnum_clobbers == NULL
              || pattern178 (x3, 
E_SFmode) != 0
              || !
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2251; /* addsf3 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || pattern178 (x3, 
E_TDmode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2252; /* addtd3 */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || pattern178 (x3, 
E_DDmode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2253; /* adddd3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!register_operand (x5, E_DImode))
        return -1;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2089 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1848; /* *lxah_index_base */

            case 2L:
              if (!
#line 2089 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1849; /* *lxaf_index_base */

            case 3L:
              if (!
#line 2089 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1850; /* *lxag_index_base */

            case 4L:
              if (!
#line 2089 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1851; /* *lxaq_index_base */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2100 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1852; /* *lxah_displacement_index_base */

            case 2L:
              if (!
#line 2100 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1853; /* *lxaf_displacement_index_base */

            case 3L:
              if (!
#line 2100 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1854; /* *lxag_displacement_index_base */

            case 4L:
              if (!
#line 2100 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1855; /* *lxaq_displacement_index_base */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern115 (x3) != 0
          || !
#line 2109 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1856; /* *lxab_displacement_index_base */

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (register_operand (operands[1], E_DImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_DImode))
            {
              switch (pattern272 (x4))
                {
                case 0:
                  if (
#line 2137 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1861; /* *llxah_index_base */
                  break;

                case 1:
                  if (
#line 2137 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1862; /* *llxaf_index_base */
                  break;

                case 2:
                  if (
#line 2137 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1863; /* *llxag_index_base */
                  break;

                case 3:
                  if (
#line 2137 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1864; /* *llxaq_index_base */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 0)
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      switch (pattern272 (x4))
        {
        case 0:
          if (!
#line 2150 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1865; /* *llxah_displacement_index_base */

        case 1:
          if (!
#line 2150 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1866; /* *llxaf_displacement_index_base */

        case 2:
          if (!
#line 2150 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1867; /* *llxag_displacement_index_base */

        case 3:
          if (!
#line 2150 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1868; /* *llxaq_displacement_index_base */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern115 (x3) != 0
          || !
#line 2159 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1869; /* *llxab_displacement_index_base */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 1012; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1081; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 1016; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1082; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 1020; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1083; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 1024; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1084; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 1028; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1085; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 1032; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1086; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 1036; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1087; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 1040; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1088; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 1044; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1089; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 1048; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1090; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 1052; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1091; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 1056; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1092; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 1060; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1093; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 1064; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1685 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1094; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern11 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9737 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2538; /* *ashrdi3_31 */
        }
      if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2541; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern11 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2544; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern12 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 1013; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1095; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 1017; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1096; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 1021; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1097; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1025; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1098; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1029; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1099; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1033; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1100; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1037; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1101; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1041; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1102; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1045; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1103; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1049; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1104; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1053; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1105; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1057; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1106; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1061; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1107; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1065; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1108; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9696 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2533; /* *lshrdi3_31 */
          if (
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2535; /* *lshrdi3 */
          break;

        case 15:
          return 2537; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4885 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 2030; /* *insvdi_mem_reghigh */
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_29 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_30 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!s390_comparison (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      operands[2] = x4;
      if (cc_reg_operand (operands[2], E_VOIDmode))
        {
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (REGNO (x4) != 33)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) == PC)
            {
              operands[1] = x3;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      return 2547; /* *cjump_64 */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      return 2551; /* *icjump_64 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          operands[0] = x7;
          if (!address_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[1] = x3;
          if (!
#line 9828 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2548; /* *cjump_long */

        case RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9851 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
            return -1;
          return 2549; /* *creturn */

        case SIMPLE_RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9851 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
            return -1;
          return 2550; /* *csimple_return */

        case PC:
          operands[1] = x3;
          x8 = XEXP (x2, 2);
          operands[0] = x8;
          if (!address_operand (operands[0], E_VOIDmode)
              || !
#line 9905 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2552; /* *icjump_long */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 3250 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1585; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5745 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2121; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5722 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2119; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5722 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2120; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern41 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2592 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1879; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_91 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_92 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_93 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern124 (x3, 
E_DImode) != 0
              || !
#line 7964 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2370; /* *anddi3 */

        case E_SImode:
          if (pattern124 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 8093 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2381; /* *andsi3_zarch */
          if (!
#line 8127 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2382; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern41 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4407 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1973; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern92 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4853 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 2027; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x3, 
E_DImode) != 0
                  || !(
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2372; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern248 (x3, 
E_SImode) != 0
                  || !
#line 8014 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2374; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern42 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern248 (x3, 
E_DImode) != 0
              || !(
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2376; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern248 (x3, 
E_SImode) != 0
              || !
#line 8028 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2378; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern42 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2387; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2409; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8236 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2388; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2411; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern218 (x3))
            {
            case 0:
              if (!(
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2421; /* *nordi */

            case 1:
              if (!
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2423; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern96 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern252 (x4, 
E_DImode) != 0
                  || !(
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2003; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern252 (x4, 
E_SImode) != 0
                  || !
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2005; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4703 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2007; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2009; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2011; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2013; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2015; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern99 (x1))
        {
        case 0:
          if (!(
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2017; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2019; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern99 (x1))
        {
        case 0:
          if (!(
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2021; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2023; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern122 (x1) == 0
          && 
#line 4795 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 2025; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern123 (x1) == 0
          && 
#line 8951 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2436; /* *xc */
        }
      operands[1] = x5;
      switch (pattern125 (x1))
        {
        case 0:
          if (!
#line 8795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2430; /* *xordi3 */

        case 1:
          if (!
#line 8865 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2433; /* *xorsi3 */

        case 2:
          if (!
#line 8898 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2434; /* *xorhi3 */

        case 3:
          if (!
#line 8928 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2435; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern101 (x4) != 0)
            return -1;
          switch (pattern260 (x1))
            {
            case 0:
              if (!(
#line 3701 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1916; /* *cpymem_long */

            case 1:
              if (!(
#line 3701 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1917; /* *cpymem_long */

            case 2:
              if (!
#line 3714 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1918; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern298 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4154 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1938; /* *cmpmem_long */

                case E_DImode:
                  if (pattern298 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4154 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1939; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4167 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1940; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern106 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3852 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1928; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3852 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1929; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern82 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern274 (x1))
            {
            case 0:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2691; /* split_stack_calldi */

            case 1:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2692; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern82 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern274 (x1))
            {
            case 0:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2693; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2694; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern30 (x3))
        {
        case 0:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_148 (insn, operands);

        case 1:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 2:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_166 (insn, operands);

        case 3:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_175 (insn, operands);

        case 4:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_184 (insn, operands);

        case 5:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        case 6:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 7:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_211 (insn, operands);

        case 8:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_220 (insn, operands);

        case 9:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_229 (insn, operands);

        case 10:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 11:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_247 (insn, operands);

        case 12:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_256 (insn, operands);

        case 13:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_265 (insn, operands);

        case 14:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_274 (insn, operands);

        case 15:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_283 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_149 (insn, operands);

        case 1:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 2:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_167 (insn, operands);

        case 3:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 4:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_185 (insn, operands);

        case 5:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 6:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 7:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 8:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_221 (insn, operands);

        case 9:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_230 (insn, operands);

        case 10:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_239 (insn, operands);

        case 11:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_248 (insn, operands);

        case 12:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_257 (insn, operands);

        case 13:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_266 (insn, operands);

        case 14:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_275 (insn, operands);

        case 15:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_284 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_150 (insn, operands);

        case 1:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_159 (insn, operands);

        case 2:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 3:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 4:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_186 (insn, operands);

        case 5:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 6:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 7:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 8:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 9:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 10:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 11:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 12:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_258 (insn, operands);

        case 13:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_267 (insn, operands);

        case 14:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_276 (insn, operands);

        case 15:
          if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_285 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern185 (x3, 
E_DImode) != 0
              || !(
#line 4634 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_346 (insn, operands);

        case E_SImode:
          if (pattern185 (x3, 
E_SImode) != 0
              || !
#line 4634 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_347 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern199 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3145 "../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
