/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 14;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 15;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 16;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 17;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 18;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 19;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 20;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 21;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 22;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 4;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 5;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 6;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 7;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern94 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern94 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern170 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern287 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern26 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1242 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 396; /* vec_fpintv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 397; /* vec_fpintv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 398; /* vec_fpintv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 399; /* vec_fpintv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 400; /* vec_fpintv2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 401; /* vec_fpintv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 1841 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 402; /* vec_fpinttf */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1274 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1785; /* *cmpdi_cct */
              if ((
#line 1362 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1792; /* *cmpdi_ccs */
              if (
#line 1427 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1798; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6872 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2285; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1288 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1786; /* *cmpsi_cct */
              if (
#line 1362 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1793; /* *cmpsi_ccs */
              if (
#line 1446 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1799; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6872 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2286; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1466 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1800; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1482 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1801; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1815; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1603 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1821; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1822; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1629 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1828; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1816; /* *cmpfprx2_ccs */
          if (!(
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1823; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1817; /* *cmpdf_ccs */
          if (!
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1824; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1818; /* *cmpsf_ccs */
          if (!
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1825; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1819; /* *cmptd_ccs */
          if (!(
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1826; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1588 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1820; /* *cmpdd_ccs */
          if (!(
#line 1614 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1827; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2239; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6364 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2240; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 6689 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2269; /* *subdi3_zero_cconly */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (pattern190 (x3))
            {
            case 0:
              if (!(
#line 6803 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2277; /* *subdi3_borrow_cconly */

            case 1:
              if (!
#line 6803 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                return -1;
              *pnum_clobbers = 1;
              return 2278; /* *subsi3_borrow_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern190 (x3))
                {
                case 0:
                  if ((
#line 6855 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2283; /* *subdi3_cconly */
                    }
                  break;

                case 1:
                  if (
#line 6855 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2284; /* *subsi3_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[3] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (!nonimmediate_operand (operands[1], E_TFmode)
                  || !general_operand (operands[2], E_TFmode)
                  || !const0_operand (operands[3], E_TFmode)
                  || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2302; /* *subtf3_cconly */

            case E_FPRX2mode:
              if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                  || !general_operand (operands[2], E_FPRX2mode)
                  || !const0_operand (operands[3], E_FPRX2mode)
                  || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2303; /* *subfprx23_cconly */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !general_operand (operands[2], E_DFmode)
                  || !const0_operand (operands[3], E_DFmode)
                  || !
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2304; /* *subdf3_cconly */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !general_operand (operands[2], E_SFmode)
                  || !const0_operand (operands[3], E_SFmode)
                  || !
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2305; /* *subsf3_cconly */

            case E_TDmode:
              if (!nonimmediate_operand (operands[1], E_TDmode)
                  || !general_operand (operands[2], E_TDmode)
                  || !const0_operand (operands[3], E_TDmode)
                  || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              *pnum_clobbers = 1;
              return 2306; /* *subtd3_cconly */

            case E_DDmode:
              if (!nonimmediate_operand (operands[1], E_DDmode)
                  || !general_operand (operands[2], E_DDmode)
                  || !const0_operand (operands[3], E_DDmode)
                  || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              *pnum_clobbers = 1;
              return 2307; /* *subdd3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4323 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1948; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4323 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1949; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4323 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1950; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4323 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1951; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 4370 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return 1958; /* *extract1bitdi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4370 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return -1;
      *pnum_clobbers = 1;
      return 1959; /* *extract1bitdi_clobbercc */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 2330; /* sne */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern177 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern177 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern177 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern177 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 121; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern177 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 122; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern177 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern177 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern177 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 125; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern177 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 126; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern0 (x2, 
E_V1QImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 794; /* andv1qi3 */

            case E_V2QImode:
              if (pattern0 (x2, 
E_V2QImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 795; /* andv2qi3 */

            case E_V4QImode:
              if (pattern0 (x2, 
E_V4QImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 796; /* andv4qi3 */

            case E_V8QImode:
              if (pattern0 (x2, 
E_V8QImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 797; /* andv8qi3 */

            case E_V16QImode:
              if (pattern0 (x2, 
E_V16QImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 798; /* andv16qi3 */

            case E_V1HImode:
              if (pattern0 (x2, 
E_V1HImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 799; /* andv1hi3 */

            case E_V2HImode:
              if (pattern0 (x2, 
E_V2HImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 800; /* andv2hi3 */

            case E_V4HImode:
              if (pattern0 (x2, 
E_V4HImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 801; /* andv4hi3 */

            case E_V8HImode:
              if (pattern0 (x2, 
E_V8HImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 802; /* andv8hi3 */

            case E_V1SImode:
              if (pattern0 (x2, 
E_V1SImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 803; /* andv1si3 */

            case E_V2SImode:
              if (pattern0 (x2, 
E_V2SImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 804; /* andv2si3 */

            case E_V4SImode:
              if (pattern0 (x2, 
E_V4SImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 805; /* andv4si3 */

            case E_V1DImode:
              if (pattern0 (x2, 
E_V1DImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 806; /* andv1di3 */

            case E_V2DImode:
              if (pattern0 (x2, 
E_V2DImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 807; /* andv2di3 */

            case E_V1SFmode:
              if (pattern0 (x2, 
E_V1SFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 808; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern0 (x2, 
E_V2SFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 809; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern0 (x2, 
E_V4SFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 810; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern0 (x2, 
E_V1DFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 811; /* andv1df3 */

            case E_V2DFmode:
              if (pattern0 (x2, 
E_V2DFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 812; /* andv2df3 */

            case E_V1TFmode:
              if (pattern0 (x2, 
E_V1TFmode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 813; /* andv1tf3 */

            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 814; /* andv1ti3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0
                  || !
#line 1384 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 815; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern67 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 8156 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2383; /* *andhi3_zarch */
                }
              if (!
#line 8173 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2384; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern67 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 8201 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2385; /* *andqi3_zarch */
                }
              if (!
#line 8218 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2386; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern144 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4836 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 2026; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern224 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1397; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern224 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1398; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern224 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1399; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern224 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1400; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern224 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1401; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (pattern224 (x2, 
E_V1TImode, 
E_V1TFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1402; /* *vec_cmpeqv1tf_signaling_nocc */

        case E_TImode:
          if (pattern224 (x2, 
E_TImode, 
E_TFmode) != 0
              || !
#line 2418 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1403; /* *vec_cmpeqtf_signaling_nocc */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern30 (x2))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1601; /* *vevalv1qi_andand */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1610; /* *vevalv2qi_andand */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1619; /* *vevalv4qi_andand */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1628; /* *vevalv8qi_andand */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1637; /* *vevalv16qi_andand */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1646; /* *vevalv1hi_andand */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1655; /* *vevalv2hi_andand */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1664; /* *vevalv4hi_andand */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1673; /* *vevalv8hi_andand */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1682; /* *vevalv1si_andand */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1691; /* *vevalv2si_andand */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1700; /* *vevalv4si_andand */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1709; /* *vevalv1di_andand */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1718; /* *vevalv2di_andand */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1727; /* *vevalv1ti_andand */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1736; /* *vevalti_andand */

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern30 (x2))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1602; /* *vevalv1qi_andior */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1611; /* *vevalv2qi_andior */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1620; /* *vevalv4qi_andior */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1629; /* *vevalv8qi_andior */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1638; /* *vevalv16qi_andior */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1647; /* *vevalv1hi_andior */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1656; /* *vevalv2hi_andior */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1665; /* *vevalv4hi_andior */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1674; /* *vevalv8hi_andior */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1683; /* *vevalv1si_andior */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1692; /* *vevalv2si_andior */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1701; /* *vevalv4si_andior */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1710; /* *vevalv1di_andior */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1719; /* *vevalv2di_andior */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1728; /* *vevalv1ti_andior */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1737; /* *vevalti_andior */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern30 (x2))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1603; /* *vevalv1qi_andxor */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1612; /* *vevalv2qi_andxor */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1621; /* *vevalv4qi_andxor */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1630; /* *vevalv8qi_andxor */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1639; /* *vevalv16qi_andxor */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1648; /* *vevalv1hi_andxor */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1657; /* *vevalv2hi_andxor */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1666; /* *vevalv4hi_andxor */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1675; /* *vevalv8hi_andxor */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1684; /* *vevalv1si_andxor */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1693; /* *vevalv2si_andxor */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1702; /* *vevalv4si_andxor */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1711; /* *vevalv1di_andxor */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1720; /* *vevalv2di_andxor */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1729; /* *vevalv1ti_andxor */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1738; /* *vevalti_andxor */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x6, 0) != 8589934590L
              || !
#line 2126 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1857; /* *llxah_displacement_index */

        case 2L:
          if (XWINT (x6, 0) != 17179869180L
              || !
#line 2126 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1858; /* *llxaf_displacement_index */

        case 3L:
          if (XWINT (x6, 0) != 34359738360L
              || !
#line 2126 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1859; /* *llxag_displacement_index */

        case 4L:
          if (XWINT (x6, 0) != 68719476720L
              || !
#line 2126 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1860; /* *llxaq_displacement_index */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern144 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4853 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 2027; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 58:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern20 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern20 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern200 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern200 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 93:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1035 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1035 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1035 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 1035 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 128:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1256 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1267 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 115:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 1539 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 1539 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 1539 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 130:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern54 (x2, 
E_V1QImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1745; /* vevalv1qi */

            case E_V2QImode:
              if (pattern54 (x2, 
E_V2QImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1746; /* vevalv2qi */

            case E_V4QImode:
              if (pattern54 (x2, 
E_V4QImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1747; /* vevalv4qi */

            case E_V8QImode:
              if (pattern54 (x2, 
E_V8QImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1748; /* vevalv8qi */

            case E_V16QImode:
              if (pattern54 (x2, 
E_V16QImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1749; /* vevalv16qi */

            case E_V1HImode:
              if (pattern54 (x2, 
E_V1HImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1750; /* vevalv1hi */

            case E_V2HImode:
              if (pattern54 (x2, 
E_V2HImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1751; /* vevalv2hi */

            case E_V4HImode:
              if (pattern54 (x2, 
E_V4HImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1752; /* vevalv4hi */

            case E_V8HImode:
              if (pattern54 (x2, 
E_V8HImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1753; /* vevalv8hi */

            case E_V1SImode:
              if (pattern54 (x2, 
E_V1SImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1754; /* vevalv1si */

            case E_V2SImode:
              if (pattern54 (x2, 
E_V2SImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1755; /* vevalv2si */

            case E_V4SImode:
              if (pattern54 (x2, 
E_V4SImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1756; /* vevalv4si */

            case E_V1DImode:
              if (pattern54 (x2, 
E_V1DImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1757; /* vevalv1di */

            case E_V2DImode:
              if (pattern54 (x2, 
E_V2DImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1758; /* vevalv2di */

            case E_V1TImode:
              if (pattern54 (x2, 
E_V1TImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1759; /* vevalv1ti */

            case E_TImode:
              if (pattern54 (x2, 
E_TImode) != 0
                  || !
#line 3571 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1760; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern253 (x2, 
E_DImode) != 0
                  || !
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1908; /* *strlendi */

            case E_SImode:
              if (pattern253 (x2, 
E_SImode) != 0
                  || !
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1909; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_15 (x1, insn, pnum_clobbers);

    case 2:
      return recog_14 (x1, insn, pnum_clobbers);

    case 3:
      return recog_16 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0
          || !
#line 1283 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 744; /* divv4si3 */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0
          || !
#line 1283 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 745; /* divv2di3 */

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0
          || !
#line 1283 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 746; /* divv1ti3 */

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0
          || !
#line 1283 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 747; /* divti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 2029 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1261; /* divv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 2029 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1262; /* divv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 2029 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1263; /* divv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 2029 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1264; /* divtf3_vr */
      if (!general_operand (operands[2], E_TFmode)
          || !(
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2362; /* divtf3_fpr */

    case E_FPRX2mode:
      if (pattern88 (x3, 
E_FPRX2mode) != 0
          || !(
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2363; /* divfprx23 */

    case E_DFmode:
      if (pattern88 (x3, 
E_DFmode) != 0
          || !
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2364; /* divdf3 */

    case E_SFmode:
      if (pattern88 (x3, 
E_SFmode) != 0
          || !
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2365; /* divsf3 */

    case E_TDmode:
      if (pattern88 (x3, 
E_TDmode) != 0
          || !(
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2366; /* divtd3 */

    case E_DDmode:
      if (pattern88 (x3, 
E_DDmode) != 0
          || !(
#line 7888 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2367; /* divdd3 */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) == E_CCL1mode)
    {
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) == E_CCL1mode)
        {
          x10 = XEXP (x9, 1);
          if (rtx_equal_p (x10, operands[1]))
            {
              x11 = XEXP (x9, 0);
              switch (GET_MODE (x11))
                {
                case E_DImode:
                  if (pattern277 (x3, 
E_DImode) == 0
                      && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2227; /* adddi3_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern277 (x3, 
E_SImode) == 0)
                    return 2228; /* addsi3_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x9 = XEXP (x7, 1);
  x11 = XEXP (x9, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      if (pattern256 (x1, 
E_DImode) != 0
          || !(
#line 6286 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2231; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern256 (x1, 
E_SImode) != 0
          || !
#line 6286 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2232; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern257 (x1, 
E_TFmode) != 0
          || !(
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2254; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern257 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2255; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern257 (x1, 
E_DFmode) != 0
          || !
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2256; /* *adddf3_cc */

    case E_SFmode:
      if (pattern257 (x1, 
E_SFmode) != 0
          || !
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2257; /* *addsf3_cc */

    case E_TDmode:
      if (pattern257 (x1, 
E_TDmode) != 0
          || !(
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2258; /* *addtd3_cc */

    case E_DDmode:
      if (pattern257 (x1, 
E_DDmode) != 0
          || !(
#line 6513 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2259; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern92 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4836 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 2026; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 8268 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2389; /* *nc */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern41 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern216 (x3, 
E_TImode) != 0
              || !
#line 6075 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2218; /* *addti3 */

        case E_DImode:
          if (pattern124 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 6166 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2223; /* *adddi3_31z */
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2225; /* *adddi3 */

        case E_SImode:
          if (pattern124 (x3, 
E_SImode) != 0)
            return -1;
          return 2226; /* *addsi3 */

        case E_TFmode:
          if (pattern216 (x3, 
E_TFmode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2248; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern216 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2249; /* addfprx23 */

        case E_DFmode:
          if (pattern216 (x3, 
E_DFmode) != 0
              || !
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2250; /* adddf3 */

        case E_SFmode:
          if (pattern216 (x3, 
E_SFmode) != 0
              || !
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2251; /* addsf3 */

        case E_TDmode:
          if (pattern216 (x3, 
E_TDmode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2252; /* addtd3 */

        case E_DDmode:
          if (pattern216 (x3, 
E_DDmode) != 0
              || !(
#line 6493 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2253; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 6115 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2219; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6401 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 2243; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2224; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6154 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2222; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern249 (x3, 
E_DImode) != 0
              || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2318; /* *adddi3_alc */

        case E_SImode:
          if (pattern249 (x3, 
E_SImode) != 0)
            return -1;
          return 2319; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 59)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern225 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern225 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern225 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern225 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern225 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 89)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern262 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2180 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 496; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern262 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2180 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 497; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern262 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2180 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 498; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern262 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2180 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 499; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern262 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2180 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 500; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern192 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 762 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 655; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern192 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 762 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 656; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern192 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 762 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 657; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern192 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 762 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 658; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern192 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 762 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 659; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern166 (x6))
        {
        case 0:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1587; /* *bswapv8hi */

        case 1:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1588; /* *bswapv4si */

        case 2:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1589; /* *bswapv4sf */

        case 3:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1590; /* *bswapv2di */

        case 4:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1591; /* *bswapv2df */

        case 5:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1592; /* *bswapv1ti */

        case 6:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1593; /* *bswapv1tf */

        case 7:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1594; /* *bswapti */

        case 8:
          if (!
#line 3480 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1595; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_V8HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 8)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER
          || pattern268 (x1) != 0
          || !
#line 1166 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 701; /* eltswapv8hi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 31)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_BLKmode)
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 0
          || GET_MODE (x16) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 33
          || GET_MODE (x17) != E_CCmode)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x19 = XVECEXP (x3, 0, 0);
      operands[2] = x19;
      x20 = XEXP (x15, 0);
      operands[3] = x20;
      x21 = XVECEXP (x3, 0, 3);
      operands[4] = x21;
      if (!immediate_operand (operands[4], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern293 (x3, 
E_DImode) != 0
              || !
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 1908; /* *strlendi */

        case E_SImode:
          if (pattern293 (x3, 
E_SImode) != 0
              || !
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 1909; /* *strlensi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x18 = XEXP (x2, 0);
      switch (GET_CODE (x18))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x18;
          operands[1] = x3;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != USE
                  || !memory_operand (operands[0], E_BLKmode)
                  || !memory_operand (operands[1], E_BLKmode))
                return -1;
              x22 = XEXP (x13, 0);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_VOIDmode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[3] = x17;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              if ((
#line 3597 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1914; /* *cpymem_short */
                }
              if (!(
#line 3597 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1915; /* *cpymem_short */

            case SET:
              x23 = XEXP (x13, 1);
              if (pattern155 (x23, 
E_TImode, 
9, 
UNSPEC_VOLATILE, 
3) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (pattern184 (x14) != 0
                  || !register_operand (operands[0], E_TImode)
                  || !nonsym_memory_operand (operands[1], E_TImode))
                return -1;
              x24 = XVECEXP (x23, 0, 1);
              operands[2] = x24;
              if (!register_operand (operands[2], E_TImode))
                return -1;
              x25 = XVECEXP (x23, 0, 2);
              operands[3] = x25;
              if (!register_operand (operands[3], E_TImode))
                return -1;
              x26 = XVECEXP (x23, 0, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              x22 = XEXP (x13, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x27 = XEXP (x14, 1);
              x28 = XEXP (x27, 0);
              if (!rtx_equal_p (x28, operands[1]))
                return -1;
              x29 = XEXP (x27, 1);
              if (!rtx_equal_p (x29, operands[2])
                  || !
#line 11355 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                return -1;
              return 2619; /* *atomic_compare_and_swapti_1 */

            default:
              return -1;
            }

        case PC:
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != LABEL_REF)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 1)
            return -1;
          operands[0] = x3;
          x30 = XEXP (x22, 0);
          operands[1] = x30;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode
                  || !(
#line 10594 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 2582; /* casesi_jump_via_thunkdi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode
                  || !(
#line 10594 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 2583; /* casesi_jump_via_thunksi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != USE)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      x14 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x14))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x17 = XEXP (x14, 0);
          operands[2] = x17;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if ((
#line 3852 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 1928; /* *clrmem_short */
            }
          if (!(
#line 3852 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 1929; /* *clrmem_short */

        case CLOBBER:
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode
              || !const_int_operand (operands[1], E_VOIDmode)
              || !
#line 9008 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
            return -1;
          return 2437; /* *xc_zero */

        default:
          return -1;
        }

    case COMPARE:
      if (pnum_clobbers == NULL
          || pattern76 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x13, 0);
      operands[2] = x22;
      if (!nonmemory_operand (operands[2], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      if ((
#line 4046 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1936; /* *cmpmem_short */
        }
      if (!(
#line 4046 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1937; /* *cmpmem_short */

    case UNSIGNED_FIX:
      if (pattern45 (x1) != 0)
        return -1;
      switch (pattern153 (x1))
        {
        case 0:
          if (
#line 5524 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2066; /* *fixuns_truncdfdi2_z13 */
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2072; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2068; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2070; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2074; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2076; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2078; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5524 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 770 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          return 2067; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2075; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2069; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2071; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2073; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2077; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2079; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      if (pattern45 (x1) != 0)
        return -1;
      switch (pattern154 (x1))
        {
        case 0:
          if (
#line 5562 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2080; /* *fix_truncdfdi2_bfp_z13 */
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2086; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2082; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2084; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2088; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5609 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2090; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5609 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2091; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5562 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 770 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2081; /* *fix_truncsfsi2_bfp_z13 */
          if (!
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2089; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2083; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2085; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2087; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 0
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!register_operand (operands[0], E_DDmode))
        return -1;
      x31 = XEXP (x3, 0);
      operands[1] = x31;
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      x32 = XVECEXP (x13, 0, 0);
      operands[2] = x32;
      if (!const_mask_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!scratch_operand (operands[3], E_TDmode)
          || !
#line 5745 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
        return -1;
      return 2121; /* *trunctddd2 */

    case AND:
      if (pattern46 (x1) != 0
          || !
#line 8268 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2389; /* *nc */

    case IOR:
      if (pattern46 (x1) != 0
          || !
#line 8678 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2427; /* *oc */

    case XOR:
      if (pattern46 (x1) != 0
          || !
#line 8951 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2436; /* *xc */

    case IF_THEN_ELSE:
      x31 = XEXP (x3, 0);
      if (!s390_brx_operator (x31, E_VOIDmode))
        return -1;
      operands[6] = x31;
      x33 = XEXP (x31, 0);
      if (GET_CODE (x33) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != PC)
        return -1;
      x18 = XEXP (x2, 0);
      if (GET_CODE (x18) != PC)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x23 = XEXP (x13, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      switch (pattern232 (x1))
        {
        case 0:
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2561; /* *brx_stage1_di */

        case 1:
          return 2562; /* *brx_stage1_si */

        default:
          return -1;
        }

    case CALL:
      x31 = XEXP (x3, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x33 = XEXP (x31, 0);
      operands[1] = x33;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case SYMBOL_REF:
          if (bras_sym_operand (operands[1], E_VOIDmode))
            {
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) == USE)
                {
                  x17 = XEXP (x14, 0);
                  operands[4] = x17;
                  if (
#line 11122 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
                    return 2611; /* *bras_tls */
                  if (
#line 11136 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
                    return 2612; /* *brasl_tls */
                }
            }
          break;

        default:
          break;
        }
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != USE
          || !address_operand (operands[1], E_VOIDmode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[4] = x17;
      if (!
#line 11151 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn) && GET_MODE (operands[3]) == Pmode))
        return -1;
      return 2613; /* *basr_tls */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 2)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern130 (x4, 
E_DImode) == 0
                          && (
#line 1115 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_1 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern131 (x4, 
E_DImode) == 0
                          && 
#line 2341 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern130 (x4, 
E_SImode) == 0
                          && 
#line 1115 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern131 (x4, 
E_SImode) == 0
                          && 
#line 2568 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x3) == MEM)
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (address_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && GET_MODE (x3) == E_DImode
                          && 
#line 2302 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && !FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == DImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_9 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && 
#line 2530 "../../gcc/config/s390/s390.md"
(!FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == SImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && 
#line 2673 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == HImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_QImode:
                      if (nonimmediate_operand (operands[0], E_QImode)
                          && GET_MODE (x3) == E_QImode
                          && 
#line 2738 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == QImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_17 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 2353 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && s390_const_int_pool_entry_p (operands[1], nullptr)
   && peep2_reg_dead_p (1, gen_rtx_REG (CCmode, CC_REGNUM))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_12 (insn, operands);

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (peep2_current_count < 2)
            return NULL;
          operands[1] = x3;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != SET)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CCZmode)
            return NULL;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 33
              || GET_MODE (x7) != E_CCZmode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern244 (
E_TFmode) != 0
                  || !(
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case E_FPRX2mode:
              if (pattern244 (
E_FPRX2mode) != 0
                  || !(
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_4 (insn, operands);

            case E_DFmode:
              if (pattern244 (
E_DFmode) != 0
                  || !
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_5 (insn, operands);

            case E_SFmode:
              if (pattern244 (
E_SFmode) != 0
                  || !
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            case E_TDmode:
              if (pattern244 (
E_TDmode) != 0
                  || !(
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            case E_DDmode:
              if (pattern244 (
E_DDmode) != 0
                  || !(
#line 1548 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case CLOBBER:
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 33
                  || GET_MODE (x14) != E_CCmode
                  || !address_operand (operands[1], E_QImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 2328 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_10 (insn, operands);

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 2555 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            case USE:
              if (peep2_current_count >= 2)
                {
                  res = peephole2_1 (x1, insn, pmatch_len_);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!plus16_Q_operand (operands[0], E_BLKmode)
                  || !plus16_Q_operand (operands[1], E_BLKmode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 3164 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 32))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_19 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern44 (x15) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!memory_operand (operands[0], E_BLKmode))
            return NULL;
          x14 = XEXP (x13, 0);
          if (!const_int_operand (x14, E_VOIDmode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern199 (x4, 
3) != 0)
            return NULL;
          x16 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x18 = XVECEXP (x4, 0, 0);
          x19 = XEXP (x18, 0);
          if (!memory_operand (x19, E_BLKmode))
            return NULL;
          x20 = XVECEXP (x4, 0, 1);
          x21 = XEXP (x20, 0);
          if (!const_int_operand (x21, E_VOIDmode))
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case AND:
              if (pattern295 (x1, 
AND) != 0
                  || !
#line 8304 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_20 (insn, operands);

            case IOR:
              if (pattern295 (x1, 
IOR) != 0
                  || !
#line 8714 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_21 (insn, operands);

            case XOR:
              if (pattern295 (x1, 
XOR) != 0
                  || !
#line 8986 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case CONST_INT:
              if (XWINT (x12, 0) != 0L)
                return NULL;
              operands[1] = x14;
              x22 = XEXP (x18, 1);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[2] = x19;
              operands[3] = x21;
              if (!
#line 9024 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[2], operands[1])
   && INTVAL (operands[1]) + INTVAL (operands[3]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_23 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
