/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 18;

    case E_TFmode:
      if (pattern0 (x3, 
E_TFmode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern9 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern9 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern9 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern9 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern9 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern9 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern9 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern9 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern9 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern9 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern9 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern9 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern9 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern9 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern9 (x1, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern9 (x1, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern20 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern20 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V1SFmode:
      if (pattern20 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern20 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern20 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    case E_V1DFmode:
      if (pattern20 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern20 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V1TFmode:
      if (pattern20 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 7;

    case E_TFmode:
      if (pattern20 (x1, 
E_TFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern65 (x1); /* [-1, 1] */
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      return 0;

    case ROTATE:
      if (GET_MODE (x8) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode)
          || !contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      return 1;

    case LSHIFTRT:
      res = pattern95 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case ASHIFT:
      res = pattern95 (x5);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern120 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern148 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern148 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern149 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern67 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern67 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              return pattern161 (x1, 
E_DImode); /* [-1, 0] */

            case E_SImode:
              if (pattern161 (x1, 
E_SImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern162 (x5, 
E_DImode) != 0)
                return -1;
              return 2;

            case E_SImode:
              if (pattern162 (x5, 
E_SImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x14 = XEXP (x7, 0);
      operands[2] = x14;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x13 = XEXP (x9, 1);
          if (GET_CODE (x13) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern163 (x1, 
E_DImode) != 0)
                return -1;
              return 4;

            case E_SImode:
              if (pattern163 (x1, 
E_SImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern164 (x4, 
E_DImode) != 0)
                return -1;
              return 6;

            case E_SImode:
              if (pattern164 (x4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MINUS)
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_DImode:
      return pattern246 (x4, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern246 (x4, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern259 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern259 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !addv_const_operand (operands[2], i2)
      || pattern284 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 1466 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 948; /* popcountv16qi2_vxe */
      if (!
#line 1474 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
        return -1;
      return 952; /* popcountv16qi2_vx */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1466 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 949; /* popcountv8hi2_vxe */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1466 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 950; /* popcountv4si2_vxe */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1466 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 951; /* popcountv2di2_vxe */

    case E_DImode:
      if (pattern107 (x2, pnum_clobbers, 
E_DImode) != 0
          || !(
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 798 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 2667; /* *popcountdi_z196 */

    case E_SImode:
      if (pattern107 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2668; /* *popcountsi_z196 */

    case E_HImode:
      if (pattern107 (x2, pnum_clobbers, 
E_HImode) != 0
          || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2669; /* *popcounthi_z196 */

    case E_QImode:
      if (pattern107 (x2, pnum_clobbers, 
E_QImode) != 0
          || !
#line 12156 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2670; /* *popcountqi_z196 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_smult_even_v1qi */

    case 1:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_smult_even_v2qi */

    case 2:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_smult_even_v4qi */

    case 3:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1196; /* vec_widen_smult_even_v8qi */

    case 4:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1197; /* vec_widen_smult_even_v16qi */

    case 5:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1198; /* vec_widen_smult_even_v1hi */

    case 6:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1199; /* vec_widen_smult_even_v2hi */

    case 7:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1200; /* vec_widen_smult_even_v4hi */

    case 8:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1201; /* vec_widen_smult_even_v8hi */

    case 9:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1202; /* vec_widen_smult_even_v1si */

    case 10:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1203; /* vec_widen_smult_even_v2si */

    case 11:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1204; /* vec_widen_smult_even_v4si */

    case 12:
      if (!
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1205; /* vec_widen_smult_even_v1di */

    case 13:
      if (!(
#line 1845 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1206; /* vec_widen_smult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case AND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != NOT)
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern223 (x2, 
E_V16QImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 46; /* vselv16qi */

                case E_V8HImode:
                  if (pattern223 (x2, 
E_V8HImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 47; /* vselv8hi */

                case E_V4SImode:
                  if (pattern223 (x2, 
E_V4SImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 48; /* vselv4si */

                case E_V2DImode:
                  if (pattern223 (x2, 
E_V2DImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 49; /* vselv2di */

                case E_V1TImode:
                  if (pattern223 (x2, 
E_V1TImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 50; /* vselv1ti */

                case E_V1DFmode:
                  if (pattern223 (x2, 
E_V1DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 51; /* vselv1df */

                case E_V2DFmode:
                  if (pattern223 (x2, 
E_V2DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 52; /* vselv2df */

                case E_V1SFmode:
                  if (pattern223 (x2, 
E_V1SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 53; /* vselv1sf */

                case E_V2SFmode:
                  if (pattern223 (x2, 
E_V2SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 54; /* vselv2sf */

                case E_V4SFmode:
                  if (pattern223 (x2, 
E_V4SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 55; /* vselv4sf */

                case E_V1TFmode:
                  if (pattern223 (x2, 
E_V1TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 56; /* vselv1tf */

                case E_TFmode:
                  if (pattern223 (x2, 
E_TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 57; /* vseltf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x6;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern9 (x2, 
E_V1QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1604; /* *vevalv1qi_iorand */

                case E_V2QImode:
                  if (pattern9 (x2, 
E_V2QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1613; /* *vevalv2qi_iorand */

                case E_V4QImode:
                  if (pattern9 (x2, 
E_V4QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1622; /* *vevalv4qi_iorand */

                case E_V8QImode:
                  if (pattern9 (x2, 
E_V8QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1631; /* *vevalv8qi_iorand */

                case E_V16QImode:
                  if (pattern9 (x2, 
E_V16QImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1640; /* *vevalv16qi_iorand */

                case E_V1HImode:
                  if (pattern9 (x2, 
E_V1HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1649; /* *vevalv1hi_iorand */

                case E_V2HImode:
                  if (pattern9 (x2, 
E_V2HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1658; /* *vevalv2hi_iorand */

                case E_V4HImode:
                  if (pattern9 (x2, 
E_V4HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1667; /* *vevalv4hi_iorand */

                case E_V8HImode:
                  if (pattern9 (x2, 
E_V8HImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1676; /* *vevalv8hi_iorand */

                case E_V1SImode:
                  if (pattern9 (x2, 
E_V1SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1685; /* *vevalv1si_iorand */

                case E_V2SImode:
                  if (pattern9 (x2, 
E_V2SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1694; /* *vevalv2si_iorand */

                case E_V4SImode:
                  if (pattern9 (x2, 
E_V4SImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1703; /* *vevalv4si_iorand */

                case E_V1DImode:
                  if (pattern9 (x2, 
E_V1DImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1712; /* *vevalv1di_iorand */

                case E_V2DImode:
                  if (pattern9 (x2, 
E_V2DImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1721; /* *vevalv2di_iorand */

                case E_V1TImode:
                  if (pattern9 (x2, 
E_V1TImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1730; /* *vevalv1ti_iorand */

                case E_TImode:
                  if (pattern9 (x2, 
E_TImode) != 0
                      || !
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1739; /* *vevalti_iorand */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 2);
              operands[5] = x10;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern245 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 4355 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1954; /* *risbgn_ior_and_sr_zedi */
                  if (pnum_clobbers == NULL
                      || !
#line 4355 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1955; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern245 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4355 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1956; /* *risbgn_ior_and_sr_zesi */
                  if (pnum_clobbers == NULL
                      || !
#line 4355 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1957; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern202 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4505 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1982; /* *insvdi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !(
#line 4505 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1983; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern202 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4505 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return 1984; /* *insvsi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !
#line 4505 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1985; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern203 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4559 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1988; /* *insvdi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !(
#line 4559 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1989; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern203 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4559 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return 1990; /* *insvsi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !
#line 4559 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1991; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern204 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4574 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1992; /* *risbgn_di_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !(
#line 4574 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1993; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern204 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4574 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return 1994; /* *risbgn_si_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !
#line 4574 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1995; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  res = recog_19 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (pnum_clobbers == NULL)
                return -1;
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern191 (x2, 
E_DImode) != 0
                      || !(
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2002; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern191 (x2, 
E_SImode) != 0
                      || !
#line 4688 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2004; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != AND)
        return -1;
      x11 = XEXP (x4, 0);
      operands[3] = x11;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern188 (x2, 
E_V16QImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 58; /* *vselv16qi_swapped */

        case E_V8HImode:
          if (pattern188 (x2, 
E_V8HImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 59; /* *vselv8hi_swapped */

        case E_V4SImode:
          if (pattern188 (x2, 
E_V4SImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 60; /* *vselv4si_swapped */

        case E_V2DImode:
          if (pattern188 (x2, 
E_V2DImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 61; /* *vselv2di_swapped */

        case E_V1TImode:
          if (pattern188 (x2, 
E_V1TImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 62; /* *vselv1ti_swapped */

        case E_V1DFmode:
          if (pattern188 (x2, 
E_V1DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 63; /* *vselv1df_swapped */

        case E_V2DFmode:
          if (pattern188 (x2, 
E_V2DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 64; /* *vselv2df_swapped */

        case E_V1SFmode:
          if (pattern188 (x2, 
E_V1SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 65; /* *vselv1sf_swapped */

        case E_V2SFmode:
          if (pattern188 (x2, 
E_V2SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 66; /* *vselv2sf_swapped */

        case E_V4SFmode:
          if (pattern188 (x2, 
E_V4SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 67; /* *vselv4sf_swapped */

        case E_V1TFmode:
          if (pattern188 (x2, 
E_V1TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 68; /* *vselv1tf_swapped */

        case E_TFmode:
          if (pattern188 (x2, 
E_TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 69; /* *vseltf_swapped */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern63 (x2, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode)
          || !
#line 4703 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      *pnum_clobbers = 1;
      return 2006; /* *rosbg_di_rotl */

    case LSHIFTRT:
      switch (pattern66 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2008; /* *rosbg_di_srl_bitmask */

        case 1:
          if (!
#line 4718 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 2010; /* *rosbg_si_srl_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern66 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2012; /* *rosbg_di_sll_bitmask */

        case 1:
          if (!
#line 4738 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 2014; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 806 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 667; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 70
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern291 (x2, 
E_V16QImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 670; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern291 (x2, 
E_V8HImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 671; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern291 (x2, 
E_V4SImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 672; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern291 (x2, 
E_V2DImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 673; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern291 (x2, 
E_V2DFmode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 674; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern291 (x2, 
E_V1TImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 675; /* *vec_permv1ti */

        case E_TImode:
          if (pattern291 (x2, 
E_TImode) != 0
              || !
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 676; /* *vec_permti */

        case E_V4SFmode:
          if (pattern291 (x2, 
E_V4SFmode) != 0
              || !(
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 677; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern291 (x2, 
E_V1TFmode) != 0
              || !(
#line 901 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 678; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      operands[1] = x2;
      if (address_operand (operands[1], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 2314 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return 1873; /* *la_64 */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 2541 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && legitimate_la_operand_p (operands[1])))
                return 1877; /* *la_31 */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      operands[0] = x2;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10385 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2569; /* *indirect_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10404 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2570; /* indirect_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10404 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2571; /* indirect_jump_via_thunksi_z10 */
      if (pnum_clobbers != NULL)
        {
          if (register_operand (operands[0], E_DImode)
              && (
#line 10422 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2572; /* indirect_jump_via_thunkdi */
            }
          if (register_operand (operands[0], E_SImode)
              && (
#line 10422 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2573; /* indirect_jump_via_thunksi */
            }
        }
      if (nonimmediate_operand (operands[0], E_VOIDmode)
          && 
#line 10478 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
        return 2578; /* *indirect2_jump */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case AND:
      return recog_50 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 4
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCUmode)
              || !
#line 4214 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1943; /* *cmpint_sign */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern91 (x2))
            {
            case 0:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 4993 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2036; /* *extendsidi2 */
              if (general_operand (operands[1], E_HImode)
                  && 
#line 5038 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_EXTIMM))
                return 2037; /* *extendhidi2_extimm */
              if (memory_operand (operands[1], E_HImode)
                  && 
#line 5052 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2038; /* *extendhidi2 */
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5095 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2041; /* *extendqidi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && (
#line 5106 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2043; /* *extendqidi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !(
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2045; /* *extendqidi2_short_displ */

            case 1:
              if (nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 5064 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2039; /* *extendhisi2_extimm */
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 5079 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM))
                return -1;
              return 2040; /* *extendhisi2 */

            case 2:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 5095 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2042; /* *extendqisi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && 
#line 5106 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT))
                return 2044; /* *extendqisi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                return -1;
              *pnum_clobbers = 1;
              return 2046; /* *extendqisi2_short_displ */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern91 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 5151 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2047; /* *zero_extendsidi2 */

            case E_HImode:
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if ((
#line 5265 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2052; /* *zero_extendhidi2_z10 */
                  if ((
#line 5280 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2054; /* *zero_extendhidi2_extimm */
                }
              if (!memory_operand (operands[1], E_HImode)
                  || !(
#line 5291 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2058; /* *zero_extendhidi2 */

            case E_QImode:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5280 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2056; /* *zero_extendqidi2_extimm */
              if (!memory_operand (operands[1], E_QImode)
                  || !(
#line 5291 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2060; /* *zero_extendqidi2 */

            default:
              return -1;
            }

        case 1:
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if (
#line 5265 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return 2053; /* *zero_extendhisi2_z10 */
              if (
#line 5280 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2055; /* *zero_extendhisi2_extimm */
            }
          if (memory_operand (operands[1], E_HImode)
              && 
#line 5291 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2059; /* *zero_extendhisi2 */
          if (pnum_clobbers == NULL
              || !s_operand (operands[1], E_HImode)
              || !
#line 5300 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2062; /* *zero_extendhisi2_31 */

        case 2:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 5280 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return 2057; /* *zero_extendqisi2_extimm */
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5291 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2061; /* *zero_extendqisi2 */
          if (!
#line 5312 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2063; /* *zero_extendqisi2_31 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          switch (pattern179 (x2))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6115 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2219; /* *adddi3_sign */
                }
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6401 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              *pnum_clobbers = 1;
              return 2243; /* *adddi3_sign */

            case 1:
              *pnum_clobbers = 1;
              return 2224; /* *addsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 6154 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2222; /* *adddi3_zero */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (pattern160 (x2))
            {
            case 0:
              if (
#line 6166 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2223; /* *adddi3_31z */
                }
              if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2225; /* *adddi3 */

            case 1:
              *pnum_clobbers = 1;
              return 2226; /* *addsi3 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x4, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern211 (x2, 
E_DImode) != 0
                  || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2318; /* *adddi3_alc */

            case E_SImode:
              if (pattern211 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2319; /* *addsi3_alc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern212 (x2, 
E_DImode) != 0)
                    return -1;
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 6661 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2267; /* *subdi3_sign */
                    }
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 6887 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2287; /* *subdi3_sign */

                case E_SImode:
                  if (pattern212 (x2, 
E_SImode) != 0
                      || !memory_operand (operands[2], E_HImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2272; /* *subsi3_sign */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!general_operand (operands[2], E_SImode)
                  || !
#line 6701 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2270; /* *subdi3_zero */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern88 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 6713 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2271; /* *subdi3_31z */
                    }
                  if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2273; /* *subdi3 */

                case E_SImode:
                  if (pattern88 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 2274; /* *subsi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern213 (x2, 
E_DImode) != 0
                  || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2322; /* *subdi3_slb */

            case E_SImode:
              if (pattern213 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2323; /* *subsi3_slb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (pattern179 (x2))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 7407 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2335; /* *muldi3_sign */
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 7459 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  return 2339; /* *muldi3_sign */

                case 1:
                  return 2340; /* *mulsi3_sign */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!nonimmediate_operand (operands[2], E_SImode)
                  || !
#line 7515 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2342; /* mulsidi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern178 (x2, 
E_DImode) != 0
                  || !
#line 7419 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2336; /* *muldi3 */

            case E_SImode:
              if (pattern178 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2341; /* *mulsi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern116 (x2, 
E_SImode, 
E_DImode) != 0
              || !
#line 785 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2346; /* umulsidi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern12 (x3))
    {
    case 0:
      if (register_operand (operands[2], E_V1QImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 997; /* vrotlv1qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return -1;
      return 1014; /* *rotlv1qi3 */

    case 1:
      if (register_operand (operands[2], E_V2QImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 998; /* vrotlv2qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return -1;
      return 1018; /* *rotlv2qi3 */

    case 2:
      if (register_operand (operands[2], E_V4QImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 999; /* vrotlv4qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return -1;
      return 1022; /* *rotlv4qi3 */

    case 3:
      if (register_operand (operands[2], E_V8QImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1000; /* vrotlv8qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return -1;
      return 1026; /* *rotlv8qi3 */

    case 4:
      if (register_operand (operands[2], E_V16QImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1001; /* vrotlv16qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return -1;
      return 1030; /* *rotlv16qi3 */

    case 5:
      if (register_operand (operands[2], E_V1HImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1002; /* vrotlv1hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return -1;
      return 1034; /* *rotlv1hi3 */

    case 6:
      if (register_operand (operands[2], E_V2HImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1003; /* vrotlv2hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return -1;
      return 1038; /* *rotlv2hi3 */

    case 7:
      if (register_operand (operands[2], E_V4HImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1004; /* vrotlv4hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return -1;
      return 1042; /* *rotlv4hi3 */

    case 8:
      if (register_operand (operands[2], E_V8HImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1005; /* vrotlv8hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return -1;
      return 1046; /* *rotlv8hi3 */

    case 9:
      if (register_operand (operands[2], E_V1SImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1006; /* vrotlv1si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return -1;
      return 1050; /* *rotlv1si3 */

    case 10:
      if (register_operand (operands[2], E_V2SImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1007; /* vrotlv2si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return -1;
      return 1054; /* *rotlv2si3 */

    case 11:
      if (register_operand (operands[2], E_V4SImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1008; /* vrotlv4si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return -1;
      return 1058; /* *rotlv4si3 */

    case 12:
      if (register_operand (operands[2], E_V1DImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1009; /* vrotlv1di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return -1;
      return 1062; /* *rotlv1di3 */

    case 13:
      if (register_operand (operands[2], E_V2DImode)
          && 
#line 1585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1010; /* vrotlv2di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return -1;
      return 1066; /* *rotlv2di3 */

    case 14:
      if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2530; /* *rotldi3 */

    case 15:
      return 2531; /* *rotlsi3 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 2044 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1265; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2044 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1266; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 2044 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1267; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 2044 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1268; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9555 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2523; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9555 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2524; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9555 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2525; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9555 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2526; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern236 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern236 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern237 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern237 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern238 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern275 (x7, 
E_V16QImode) != 0
                  || !
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern275 (x7, 
E_V8HImode) != 0
                  || !
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern275 (x7, 
E_V4SImode) != 0
                  || !
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern275 (x7, 
E_V2DImode) != 0
                  || !
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern275 (x7, 
E_V1TImode) != 0
                  || !(
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern275 (x7, 
E_TImode) != 0
                  || !(
#line 2028 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern276 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2111 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern276 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2111 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern276 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2111 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern276 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2111 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern275 (x7, 
E_V16QImode) != 0
                      || !
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern275 (x7, 
E_V8HImode) != 0
                      || !
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern275 (x7, 
E_V4SImode) != 0
                      || !
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern275 (x7, 
E_V2DImode) != 0
                      || !
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern275 (x7, 
E_V1TImode) != 0
                      || !(
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern275 (x7, 
E_TImode) != 0
                      || !(
#line 2038 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern276 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2122 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern276 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2122 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern276 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2122 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern276 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2122 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern238 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern275 (x7, 
E_V16QImode) != 0
                  || !
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern275 (x7, 
E_V8HImode) != 0
                  || !
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern275 (x7, 
E_V4SImode) != 0
                  || !
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern275 (x7, 
E_V2DImode) != 0
                  || !
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern275 (x7, 
E_V1TImode) != 0
                  || !(
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern275 (x7, 
E_TImode) != 0
                  || !(
#line 2048 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern238 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern276 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern276 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern276 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern276 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2133 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1802; /* *clc */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern101 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern260 (x1))
    {
    case 0:
      if (!(
#line 3701 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1916; /* *cpymem_long */

    case 1:
      if (!(
#line 3701 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1917; /* *cpymem_long */

    case 2:
      if (!
#line 3714 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1918; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  if (pattern7 (x1, 
39, 
E_TImode, 
17, 
38) != 0
      || pattern300 (x1, 
41, 
E_TImode, 
19, 
40, 
18) != 0
      || pattern301 (x1, 
43, 
E_TImode, 
21, 
42, 
20) != 0
      || pattern302 (x1, 
E_TImode, 
45, 
23, 
44, 
22) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 46
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25
      || GET_MODE (x7) != E_TImode)
    return -1;
  x8 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 47
      || GET_MODE (x9) != E_TImode)
    return -1;
  x10 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 26
      || GET_MODE (x11) != E_TImode)
    return -1;
  x12 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 48
      || GET_MODE (x13) != E_TImode)
    return -1;
  x14 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 27
      || GET_MODE (x15) != E_TImode)
    return -1;
  x16 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 49
      || GET_MODE (x17) != E_TImode)
    return -1;
  x18 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 28
      || GET_MODE (x19) != E_TImode)
    return -1;
  x20 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 50
      || GET_MODE (x21) != E_TImode)
    return -1;
  x22 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 29
      || GET_MODE (x23) != E_TImode)
    return -1;
  x24 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 51
      || GET_MODE (x25) != E_TImode)
    return -1;
  x26 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 30
      || GET_MODE (x27) != E_TImode)
    return -1;
  x28 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 52
      || GET_MODE (x29) != E_TImode)
    return -1;
  x30 = XVECEXP (x1, 0, 32);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 31
      || GET_MODE (x31) != E_TImode)
    return -1;
  x32 = XVECEXP (x1, 0, 33);
  if (GET_CODE (x32) != CLOBBER)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 53
      || GET_MODE (x33) != E_TImode)
    return -1;
  x34 = XVECEXP (x1, 0, 0);
  x35 = XEXP (x34, 1);
  x36 = XVECEXP (x35, 0, 0);
  operands[0] = x36;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  x37 = XVECEXP (x1, 0, 1);
  x38 = XEXP (x37, 0);
  operands[1] = x38;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x39 = XEXP (x37, 1);
  x40 = XVECEXP (x39, 0, 0);
  if (!rtx_equal_p (x40, operands[0])
      || !
#line 12420 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
    return -1;
  return 2678; /* tbegin_1_z13 */
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_61 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_57 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_56 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 182; /* vec_smulhv16qi */

        case 1:
          if (!
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 183; /* vec_smulhv8hi */

        case 2:
          if (!
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 184; /* vec_smulhv4si */

        case 3:
          if (!(
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 185; /* vec_smulhv2di */

        case 4:
          if (!(
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 186; /* vec_smulhv1ti */

        case 5:
          if (!(
#line 988 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 187; /* vec_smulhti */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 188; /* vec_umulhv16qi */

        case 1:
          if (!
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 189; /* vec_umulhv8hi */

        case 2:
          if (!
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 190; /* vec_umulhv4si */

        case 3:
          if (!(
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 191; /* vec_umulhv2di */

        case 4:
          if (!(
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 192; /* vec_umulhv1ti */

        case 5:
          if (!(
#line 997 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 193; /* vec_umulhti */

        default:
          return -1;
        }

    case NOT:
      return recog_53 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_55 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_67 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_75 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_62 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_70 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1292 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 748; /* udivv4si3 */

        case 1:
          if (!
#line 1292 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 749; /* udivv2di3 */

        case 2:
          if (!
#line 1292 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 750; /* udivv1ti3 */

        case 3:
          if (!
#line 1292 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 751; /* udivti3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1301 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 752; /* modv4si3 */

        case 1:
          if (!
#line 1301 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 753; /* modv2di3 */

        case 2:
          if (!
#line 1301 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 754; /* modv1ti3 */

        case 3:
          if (!
#line 1301 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 755; /* modti3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1310 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 756; /* umodv4si3 */

        case 1:
          if (!
#line 1310 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 757; /* umodv2di3 */

        case 2:
          if (!
#line 1310 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 758; /* umodv1ti3 */

        case 3:
          if (!
#line 1310 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 759; /* umodti3 */

        default:
          return -1;
        }

    case NEG:
      return recog_54 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_58 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_59 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_77 (x1, insn, pnum_clobbers);

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 975; /* ctzv1qi2 */

        case 1:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 976; /* ctzv2qi2 */

        case 2:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 977; /* ctzv4qi2 */

        case 3:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 978; /* ctzv8qi2 */

        case 4:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 979; /* ctzv16qi2 */

        case 5:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 980; /* ctzv1hi2 */

        case 6:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 981; /* ctzv2hi2 */

        case 7:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 982; /* ctzv4hi2 */

        case 8:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 983; /* ctzv8hi2 */

        case 9:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 984; /* ctzv1si2 */

        case 10:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 985; /* ctzv2si2 */

        case 11:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 986; /* ctzv4si2 */

        case 12:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 987; /* ctzv1di2 */

        case 13:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 988; /* ctzv2di2 */

        case 14:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 989; /* ctzv1sf2 */

        case 15:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 990; /* ctzv2sf2 */

        case 16:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 991; /* ctzv4sf2 */

        case 17:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 992; /* ctzv1df2 */

        case 18:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 993; /* ctzv2df2 */

        case 19:
          if (!
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 994; /* ctzv1tf2 */

        case 20:
          if (!(
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 995; /* ctzv1ti2 */

        case 21:
          if (!(
#line 1573 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 996; /* ctzti2 */

        case 22:
          if (!
#line 9643 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
            return -1;
          return 2529; /* ctzdi2 */

        default:
          return -1;
        }

    case ROTATE:
      return recog_65 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_63 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_60 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_64 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* *sminv1qi3 */

        case 1:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* *sminv2qi3 */

        case 2:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1131; /* *sminv4qi3 */

        case 3:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1132; /* *sminv8qi3 */

        case 4:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1133; /* *sminv16qi3 */

        case 5:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1134; /* *sminv1hi3 */

        case 6:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1135; /* *sminv2hi3 */

        case 7:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1136; /* *sminv4hi3 */

        case 8:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1137; /* *sminv8hi3 */

        case 9:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1138; /* *sminv1si3 */

        case 10:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1139; /* *sminv2si3 */

        case 11:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1140; /* *sminv4si3 */

        case 12:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1141; /* *sminv1di3 */

        case 13:
          if (!
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1142; /* *sminv2di3 */

        case 14:
          if (!(
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1143; /* *sminv1ti3 */

        case 15:
          if (!(
#line 1760 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1144; /* *sminti3 */

        case 16:
          if (!
#line 2179 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1311; /* *sminv4sf3_vxe */

        case 17:
          if (
#line 2179 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1312; /* *sminv2df3_vxe */
          if (!
#line 2188 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1315; /* *sminv2df3_vx */

        case 18:
          if (!
#line 2179 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1313; /* *sminv1tf3_vxe */

        case 19:
          if (!
#line 2179 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1314; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1145; /* *smaxv1qi3 */

        case 1:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1146; /* *smaxv2qi3 */

        case 2:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1147; /* *smaxv4qi3 */

        case 3:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1148; /* *smaxv8qi3 */

        case 4:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1149; /* *smaxv16qi3 */

        case 5:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1150; /* *smaxv1hi3 */

        case 6:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1151; /* *smaxv2hi3 */

        case 7:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1152; /* *smaxv4hi3 */

        case 8:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1153; /* *smaxv8hi3 */

        case 9:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1154; /* *smaxv1si3 */

        case 10:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1155; /* *smaxv2si3 */

        case 11:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1156; /* *smaxv4si3 */

        case 12:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1157; /* *smaxv1di3 */

        case 13:
          if (!
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1158; /* *smaxv2di3 */

        case 14:
          if (!(
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1159; /* *smaxv1ti3 */

        case 15:
          if (!(
#line 1785 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1160; /* *smaxti3 */

        case 16:
          if (!
#line 2143 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1306; /* *smaxv4sf3_vxe */

        case 17:
          if (
#line 2143 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1307; /* *smaxv2df3_vxe */
          if (!
#line 2152 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1310; /* *smaxv2df3_vx */

        case 18:
          if (!
#line 2143 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1308; /* *smaxv1tf3_vxe */

        case 19:
          if (!
#line 2143 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1309; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1161; /* *uminv1qi3 */

        case 1:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1162; /* *uminv2qi3 */

        case 2:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1163; /* *uminv4qi3 */

        case 3:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1164; /* *uminv8qi3 */

        case 4:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1165; /* *uminv16qi3 */

        case 5:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1166; /* *uminv1hi3 */

        case 6:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1167; /* *uminv2hi3 */

        case 7:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1168; /* *uminv4hi3 */

        case 8:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1169; /* *uminv8hi3 */

        case 9:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1170; /* *uminv1si3 */

        case 10:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1171; /* *uminv2si3 */

        case 11:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1172; /* *uminv4si3 */

        case 12:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1173; /* *uminv1di3 */

        case 13:
          if (!
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1174; /* *uminv2di3 */

        case 14:
          if (!(
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1175; /* *uminv1ti3 */

        case 15:
          if (!(
#line 1810 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1176; /* *uminti3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1177; /* *umaxv1qi3 */

        case 1:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1178; /* *umaxv2qi3 */

        case 2:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1179; /* *umaxv4qi3 */

        case 3:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1180; /* *umaxv8qi3 */

        case 4:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1181; /* *umaxv16qi3 */

        case 5:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1182; /* *umaxv1hi3 */

        case 6:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1183; /* *umaxv2hi3 */

        case 7:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1184; /* *umaxv4hi3 */

        case 8:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1185; /* *umaxv8hi3 */

        case 9:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1186; /* *umaxv1si3 */

        case 10:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1187; /* *umaxv2si3 */

        case 11:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1188; /* *umaxv4si3 */

        case 12:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1189; /* *umaxv1di3 */

        case 13:
          if (!
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1190; /* *umaxv2di3 */

        case 14:
          if (!(
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1191; /* *umaxv1ti3 */

        case 15:
          if (!(
#line 1835 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1192; /* *umaxti3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_72 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_74 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_76 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_68 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_73 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_69 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 3152 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1557; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3152 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 108 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1558; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 3184 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1559; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3184 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 108 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1560; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x2, 2);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      operands[3] = x3;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_32 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x3, 0) != 0L)
        return -1;
      switch (pattern35 (x1))
        {
        case 0:
          if (!(
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1974; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1975; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 2);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1976; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1977; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5704 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2118; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5722 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2120; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5722 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2119; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5753 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2122; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_66 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      if (!const_int_operand (x6, E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x6;
          if (!
#line 10808 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2592; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x6;
          if (
#line 10838 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2593; /* *sibcall_value_brc */
          if (!
#line 10847 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2594; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_71 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12146 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2666; /* *popcountdi_z15 */

    case COPYSIGN:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern0 (x2, 
E_TFmode) != 0
              || !(
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2671; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern0 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2672; /* copysignfprx23 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2673; /* copysigndf3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2674; /* copysignsf3 */

        case E_TDmode:
          if (pattern0 (x2, 
E_TDmode) != 0
              || !(
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2675; /* copysigntd3 */

        case E_DDmode:
          if (pattern0 (x2, 
E_DDmode) != 0
              || !(
#line 12313 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2676; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
