/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern17 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern17 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern17 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern17 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern17 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern17 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    case E_V1TImode:
      if (pattern17 (x3, 
E_V1DImode, 
E_V1TImode) != 0)
        return -1;
      return 12;

    case E_TImode:
      if (pattern17 (x3, 
E_V2DImode, 
E_TImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern56 (x1, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern56 (x1, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern56 (x1, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern56 (x1, 
E_TImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 1
      || GET_MODE (x11) != E_SImode)
    return -1;
  return pattern72 (x2); /* [-1, 23] */
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern97 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern97 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern102 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern102 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern102 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern102 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern102 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern102 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern102 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern102 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern102 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern102 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern102 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern102 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern102 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern102 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern103 (x1, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern103 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern103 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern103 (x1, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern103 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern174 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern188 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern244 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || pattern287 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XVECEXP (x10, 0, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1047 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode
      || pattern112 (x2, 
E_SImode) != 0
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4591 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return 1996; /* *risbgn_sidi_ior_and_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4591 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return -1;
  *pnum_clobbers = 1;
  return 1997; /* *risbg_sidi_ior_and_lshiftrt */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_CCVEQmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          switch (pattern169 (x2, pnum_clobbers, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          switch (pattern169 (x2, pnum_clobbers, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1979 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          switch (pattern170 (x2, pnum_clobbers, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          switch (pattern170 (x2, pnum_clobbers, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2062 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        case E_CCSmode:
          if (GET_MODE (x2) != E_CCSmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2358 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1373; /* *vec_cmpti_ccs */

        case E_CCUmode:
          if (GET_MODE (x2) != E_CCUmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2358 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1374; /* *vec_cmpti_ccu */

        case E_CCZmode:
          if (GET_MODE (x2) != E_CCZmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2358 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1375; /* *vec_cmpti_ccz */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 1065 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1764; /* *tmhi_full */
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_HImode)
              && const0_operand (operands[1], E_HImode)
              && 
#line 1218 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            {
              *pnum_clobbers = 1;
              return 1779; /* *tsthiCCT_cconly */
            }
          if (!s_operand (operands[0], E_HImode))
            return -1;
          if (pnum_clobbers != NULL
              && const0_operand (operands[1], E_HImode)
              && 
#line 1259 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            {
              *pnum_clobbers = 1;
              return 1783; /* *tsthi_cconly */
            }
          if (!immediate_operand (operands[1], E_HImode)
              || !
#line 1338 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_Z10))
            return -1;
          return 1789; /* *cmphi_ccs_z10 */

        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 1065 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1765; /* *tmqi_full */
          if (!const0_operand (operands[1], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_QImode)
              && 
#line 1231 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return 1780; /* *tstqiCCT_cconly */
          if (pnum_clobbers == NULL
              || !s_operand (operands[0], E_QImode)
              || !
#line 1259 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1784; /* *tstqi_cconly */

        case E_DImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_DImode)
              && const0_operand (operands[1], E_DImode)
              && (
#line 1130 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1769; /* *tstdi_cconly_extimm */
            }
          if (!register_operand (operands[0], E_DImode)
              || !const0_operand (operands[1], E_DImode))
            return -1;
          if (
#line 1181 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_ZARCH))
            return 1774; /* *tstdi_cconly_31 */
          if (!(
#line 1191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1775; /* *tstdi_cconly2 */

        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode)
              && const0_operand (operands[1], E_SImode))
            {
              if (
#line 1130 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                {
                  *pnum_clobbers = 1;
                  return 1770; /* *tstsi_cconly_extimm */
                }
              if (
#line 1168 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                {
                  *pnum_clobbers = 1;
                  return 1773; /* *tstsi_cconly */
                }
            }
          if (!register_operand (operands[0], E_SImode)
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1191 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          return 1776; /* *tstsi_cconly2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || !const0_operand (operands[1], E_TFmode)
              || !(
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1809; /* *cmptf_ccs_0_fastmath */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || !const0_operand (operands[1], E_FPRX2mode)
              || !(
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1810; /* *cmpfprx2_ccs_0_fastmath */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !const0_operand (operands[1], E_DFmode)
              || !
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1811; /* *cmpdf_ccs_0_fastmath */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !const0_operand (operands[1], E_SFmode)
              || !
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1812; /* *cmpsf_ccs_0_fastmath */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || !const0_operand (operands[1], E_TDmode)
              || !(
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1813; /* *cmptd_ccs_0_fastmath */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || !const0_operand (operands[1], E_DDmode)
              || !(
#line 1574 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1814; /* *cmpdd_ccs_0_fastmath */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      if (pattern13 (x1, 
E_V1QImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1318; /* *vec_cmpgtuv1qiv1qi_nocc */

    case E_V2QImode:
      if (pattern13 (x1, 
E_V2QImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1321; /* *vec_cmpgtuv2qiv2qi_nocc */

    case E_V4QImode:
      if (pattern13 (x1, 
E_V4QImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1324; /* *vec_cmpgtuv4qiv4qi_nocc */

    case E_V8QImode:
      if (pattern13 (x1, 
E_V8QImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1327; /* *vec_cmpgtuv8qiv8qi_nocc */

    case E_V16QImode:
      if (pattern13 (x1, 
E_V16QImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1330; /* *vec_cmpgtuv16qiv16qi_nocc */

    case E_V1HImode:
      if (pattern13 (x1, 
E_V1HImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1333; /* *vec_cmpgtuv1hiv1hi_nocc */

    case E_V2HImode:
      if (pattern13 (x1, 
E_V2HImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1336; /* *vec_cmpgtuv2hiv2hi_nocc */

    case E_V4HImode:
      if (pattern13 (x1, 
E_V4HImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1339; /* *vec_cmpgtuv4hiv4hi_nocc */

    case E_V8HImode:
      if (pattern13 (x1, 
E_V8HImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1342; /* *vec_cmpgtuv8hiv8hi_nocc */

    case E_V1SImode:
      if (pattern13 (x1, 
E_V1SImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1345; /* *vec_cmpgtuv1siv1si_nocc */

    case E_V2SImode:
      if (pattern13 (x1, 
E_V2SImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1348; /* *vec_cmpgtuv2siv2si_nocc */

    case E_V4SImode:
      if (pattern13 (x1, 
E_V4SImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1351; /* *vec_cmpgtuv4siv4si_nocc */

    case E_V1DImode:
      if (pattern13 (x1, 
E_V1DImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1354; /* *vec_cmpgtuv1div1di_nocc */

    case E_V2DImode:
      if (pattern13 (x1, 
E_V2DImode) != 0
          || !
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1357; /* *vec_cmpgtuv2div2di_nocc */

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_V1TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_V1TImode)
          && (
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1360; /* *vec_cmpgtuv1tiv1ti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode)
          || !
#line 2312 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1368; /* *vec_cmpgtuv1tiv1ti_nocc_emu */

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_TImode)
          && (
#line 2248 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1363; /* *vec_cmpgtutiti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_TImode)
          || !
#line 2312 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1369; /* *vec_cmpgtutiti_nocc_emu */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern67 (x3, 
E_V1QImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 722; /* subv1qi3 */

    case E_V2QImode:
      if (pattern67 (x3, 
E_V2QImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 723; /* subv2qi3 */

    case E_V4QImode:
      if (pattern67 (x3, 
E_V4QImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 724; /* subv4qi3 */

    case E_V8QImode:
      if (pattern67 (x3, 
E_V8QImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 725; /* subv8qi3 */

    case E_V16QImode:
      if (pattern67 (x3, 
E_V16QImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 726; /* subv16qi3 */

    case E_V1HImode:
      if (pattern67 (x3, 
E_V1HImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 727; /* subv1hi3 */

    case E_V2HImode:
      if (pattern67 (x3, 
E_V2HImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 728; /* subv2hi3 */

    case E_V4HImode:
      if (pattern67 (x3, 
E_V4HImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 729; /* subv4hi3 */

    case E_V8HImode:
      if (pattern67 (x3, 
E_V8HImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 730; /* subv8hi3 */

    case E_V1SImode:
      if (pattern67 (x3, 
E_V1SImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 731; /* subv1si3 */

    case E_V2SImode:
      if (pattern67 (x3, 
E_V2SImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 732; /* subv2si3 */

    case E_V4SImode:
      if (pattern67 (x3, 
E_V4SImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 733; /* subv4si3 */

    case E_V1DImode:
      if (pattern67 (x3, 
E_V1DImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 734; /* subv1di3 */

    case E_V2DImode:
      if (pattern67 (x3, 
E_V2DImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 735; /* subv2di3 */

    case E_V1TImode:
      if (pattern67 (x3, 
E_V1TImode) != 0
          || !
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 736; /* subv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && nonimmediate_operand (operands[1], E_TImode)
          && 
#line 1265 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 737; /* *subti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 6622 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2266; /* *subti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1997 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1253; /* subv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1997 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1254; /* subv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1997 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1255; /* subv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1997 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1256; /* subtf3_vr */
      if (pnum_clobbers == NULL
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2290; /* subtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern88 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2291; /* subfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern88 (x3, 
E_DFmode) != 0
          || !
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2292; /* subdf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern88 (x3, 
E_SFmode) != 0
          || !
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2293; /* subsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern88 (x3, 
E_TDmode) != 0
          || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2294; /* subtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern88 (x3, 
E_DDmode) != 0
          || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2295; /* subdd3 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_18 (x1, insn, pnum_clobbers);

    case BSWAP:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern168 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 501; /* *vec_extract_bswap_vecv8hi */

        case E_SImode:
          if (pattern168 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 502; /* *vec_extract_bswap_vecv4si */

        case E_SFmode:
          if (pattern168 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 503; /* *vec_extract_bswap_vecv4sf */

        case E_DImode:
          if (pattern168 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 504; /* *vec_extract_bswap_vecv2di */

        case E_DFmode:
          if (pattern168 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 505; /* *vec_extract_bswap_vecv2df */

        default:
          return -1;
        }

    case VEC_CONCAT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x7 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          switch (XWINT (x7, 0))
            {
            case 0L:
              switch (XWINT (x9, 0))
                {
                case 3L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern222 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                          || !
#line 914 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 679; /* vpdi1v2di */

                    case E_V2DFmode:
                      if (pattern222 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                          || !
#line 914 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 680; /* vpdi1v2df */

                    default:
                      return -1;
                    }

                case 2L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern222 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                          || !
#line 1041 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 695; /* *vmrhg */

                    case E_V2DFmode:
                      if (pattern222 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                          || !
#line 1041 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 696; /* *vmrhg */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1L:
              switch (XWINT (x9, 0))
                {
                case 2L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern222 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                          || !
#line 926 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 681; /* vpdi4v2di */

                    case E_V2DFmode:
                      if (pattern222 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                          || !
#line 926 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 682; /* vpdi4v2df */

                    default:
                      return -1;
                    }

                case 3L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern222 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                          || !
#line 1051 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 697; /* *vmrlg */

                    case E_V2DFmode:
                      if (pattern222 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                          || !
#line 1051 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 698; /* *vmrlg */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          x7 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          switch (XWINT (x7, 0))
            {
            case 2L:
              switch (XWINT (x9, 0))
                {
                case 3L:
                  if (XWINT (x10, 0) != 4L
                      || XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern222 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                          || !
#line 938 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 683; /* vpdi4_2v4si */

                    case E_V4SFmode:
                      if (pattern222 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                          || !
#line 938 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 684; /* vpdi4_2v4sf */

                    default:
                      return -1;
                    }

                case 6L:
                  if (XWINT (x10, 0) != 3L
                      || XWINT (x11, 0) != 7L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern222 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                          || !
#line 1031 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 693; /* *vmrlf */

                    case E_V4SFmode:
                      if (pattern222 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                          || !
#line 1031 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 694; /* *vmrlf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 0L:
              if (XWINT (x10, 0) != 1L)
                return -1;
              switch (XWINT (x9, 0))
                {
                case 4L:
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern222 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                          || !
#line 1009 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 689; /* *vmrhf */

                    case E_V4SFmode:
                      if (pattern222 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                          || !
#line 1009 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 690; /* *vmrhf */

                    default:
                      return -1;
                    }

                case 2L:
                  if (XWINT (x11, 0) != 3L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern110 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                          || !
#line 1020 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 691; /* *vmrhf_halfv4si */

                    case E_V4SFmode:
                      if (pattern110 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                          || !
#line 1020 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                        return -1;
                      return 692; /* *vmrhf_halfv4sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 16:
          if (pattern132 (x4) != 0)
            return -1;
          x12 = XVECEXP (x4, 0, 8);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x4, 0, 9);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x4, 0, 10);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XVECEXP (x4, 0, 11);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XVECEXP (x4, 0, 12);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x4, 0, 13);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x4, 0, 14);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XVECEXP (x4, 0, 15);
          if (GET_CODE (x19) != CONST_INT
              || pattern222 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          switch (XWINT (x7, 0))
            {
            case 0L:
              x9 = XVECEXP (x4, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x4, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x4, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x20 = XVECEXP (x4, 0, 4);
              if (XWINT (x20, 0) != 2L)
                return -1;
              x21 = XVECEXP (x4, 0, 5);
              if (XWINT (x21, 0) != 18L)
                return -1;
              x22 = XVECEXP (x4, 0, 6);
              if (XWINT (x22, 0) != 3L)
                return -1;
              x23 = XVECEXP (x4, 0, 7);
              if (XWINT (x23, 0) != 19L
                  || XWINT (x12, 0) != 4L
                  || XWINT (x13, 0) != 20L
                  || XWINT (x14, 0) != 5L
                  || XWINT (x15, 0) != 21L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 22L
                  || XWINT (x18, 0) != 7L
                  || XWINT (x19, 0) != 23L
                  || !
#line 955 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 685; /* *vmrhb */

            case 8L:
              x9 = XVECEXP (x4, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x4, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x4, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x20 = XVECEXP (x4, 0, 4);
              if (XWINT (x20, 0) != 10L)
                return -1;
              x21 = XVECEXP (x4, 0, 5);
              if (XWINT (x21, 0) != 26L)
                return -1;
              x22 = XVECEXP (x4, 0, 6);
              if (XWINT (x22, 0) != 11L)
                return -1;
              x23 = XVECEXP (x4, 0, 7);
              if (XWINT (x23, 0) != 27L
                  || XWINT (x12, 0) != 12L
                  || XWINT (x13, 0) != 28L
                  || XWINT (x14, 0) != 13L
                  || XWINT (x15, 0) != 29L
                  || XWINT (x16, 0) != 14L
                  || XWINT (x17, 0) != 30L
                  || XWINT (x18, 0) != 15L
                  || XWINT (x19, 0) != 31L
                  || !
#line 972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 686; /* *vmrlb */

            default:
              return -1;
            }

        case 8:
          if (pattern132 (x4) != 0
              || pattern222 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          switch (XWINT (x7, 0))
            {
            case 0L:
              x9 = XVECEXP (x4, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x4, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x4, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x20 = XVECEXP (x4, 0, 4);
              if (XWINT (x20, 0) != 2L)
                return -1;
              x21 = XVECEXP (x4, 0, 5);
              if (XWINT (x21, 0) != 10L)
                return -1;
              x22 = XVECEXP (x4, 0, 6);
              if (XWINT (x22, 0) != 3L)
                return -1;
              x23 = XVECEXP (x4, 0, 7);
              if (XWINT (x23, 0) != 11L
                  || !
#line 985 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 687; /* *vmrhh */

            case 4L:
              x9 = XVECEXP (x4, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x4, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x4, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x20 = XVECEXP (x4, 0, 4);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x4, 0, 5);
              if (XWINT (x21, 0) != 14L)
                return -1;
              x22 = XVECEXP (x4, 0, 6);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x4, 0, 7);
              if (XWINT (x23, 0) != 15L
                  || !
#line 998 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 688; /* *vmrlh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern12 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 1011; /* *ashlv1qi3 */
          if (!register_operand (operands[2], E_V1QImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1067; /* vashlv1qi3 */

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 1015; /* *ashlv2qi3 */
          if (!register_operand (operands[2], E_V2QImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1068; /* vashlv2qi3 */

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 1019; /* *ashlv4qi3 */
          if (!register_operand (operands[2], E_V4QImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1069; /* vashlv4qi3 */

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1023; /* *ashlv8qi3 */
          if (!register_operand (operands[2], E_V8QImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1070; /* vashlv8qi3 */

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1027; /* *ashlv16qi3 */
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1071; /* vashlv16qi3 */

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1031; /* *ashlv1hi3 */
          if (!register_operand (operands[2], E_V1HImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1072; /* vashlv1hi3 */

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1035; /* *ashlv2hi3 */
          if (!register_operand (operands[2], E_V2HImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1073; /* vashlv2hi3 */

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1039; /* *ashlv4hi3 */
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1074; /* vashlv4hi3 */

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1043; /* *ashlv8hi3 */
          if (!register_operand (operands[2], E_V8HImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1075; /* vashlv8hi3 */

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1047; /* *ashlv1si3 */
          if (!register_operand (operands[2], E_V1SImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1076; /* vashlv1si3 */

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1051; /* *ashlv2si3 */
          if (!register_operand (operands[2], E_V2SImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1077; /* vashlv2si3 */

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1055; /* *ashlv4si3 */
          if (!register_operand (operands[2], E_V4SImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1078; /* vashlv4si3 */

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1059; /* *ashlv1di3 */
          if (!register_operand (operands[2], E_V1DImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1079; /* vashlv1di3 */

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1644 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1063; /* *ashlv2di3 */
          if (!register_operand (operands[2], E_V2DImode)
              || !
#line 1676 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1080; /* vashlv2di3 */

        case 14:
          if (
#line 9696 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2532; /* *ashldi3_31 */
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2534; /* *ashldi3 */

        case 15:
          return 2536; /* *ashlsi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1840; /* *lxah_index */

            case 2L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1841; /* *lxaf_index */

            case 3L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1842; /* *lxag_index */

            case 4L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1843; /* *lxaq_index */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2079 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1844; /* *lxah_displacement_index */

            case 2L:
              if (!
#line 2079 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1845; /* *lxaf_displacement_index */

            case 3L:
              if (!
#line 2079 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1846; /* *lxag_displacement_index */

            case 4L:
              if (!
#line 2079 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1847; /* *lxaq_displacement_index */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 953; /* clzv1qi2 */

    case 1:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 954; /* clzv2qi2 */

    case 2:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 955; /* clzv4qi2 */

    case 3:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 956; /* clzv8qi2 */

    case 4:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 957; /* clzv16qi2 */

    case 5:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 958; /* clzv1hi2 */

    case 6:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 959; /* clzv2hi2 */

    case 7:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 960; /* clzv4hi2 */

    case 8:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 961; /* clzv8hi2 */

    case 9:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 962; /* clzv1si2 */

    case 10:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 963; /* clzv2si2 */

    case 11:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 964; /* clzv4si2 */

    case 12:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 965; /* clzv1di2 */

    case 13:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 966; /* clzv2di2 */

    case 14:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 967; /* clzv1sf2 */

    case 15:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 968; /* clzv2sf2 */

    case 16:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 969; /* clzv4sf2 */

    case 17:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 970; /* clzv1df2 */

    case 18:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 971; /* clzv2df2 */

    case 19:
      if (!
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 972; /* clzv1tf2 */

    case 20:
      if (!(
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 973; /* clzv1ti2 */

    case 21:
      if (!(
#line 1564 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 974; /* clzti2 */

    case 22:
      if (!
#line 9614 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2527; /* *clzg */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6676 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2268; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6689 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2269; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern228 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern247 (x1))
                    {
                    case 0:
                      if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2275; /* subdi3_borrow_cc */

                    case 1:
                      return 2276; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6803 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2277; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6803 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 2278; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern228 (x1))
                    {
                    case 0:
                      switch (pattern247 (x1))
                        {
                        case 0:
                          if ((
#line 6821 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 2279; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6821 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 2280; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6855 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2283; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6855 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 2284; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern278 (x10, 
E_TFmode) != 0
                          || !(
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2296; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern278 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2297; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern278 (x10, 
E_DFmode) != 0
                          || !
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2298; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern278 (x10, 
E_SFmode) != 0
                          || !
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2299; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern278 (x10, 
E_TDmode) != 0
                          || !(
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2300; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern278 (x10, 
E_DDmode) != 0
                          || !(
#line 6958 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2301; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern258 (
E_TFmode) != 0
                          || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2302; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern258 (
E_FPRX2mode) != 0
                          || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2303; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern258 (
E_DFmode) != 0
                          || !
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2304; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern258 (
E_SFmode) != 0
                          || !
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2305; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern258 (
E_TDmode) != 0
                          || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2306; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern258 (
E_DDmode) != 0
                          || !(
#line 6974 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2307; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern147 (x1, 
MINUS))
        {
        case 0:
          if (pattern288 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6916 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2288; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern288 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6916 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 2289; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern289 (x1, 
E_DImode) != 0
                  || !(
#line 7148 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2320; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern289 (x1, 
E_SImode) != 0
                  || !
#line 7148 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2321; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern289 (x1, 
E_DImode) != 0
                  || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2324; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern289 (x1, 
E_SImode) != 0)
                return -1;
              return 2325; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_103 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_101 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_100 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 1135 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 700; /* *eltswapv16qi */

        case 1:
          if (!
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 702; /* eltswapv4si */

        case 2:
          if (!
#line 1205 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 703; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_87 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2170; /* *trunctftd2 */

        case 1:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2171; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2172; /* *truncdftd2 */

        case 3:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2173; /* *truncsftd2 */

        case 4:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2174; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2175; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2176; /* *truncdfdd2 */

        case 7:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2177; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2178; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2179; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2180; /* *truncdfsd2 */

        case 11:
          if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2181; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2182; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2186; /* *truncddtf2 */

        case 14:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2190; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2183; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2187; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2191; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2184; /* *trunctddf2 */

        case 19:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2188; /* *truncdddf2 */

        case 20:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2192; /* *truncsddf2 */

        case 21:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2185; /* *trunctdsf2 */

        case 22:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2189; /* *truncddsf2 */

        case 23:
          if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2193; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_90 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern121 (x1))
        {
        case 0:
          if (!(
#line 1675 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1831; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1675 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1832; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1733 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1835; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1733 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1836; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_104 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_99 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern75 (x1))
        {
        case 0:
          if (!(
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1974; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4418 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1975; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern93 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4337 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1953; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_102 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern41 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4370 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1959; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 2330; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1976; /* *pre_z10_extvdi */

        case 1:
          return 1977; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_106 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern40 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern153 (x1))
        {
        case 0:
          if (
#line 5524 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2066; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2072; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2068; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2070; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2074; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2076; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2078; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5524 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 770 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 2067; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2075; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2069; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2071; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2073; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2077; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5539 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2079; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern40 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern154 (x1))
        {
        case 0:
          if (
#line 5562 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2080; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2086; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2082; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2084; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2088; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5609 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2090; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5609 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2091; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5562 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 770 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 2081; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2089; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2083; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2085; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5575 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2087; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2194; /* *extendtftd2 */

        case 1:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2195; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2196; /* *extenddftd2 */

        case 3:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2197; /* *extendsftd2 */

        case 4:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2198; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2199; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2200; /* *extenddfdd2 */

        case 7:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2201; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2202; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2203; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2204; /* *extenddfsd2 */

        case 11:
          if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2205; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2206; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2210; /* *extendddtf2 */

        case 14:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2214; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2207; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2211; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2215; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2208; /* *extendtddf2 */

        case 19:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2212; /* *extenddddf2 */

        case 20:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2216; /* *extendsddf2 */

        case 21:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2209; /* *extendtdsf2 */

        case 22:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2213; /* *extendddsf2 */

        case 23:
          if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2217; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern41 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern195 (x3))
            {
            case 0:
              if (!(
#line 8664 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2425; /* *notdi */

            case 1:
              if (!
#line 8664 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2426; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern229 (x3, 
E_DImode) != 0
                  || !(
#line 9069 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2442; /* *nxordi */

            case E_SImode:
              if (pattern229 (x3, 
E_SImode) != 0
                  || !
#line 9069 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2443; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_105 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern41 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern182 (x3) != 0
              || !
#line 9307 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2472; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern183 (x3))
            {
            case 0:
              if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2477; /* absdi2 */

            case 1:
              return 2478; /* abssi2 */

            case 2:
              if (!(
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2493; /* *abstf2 */

            case 3:
              if (!(
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2494; /* *absfprx22 */

            case 4:
              if (!
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2495; /* *absdf2 */

            case 5:
              if (!
#line 9395 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2496; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern42 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern195 (x3))
        {
        case 0:
          if (
#line 9737 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2538; /* *ashrdi3_31 */
          if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2541; /* *ashrdi3 */

        case 1:
          return 2544; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10978 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2602; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10991 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2603; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 11005 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2604; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 11029 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2605; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 11052 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2606; /* *basr_r_via_thunk */
        }
      if (!(
#line 11052 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2607; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern43 (x1) != 0
          || !
#line 12146 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2666; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern155 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12420 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2678; /* tbegin_1_z13 */
            }
          if (
#line 12448 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2679; /* tbegin_1 */
            }
        }
      if (!
#line 12459 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2680; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
