/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern20 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern20 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern20 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern20 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern20 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern20 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern31 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern31 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern85 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE
      || !memory_operand (operands[0], E_BLKmode)
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const0_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !const0_operand (operands[2], E_TFmode))
        return -1;
      return 0;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode)
          || !const0_operand (operands[2], E_FPRX2mode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !const0_operand (operands[2], E_DFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !const0_operand (operands[2], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != E_DImode
      || !immediate_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 4;

    case E_DDmode:
      if (!register_operand (operands[1], E_DDmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  return 0;
}

int
pattern200 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern217 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern217 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XWINT (x3, 0))
    {
    case 1L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 8589934590L)
        return -1;
      return 0;

    case 2L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 17179869180L)
        return -1;
      return 1;

    case 3L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 34359738360L)
        return -1;
      return 2;

    case 4L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 68719476720L)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern292 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern300 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1235; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1236; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1237; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1238; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1239; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1240; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1241; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1242; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1243; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1244; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1245; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1246; /* vec_widen_umult_odd_v4si */

    case 12:
      if (!
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1247; /* vec_widen_umult_odd_v1di */

    case 13:
      if (!(
#line 1875 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1248; /* vec_widen_umult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 60:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 62:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 63:
      switch (pattern18 (x1))
        {
        case 0:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 64:
      switch (pattern18 (x1))
        {
        case 0:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 67:
      switch (pattern18 (x1))
        {
        case 0:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 72:
      return recog_2 (x1, insn, pnum_clobbers);

    case 73:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 74:
      if (pattern19 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 79:
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 112; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 113; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vaccq_ti */

        default:
          return -1;
        }

    case 82:
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avgv2di */

        case 4:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 131; /* vec_avgv1ti */

        case 5:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 132; /* vec_avgti */

        default:
          return -1;
        }

    case 83:
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 135; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_avguv2di */

        case 4:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 137; /* vec_avguv1ti */

        case 5:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 138; /* vec_avguti */

        default:
          return -1;
        }

    case 84:
      if (pattern22 (x1, 
E_V4SImode) != 0
          || !
#line 741 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_checksum */

    case 85:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern20 (x2, 
E_V16QImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_gfmsumv16qi */

        case E_V8HImode:
          if (pattern20 (x2, 
E_V8HImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_gfmsumv8hi */

        case E_V4SImode:
          if (pattern20 (x2, 
E_V4SImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 86:
      if (pattern19 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 143; /* vec_gfmsum_128 */

    case 94:
      return recog_5 (x1, insn, pnum_clobbers);

    case 99:
      return recog_6 (x1, insn, pnum_clobbers);

    case 100:
      switch (pattern25 (x1))
        {
        case 0:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vec_srabv16qi */

        case 1:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vec_srabv8hi */

        case 2:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 299; /* vec_srabv4si */

        case 3:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 300; /* vec_srabv2di */

        case 4:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 301; /* vec_srabv1ti */

        case 5:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 302; /* vec_srabti */

        case 6:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 303; /* vec_srabv4sf */

        case 7:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 304; /* vec_srabv2df */

        case 8:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 305; /* vec_srabv1tf */

        case 9:
          if (!
#line 1128 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 306; /* vec_srabtf */

        default:
          return -1;
        }

    case 101:
      return recog_4 (x1, insn, pnum_clobbers);

    case 103:
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 337; /* vscbib_v16qi */

        case 1:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 338; /* vscbih_v8hi */

        case 2:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 339; /* vscbif_v4si */

        case 3:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 340; /* vscbig_v2di */

        case 4:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 341; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1165 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 342; /* vscbiq_ti */

        default:
          return -1;
        }

    case 91:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1213 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 345; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1213 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 346; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 106:
      return recog_3 (x1, insn, pnum_clobbers);

    case 127:
      if (pnum_clobbers == NULL
          || pattern38 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 405; /* *vftciv4sf_cconly */

        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
            return -1;
          *pnum_clobbers = 1;
          return 406; /* *vftciv2df_cconly */

        case E_V1TFmode:
          if (!register_operand (operands[1], E_V1TFmode)
              || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 407; /* *vftciv1tf_cconly */

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !(
#line 1925 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 408; /* *vftcitf_cconly */

        default:
          return -1;
        }

    case 133:
      if (pattern27 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2221 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 511; /* vclfnhs_v8hi */

    case 134:
      if (pattern27 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2232 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 512; /* vclfnls_v8hi */

    case 136:
      if (pattern28 (x1) != 0
          || !
#line 2251 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 514; /* vcfn_v8hi */

    case 137:
      if (pattern28 (x1) != 0
          || !
#line 2260 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 515; /* vcnf_v8hi */

    case 90:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1360 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 790; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1360 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 791; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 92:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1370 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 792; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1370 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 793; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 102:
      switch (pattern25 (x1))
        {
        case 0:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1109; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1110; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1111; /* *vec_srbv4si */

        case 3:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1112; /* *vec_srbv2di */

        case 4:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1113; /* *vec_srbv1ti */

        case 5:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1114; /* *vec_srbti */

        case 6:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1115; /* *vec_srbv4sf */

        case 7:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1116; /* *vec_srbv2df */

        case 8:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1117; /* *vec_srbv1tf */

        case 9:
          if (!
#line 1706 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1118; /* *vec_srbtf */

        default:
          return -1;
        }

    case 95:
      switch (pattern25 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1119; /* *vec_slbv16qi */

        case 1:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1120; /* *vec_slbv8hi */

        case 2:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1121; /* *vec_slbv4si */

        case 3:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1122; /* *vec_slbv2di */

        case 4:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* *vec_slbv1ti */

        case 5:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1124; /* *vec_slbti */

        case 6:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1125; /* *vec_slbv4sf */

        case 7:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1126; /* *vec_slbv2df */

        case 8:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1127; /* *vec_slbv1tf */

        case 9:
          if (!
#line 1718 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1128; /* *vec_slbtf */

        default:
          return -1;
        }

    case 47:
      return recog_11 (x1, insn, pnum_clobbers);

    case 48:
      return recog_10 (x1, insn, pnum_clobbers);

    case 49:
      return recog_9 (x1, insn, pnum_clobbers);

    case 50:
      return recog_8 (x1, insn, pnum_clobbers);

    case 61:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1434; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3741 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1919; /* *mvcrl */

    case 36:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (pattern36 (x2))
        {
        case 0:
          *pnum_clobbers = 1;
          return 1945; /* *sethighpartsi */

        case 1:
          if (
#line 4267 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1946; /* *sethighpartdi_64 */
            }
          if (!
#line 4277 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1947; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 38:
      if (pattern22 (x1, 
E_DImode) != 0
          || !
#line 4953 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2034; /* bdepg */

    case 39:
      if (pattern22 (x1, 
E_DImode) != 0
          || !
#line 4966 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2035; /* bextg */

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 11097 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2609; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 11107 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2610; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern26 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2655; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2656; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2657; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2658; /* stack_tiesi */

        default:
          return -1;
        }

    case 46:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12590 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2690; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 738; /* mulv16qi3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 739; /* mulv8hi3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 740; /* mulv4si3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !(
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 741; /* mulv2di3 */

        case E_V1TImode:
          if (pattern0 (x3, 
E_V1TImode) != 0
              || !(
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 742; /* mulv1ti3 */

        case E_TImode:
          if (pattern0 (x3, 
E_TImode) != 0
              || !(
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 743; /* multi3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 2013 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1257; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 2013 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1258; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 2013 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1259; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 2013 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1260; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2347; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern178 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2348; /* mulfprx23 */

        case E_DFmode:
          if (pattern178 (x3, 
E_DFmode) != 0
              || !
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2349; /* muldf3 */

        case E_SFmode:
          if (pattern178 (x3, 
E_SFmode) != 0
              || !
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2350; /* mulsf3 */

        case E_TDmode:
          if (pattern178 (x3, 
E_TDmode) != 0
              || !(
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2351; /* multd3 */

        case E_DDmode:
          if (pattern178 (x3, 
E_DDmode) != 0
              || !(
#line 7583 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2352; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7436 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 2337; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7449 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 2338; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern116 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 785 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2345; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_23 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_CCSmode:
          if (GET_MODE (x3) != E_CCSmode
              || !
#line 2349 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1370; /* *vec_cmpv2di_lane0_ccs */

        case E_CCUmode:
          if (GET_MODE (x3) != E_CCUmode
              || !
#line 2349 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1371; /* *vec_cmpv2di_lane0_ccu */

        case E_CCZmode:
          if (GET_MODE (x3) != E_CCZmode
              || !
#line 2349 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1372; /* *vec_cmpv2di_lane0_ccz */

        default:
          return -1;
        }

    case AND:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x10;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1023 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1761; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1037 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1762; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1053 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1763; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x10;
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern157 (x4))
            {
            case 0:
              if (!
#line 7942 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2369; /* *anddi3_cconly */

            case 1:
              if (!
#line 8070 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2380; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern137 (x4))
            {
            case 0:
              if (!(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2405; /* *andcdi_cconly */

            case 1:
              if (!
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2407; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2417; /* *nordi_cconly */

            case 3:
              if (!
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2419; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1307 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1787; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1347 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1790; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1347 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1791; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1323 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1788; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) == MEM
          && GET_MODE (x10) == E_HImode)
        {
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1385 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1794; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1398 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1796; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1398 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1795; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1410 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1797; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          if (GET_MODE (x10) != E_DImode)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x13 = XEXP (x10, 1);
          operands[2] = x13;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[3] = x14;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x15 = XEXP (x5, 1);
          operands[4] = x15;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4543 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1987; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x10;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (pattern157 (x4))
            {
            case 0:
              if (!
#line 8356 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2391; /* *iordi3_cconly */

            case 1:
              if (!
#line 8438 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2394; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern137 (x4))
            {
            case 0:
              if (!(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2406; /* *orcdi_cconly */

            case 1:
              if (!
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2408; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2418; /* *nanddi_cconly */

            case 3:
              if (!
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2420; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_24 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_25 (x1, insn, pnum_clobbers);

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern157 (x4))
        {
        case 0:
          if (!
#line 8781 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2429; /* *xordi3_cconly */

        case 1:
          if (!
#line 8848 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2432; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != XOR)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x13 = XEXP (x10, 1);
      operands[2] = x13;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (GET_MODE (x10) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2440; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x10) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9059 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2441; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2448; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9129 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2449; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (pattern138 (x4))
            {
            case 0:
              if (!(
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2457; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2458; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2459; /* *negdf2_cconly */

            case 3:
              if (!
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2460; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (GET_MODE (x10) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9477 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2501; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x10) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9477 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2502; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_TFmode:
              if (GET_MODE (x10) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2509; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x10) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2510; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x10) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2511; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x10) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2512; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9330 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2475; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9330 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2476; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x7;
      switch (pattern138 (x4))
        {
        case 0:
          if (!(
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2483; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2484; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2485; /* *absdf2_cconly */

        case 3:
          if (!
#line 9375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2486; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9737 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2539; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2542; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2545; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12138 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2665; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 3122 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1555; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 3122 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 108 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1556; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern70 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5674 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2104; /* *floatunsdidf2_z13 */
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2110; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 2111; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5674 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 770 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2105; /* *floatunssisf2_z13 */
          if (!
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 2113; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2112; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern70 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2106; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2107; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern70 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2108; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2109; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern70 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2114; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2115; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern70 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2116; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5686 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2117; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      if (pattern151 (x1, 
NEG) != 0
          || !
#line 9097 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
        return -1;
      return 2444; /* *negdi2_sign_cc */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x6;
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 9239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2453; /* *negtf2_cc */

        case 1:
          if (!(
#line 9239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2454; /* *negfprx22_cc */

        case 2:
          if (!
#line 9239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2455; /* *negdf2_cc */

        case 3:
          if (!
#line 9239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2456; /* *negsf2_cc */

        case 4:
          if (!(
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2457; /* *negtf2_cconly */

        case 5:
          if (!(
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2458; /* *negfprx22_cconly */

        case 6:
          if (!
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2459; /* *negdf2_cconly */

        case 7:
          if (!
#line 9250 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2460; /* *negsf2_cconly */

        default:
          return -1;
        }

    case ABS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x11 = XEXP (x7, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x13 = XEXP (x12, 1);
          if (pattern255 (x13, 
ABS, 
NEG) != 0)
            return -1;
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x16 = XEXP (x9, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !
#line 9444 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2497; /* *negabsdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern193 (x1, 
ABS, 
NEG))
                {
                case 0:
                  switch (GET_MODE (x4))
                    {
                    case E_DImode:
                      if (pattern263 (x1, 
E_DImode) == 0
                          && (
#line 9466 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2499; /* *negabsdi2_cc */
                      break;

                    case E_SImode:
                      if (pattern263 (x1, 
E_SImode) == 0
                          && 
#line 9466 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                        return 2500; /* *negabssi2_cc */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (GET_MODE (x5) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && scratch_operand (operands[0], E_DImode)
                      && (
#line 9477 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2501; /* *negabsdi2_cconly */
                  break;

                case 2:
                  if (GET_MODE (x5) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && scratch_operand (operands[0], E_SImode)
                      && 
#line 9477 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    return 2502; /* *negabssi2_cconly */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != NEG)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ABS)
                return -1;
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern264 (x1, 
E_TFmode) != 0
                      || !(
#line 9503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2505; /* *negabstf2_cc */

                case E_FPRX2mode:
                  if (pattern264 (x1, 
E_FPRX2mode) != 0
                      || !(
#line 9503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2506; /* *negabsfprx22_cc */

                case E_DFmode:
                  if (pattern264 (x1, 
E_DFmode) != 0
                      || !
#line 9503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2507; /* *negabsdf2_cc */

                case E_SFmode:
                  if (pattern264 (x1, 
E_SFmode) != 0
                      || !
#line 9503 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2508; /* *negabssf2_cc */

                default:
                  return -1;
                }

            case CLOBBER:
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern242 (x5, 
E_TFmode) != 0
                      || !(
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2509; /* *negabstf2_cconly */

                case E_FPRX2mode:
                  if (pattern242 (x5, 
E_FPRX2mode) != 0
                      || !(
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2510; /* *negabsfprx22_cconly */

                case E_DFmode:
                  if (pattern242 (x5, 
E_DFmode) != 0
                      || !
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2511; /* *negabsdf2_cconly */

                case E_SFmode:
                  if (pattern242 (x5, 
E_SFmode) != 0
                      || !
#line 9514 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2512; /* *negabssf2_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_94 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_95 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern41 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern186 (x3))
                {
                case 0:
                  if (
#line 4214 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1943; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2045; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 5115 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 2046; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5300 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 2062; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2326; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2328; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 2327; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 2329; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 9008 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2437; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2605 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1880; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10557 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2579; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10576 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2580; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10576 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2581; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10594 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2582; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10594 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2583; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern100 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern294 (
E_DImode) != 0
                  || !
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1910; /* *cmpstrdi */

            case E_SImode:
              if (pattern294 (
E_SImode) != 0
                  || !
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1911; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern100 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern129 (x1))
            {
            case 0:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1912; /* *movstr */

            case 1:
              if (!
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1913; /* *movstr */

            case 2:
              if (!(
#line 3961 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1930; /* *setmem_long */

            case 3:
              if (!(
#line 3961 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1931; /* *setmem_long */

            case 4:
              if (!
#line 3989 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1934; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3974 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1932; /* *setmem_long_and */

            case 6:
              if (!(
#line 3974 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1933; /* *setmem_long_and */

            case 7:
              if (!
#line 4001 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1935; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern77 (x1) != 0)
            return -1;
          switch (pattern196 (x1))
            {
            case 0:
              if (!(
#line 3597 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1914; /* *cpymem_short */

            case 1:
              if (!(
#line 3597 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1915; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern76 (x1) != 0)
            return -1;
          switch (pattern196 (x1))
            {
            case 0:
              if (!(
#line 4046 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1936; /* *cmpmem_short */

            case 1:
              if (!(
#line 4046 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1937; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2170; /* *trunctftd2 */

            case 1:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2171; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2172; /* *truncdftd2 */

            case 3:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2173; /* *truncsftd2 */

            case 4:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2174; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2175; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2176; /* *truncdfdd2 */

            case 7:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2177; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2178; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2179; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2180; /* *truncdfsd2 */

            case 11:
              if (!
#line 5897 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2181; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2182; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2186; /* *truncddtf2 */

            case 14:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2190; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2183; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2187; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2191; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2184; /* *trunctddf2 */

            case 19:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2188; /* *truncdddf2 */

            case 20:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2192; /* *truncsddf2 */

            case 21:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2185; /* *trunctdsf2 */

            case 22:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2189; /* *truncddsf2 */

            case 23:
              if (!
#line 5906 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2193; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern78 (x1))
            {
            case 0:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2194; /* *extendtftd2 */

            case 1:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2195; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2196; /* *extenddftd2 */

            case 3:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2197; /* *extendsftd2 */

            case 4:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2198; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2199; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2200; /* *extenddfdd2 */

            case 7:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2201; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2202; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2203; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2204; /* *extenddfsd2 */

            case 11:
              if (!
#line 5971 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2205; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2206; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2210; /* *extendddtf2 */

            case 14:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2214; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2207; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2211; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2215; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2208; /* *extendtddf2 */

            case 19:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2212; /* *extenddddf2 */

            case 20:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2216; /* *extendsddf2 */

            case 21:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2209; /* *extendtdsf2 */

            case 22:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2213; /* *extendddsf2 */

            case 23:
              if (!
#line 5979 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2217; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern81 (x1))
            {
            case 0:
              if (!
#line 10074 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2563; /* *brxg_64bit */

            case 1:
              if (!
#line 10160 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2565; /* *brx_31bit */

            case 2:
              if (!
#line 10117 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2564; /* *brx_64bit */

            case 3:
              return 2566; /* doloop_si64 */

            case 4:
              if (!
#line 10258 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2567; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern10 (x1))
    {
    case 0:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_151 (insn, operands);

    case 1:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_160 (insn, operands);

    case 2:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_169 (insn, operands);

    case 3:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_178 (insn, operands);

    case 4:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 5:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_196 (insn, operands);

    case 6:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_205 (insn, operands);

    case 7:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_214 (insn, operands);

    case 8:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_223 (insn, operands);

    case 9:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_232 (insn, operands);

    case 10:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_241 (insn, operands);

    case 11:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_250 (insn, operands);

    case 12:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_259 (insn, operands);

    case 13:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_268 (insn, operands);

    case 14:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 15:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_286 (insn, operands);

    case 16:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_152 (insn, operands);

    case 17:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_161 (insn, operands);

    case 18:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_170 (insn, operands);

    case 19:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_179 (insn, operands);

    case 20:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 21:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_197 (insn, operands);

    case 22:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_206 (insn, operands);

    case 23:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_215 (insn, operands);

    case 24:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_224 (insn, operands);

    case 25:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_233 (insn, operands);

    case 26:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_242 (insn, operands);

    case 27:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_251 (insn, operands);

    case 28:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_260 (insn, operands);

    case 29:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_269 (insn, operands);

    case 30:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_278 (insn, operands);

    case 31:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_287 (insn, operands);

    case 32:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_153 (insn, operands);

    case 33:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_162 (insn, operands);

    case 34:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_171 (insn, operands);

    case 35:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_180 (insn, operands);

    case 36:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 37:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_198 (insn, operands);

    case 38:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_207 (insn, operands);

    case 39:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_216 (insn, operands);

    case 40:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_225 (insn, operands);

    case 41:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_234 (insn, operands);

    case 42:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_243 (insn, operands);

    case 43:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_252 (insn, operands);

    case 44:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_261 (insn, operands);

    case 45:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_270 (insn, operands);

    case 46:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_279 (insn, operands);

    case 47:
      if (!(
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3552 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_288 (insn, operands);

    default:
      return NULL;
    }
}
