/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern11 (x1, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern11 (x1, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern36 (x2); /* [-1, 1] */
}

int
pattern40 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  return pattern44 (x3); /* [-1, 0] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  operands[2] = x4;
  switch (XWINT (x2, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern20 (x1, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern20 (x1, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern20 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 2L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern20 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern20 (x1, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern20 (x1, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern100 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern124 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern124 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern124 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern124 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern151 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern258 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern266 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 267; /* vec_sralv16qiv16qi */

    case 1:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 277; /* vec_sralv16qiv8hi */

    case 2:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 287; /* vec_sralv16qiv4si */

    case 3:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 268; /* vec_sralv8hiv16qi */

    case 4:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 278; /* vec_sralv8hiv8hi */

    case 5:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 288; /* vec_sralv8hiv4si */

    case 6:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 269; /* vec_sralv4siv16qi */

    case 7:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 279; /* vec_sralv4siv8hi */

    case 8:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 289; /* vec_sralv4siv4si */

    case 9:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 270; /* vec_sralv2div16qi */

    case 10:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 280; /* vec_sralv2div8hi */

    case 11:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 290; /* vec_sralv2div4si */

    case 12:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 271; /* vec_sralv1tiv16qi */

    case 13:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 281; /* vec_sralv1tiv8hi */

    case 14:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 291; /* vec_sralv1tiv4si */

    case 15:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 272; /* vec_sraltiv16qi */

    case 16:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 282; /* vec_sraltiv8hi */

    case 17:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 292; /* vec_sraltiv4si */

    case 18:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 273; /* vec_sralv4sfv16qi */

    case 19:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 283; /* vec_sralv4sfv8hi */

    case 20:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 293; /* vec_sralv4sfv4si */

    case 21:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 274; /* vec_sralv2dfv16qi */

    case 22:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 284; /* vec_sralv2dfv8hi */

    case 23:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 294; /* vec_sralv2dfv4si */

    case 24:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 275; /* vec_sralv1tfv16qi */

    case 25:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 285; /* vec_sralv1tfv8hi */

    case 26:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 295; /* vec_sralv1tfv4si */

    case 27:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 276; /* vec_sraltfv16qi */

    case 28:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 286; /* vec_sraltfv8hi */

    case 29:
      if (!
#line 1116 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 296; /* vec_sraltfv4si */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern133 (x2, 
E_V1QImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 816; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern133 (x2, 
E_V2QImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 817; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern133 (x2, 
E_V4QImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 818; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern133 (x2, 
E_V8QImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 819; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern133 (x2, 
E_V16QImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 820; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern133 (x2, 
E_V1HImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 821; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern133 (x2, 
E_V2HImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 822; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern133 (x2, 
E_V4HImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 823; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern133 (x2, 
E_V8HImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 824; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern133 (x2, 
E_V1SImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 825; /* notandv1si3 */

        case E_V2SImode:
          if (pattern133 (x2, 
E_V2SImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 826; /* notandv2si3 */

        case E_V4SImode:
          if (pattern133 (x2, 
E_V4SImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 827; /* notandv4si3 */

        case E_V1DImode:
          if (pattern133 (x2, 
E_V1DImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 828; /* notandv1di3 */

        case E_V2DImode:
          if (pattern133 (x2, 
E_V2DImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 829; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern133 (x2, 
E_V1SFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 830; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern133 (x2, 
E_V2SFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 831; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern133 (x2, 
E_V4SFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 832; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern133 (x2, 
E_V1DFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 833; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern133 (x2, 
E_V2DFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 834; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern133 (x2, 
E_V1TFmode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 835; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern133 (x2, 
E_V1TImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 836; /* notandv1ti3 */

        case E_TImode:
          if (pattern133 (x2, 
E_TImode) != 0
              || !
#line 1394 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 837; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern133 (x2, 
E_DImode) != 0
              || !(
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2422; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern133 (x2, 
E_SImode) != 0
              || !
#line 8655 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2424; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern84 (x2, 
E_V1QImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 860; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern84 (x2, 
E_V2QImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 861; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern84 (x2, 
E_V4QImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 862; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern84 (x2, 
E_V8QImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 863; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern84 (x2, 
E_V16QImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 864; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern84 (x2, 
E_V1HImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 865; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern84 (x2, 
E_V2HImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 866; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern84 (x2, 
E_V4HImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 867; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern84 (x2, 
E_V8HImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 868; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern84 (x2, 
E_V1SImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 869; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern84 (x2, 
E_V2SImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 870; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern84 (x2, 
E_V4SImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 871; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern84 (x2, 
E_V1DImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 872; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern84 (x2, 
E_V2DImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 873; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern84 (x2, 
E_V1SFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 874; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern84 (x2, 
E_V2SFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 875; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern84 (x2, 
E_V4SFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 876; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern84 (x2, 
E_V1DFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 877; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern84 (x2, 
E_V2DFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 878; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern84 (x2, 
E_V1TFmode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 879; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern84 (x2, 
E_V1TImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 880; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern84 (x2, 
E_TImode) != 0
              || !
#line 1414 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 881; /* ior_notti3 */

        case E_DImode:
          if (pattern85 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2410; /* *orcdi */

        case E_SImode:
          if (pattern85 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8615 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4337 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1952; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4337 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1953; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern176 (x8))
        {
        case 0:
          if ((
#line 1705 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1833; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1705 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1834; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern175 (x2))
    {
    case 0:
      if (!(
#line 1647 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1829; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1647 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1830; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern175 (x2))
        {
        case 0:
          if (!(
#line 1675 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1831; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1675 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1832; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern176 (x8))
        {
        case 0:
          if (!(
#line 1733 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1835; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1733 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1836; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern235 (x3, 
E_DImode) != 0
          || !(
#line 7373 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2333; /* *movdicc */

    case E_SImode:
      if (pattern235 (x3, 
E_SImode) != 0
          || !
#line 7373 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      return 2334; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      if (pattern111 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1418; /* *vec_cmpgev1sf_signaling_nocc */
      if (!(
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1425; /* *vec_cmpgev1sf_signaling_finite_nocc */

    case E_V2SImode:
      if (pattern111 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1419; /* *vec_cmpgev2sf_signaling_nocc */
      if (!(
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1426; /* *vec_cmpgev2sf_signaling_finite_nocc */

    case E_V4SImode:
      if (pattern111 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1420; /* *vec_cmpgev4sf_signaling_nocc */
      if (!(
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1427; /* *vec_cmpgev4sf_signaling_finite_nocc */

    case E_V1DImode:
      if (pattern111 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1421; /* *vec_cmpgev1df_signaling_nocc */
      if (!
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1428; /* *vec_cmpgev1df_signaling_finite_nocc */

    case E_V2DImode:
      if (pattern111 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1422; /* *vec_cmpgev2df_signaling_nocc */
      if (!
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1429; /* *vec_cmpgev2df_signaling_finite_nocc */

    case E_V1TImode:
      if (pattern111 (x3, 
E_V1TFmode, 
E_V1TImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1423; /* *vec_cmpgev1tf_signaling_nocc */
      if (!(
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1430; /* *vec_cmpgev1tf_signaling_finite_nocc */

    case E_TImode:
      if (pattern111 (x3, 
E_TFmode, 
E_TImode) != 0)
        return -1;
      if (
#line 2444 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1424; /* *vec_cmpgetf_signaling_nocc */
      if (!(
#line 2452 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1431; /* *vec_cmpgetf_signaling_finite_nocc */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      return 531; /* movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      return 532; /* movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      return 533; /* movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      return 534; /* movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      return 535; /* movv2di */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode))
        return -1;
      return 536; /* movv2df */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !general_operand (operands[1], E_V1TImode))
        return -1;
      return 537; /* movv1ti */

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || !general_operand (operands[1], E_V1TFmode))
        return -1;
      return 538; /* movv1tf */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 104 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 539; /* movtf_vr */

    case E_V1QImode:
      if (!nonimmediate_operand (operands[0], E_V1QImode)
          || !general_operand (operands[1], E_V1QImode)
          || !
#line 379 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 540; /* movv1qi */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      return 541; /* movv2qi */

    case E_V1HImode:
      if (!nonimmediate_operand (operands[0], E_V1HImode)
          || !general_operand (operands[1], E_V1HImode))
        return -1;
      return 542; /* movv1hi */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 434 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 543; /* movv4qi */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 434 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 544; /* movv2hi */

    case E_V1SImode:
      if (!nonimmediate_operand (operands[0], E_V1SImode)
          || !general_operand (operands[1], E_V1SImode)
          || !
#line 434 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 545; /* movv1si */

    case E_V1SFmode:
      if (!nonimmediate_operand (operands[0], E_V1SFmode)
          || !general_operand (operands[1], E_V1SFmode)
          || !
#line 434 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 546; /* movv1sf */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 547; /* movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 548; /* movv4hi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 549; /* movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 550; /* movv2sf */

    case E_V1DImode:
      if (!nonimmediate_operand (operands[0], E_V1DImode)
          || !general_operand (operands[1], E_V1DImode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 551; /* movv1di */

    case E_V1DFmode:
      if (!nonimmediate_operand (operands[0], E_V1DFmode)
          || !general_operand (operands[1], E_V1DFmode)
          || !
#line 471 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 552; /* movv1df */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !reload_const_wide_int_operand (operands[1], E_TImode)
          || !
#line 1764 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1837; /* *movti_bigconst */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1979 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1839; /* *movdi_64 */
      if (!
#line 2220 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1872; /* *movdi_31 */

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && larl_operand (operands[1], E_SImode)
          && 
#line 2401 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !FP_REG_P (operands[0])))
        return 1874; /* *movsi_larl */
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 2414 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1875; /* *movsi_zarch */
      if (!
#line 2505 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1876; /* *movsi_esa */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 1881; /* *movhi */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 1882; /* *movqi */

    case E_FPRX2mode:
      if (!nonimmediate_operand (operands[0], E_FPRX2mode)
          || !general_operand (operands[1], E_FPRX2mode))
        return -1;
      if ((
#line 2800 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return 1887; /* *movfprx2_64 */
      if (!(
#line 2817 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1890; /* *movfprx2_31 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode))
        return -1;
      if (
#line 2800 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1888; /* *movtd_64 */
      if (!
#line 2817 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1891; /* *movtd_31 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 2924 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1892; /* *movdf_64dfp */
      if (
#line 2956 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1894; /* *movdf_64 */
      if (!
#line 2982 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1896; /* *movdf_31 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode))
        return -1;
      if (
#line 2924 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1893; /* *movdd_64dfp */
      if (
#line 2956 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1895; /* *movdd_64 */
      if (!
#line 2982 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1897; /* *movdd_31 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 1898; /* movsf */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode))
        return -1;
      return 1899; /* movsd */

    case E_CCmode:
      if (!nonimmediate_operand (operands[0], E_CCmode)
          || !nonimmediate_operand (operands[1], E_CCmode))
        return -1;
      return 1900; /* movcc */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_20 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_21 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern68 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 838; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 839; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 840; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 841; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 842; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 843; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 844; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 845; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 846; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 847; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 848; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 849; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 850; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 851; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 852; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 853; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 854; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 855; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 856; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 857; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 858; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1404 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 859; /* iorti3 */
          break;

        case 22:
          if (
#line 8373 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2392; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8510 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2397; /* *iorhi3_zarch */
            }
          if (
#line 8526 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2398; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8553 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2399; /* *iorqi3_zarch */
            }
          if (
#line 8571 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2400; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern134 (x3) == 0
          && 
#line 4795 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 2024; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8454 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2395; /* *iorsi3_zarch */
        }
      if (!
#line 8482 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2396; /* *iorsi3_esa */

    case IOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1722; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1731; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1740; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern30 (x3))
        {
        case 0:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1606; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1615; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1624; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1633; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1642; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1651; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1660; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1669; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1678; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1687; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1696; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1705; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1714; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1723; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1732; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3550 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1741; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern32 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2016; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4756 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 2018; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern135 (x3, 
DIV) != 0
                  || pattern205 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7673 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2357; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7691 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2358; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern271 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7752 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2359; /* udivmodtidi3 */

                    case 32L:
                      if (pattern271 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7872 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2361; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7811 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2360; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern135 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern205 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9630 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2528; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern32 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2020; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4775 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2022; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern171 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2205 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 506; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern171 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2205 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 507; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern171 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2205 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 508; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern171 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2205 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 509; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern171 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2205 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 510; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3500 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1596; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3500 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1597; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3500 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1598; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3500 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1599; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3500 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1600; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2661; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2662; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2663; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  switch (XINT (x2, 1))
    {
    case 8:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 36)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 36)
        return -1;
      return 2608; /* *set_tp */

    case 7:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 11757 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2642; /* main_pool */

    case 28:
      switch (pattern37 (x1))
        {
        case 0:
          return 2651; /* stack_protect_get_tpsi */

        case 1:
          return 2652; /* stack_protect_get_tpdi */

        default:
          return -1;
        }

    case 18:
      if (pattern38 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode)
          || !
#line 12477 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2681; /* *tbeginc_1 */

    case 19:
      if (GET_MODE (x2) != E_CCRAWmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode
          || !
#line 12494 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2682; /* *tend_1 */

    case 21:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12534 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2685; /* etnd */

    case 22:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12544 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2686; /* ntstg */

    case 25:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12579 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2689; /* efpc */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_78 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!const0_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && (
#line 1101 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1767; /* *tstdi_extimm */
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1143 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH && !TARGET_EXTIMM))
                return -1;
              return 1771; /* *tstdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !const0_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 1101 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                return 1768; /* *tstsi_extimm */
              if (!
#line 1154 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_EXTIMM))
                return -1;
              return 1772; /* *tstsi */

            case E_HImode:
              if (!const0_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_HImode)
                  && 
#line 1204 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1777; /* *tsthiCCT */
              if (!s_operand (operands[0], E_HImode)
                  || !
#line 1246 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1781; /* *tsthi */

            case E_QImode:
              if (!const0_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && 
#line 1204 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1778; /* *tstqiCCT */
              if (!s_operand (operands[0], E_QImode)
                  || !
#line 1246 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1782; /* *tstqi */

            default:
              return -1;
            }

        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && const0_operand (operands[1], E_DImode)
                  && scratch_operand (operands[2], E_DImode)
                  && (
#line 1130 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1769; /* *tstdi_cconly_extimm */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && const0_operand (operands[1], E_SImode)
                  && scratch_operand (operands[2], E_SImode))
                {
                  if (
#line 1130 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                    return 1770; /* *tstsi_cconly_extimm */
                  if (
#line 1168 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1773; /* *tstsi_cconly */
                }
              break;

            case E_HImode:
              if (const0_operand (operands[1], E_HImode)
                  && scratch_operand (operands[2], E_HImode))
                {
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && 
#line 1218 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                    return 1779; /* *tsthiCCT_cconly */
                  if (s_operand (operands[0], E_HImode)
                      && 
#line 1259 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1783; /* *tsthi_cconly */
                }
              break;

            case E_QImode:
              if (s_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && scratch_operand (operands[2], E_QImode)
                  && 
#line 1259 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1784; /* *tstqi_cconly */
              break;

            default:
              break;
            }
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !const0_operand (operands[1], E_TFmode)
                  || !register_operand (operands[2], E_TFmode)
                  || !(
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1803; /* *cmptf_ccz_0 */

            case E_FPRX2mode:
              if (!register_operand (operands[0], E_FPRX2mode)
                  || !const0_operand (operands[1], E_FPRX2mode)
                  || !register_operand (operands[2], E_FPRX2mode)
                  || !(
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1804; /* *cmpfprx2_ccz_0 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !const0_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1805; /* *cmpdf_ccz_0 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const0_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1806; /* *cmpsf_ccz_0 */

            case E_TDmode:
              if (!register_operand (operands[0], E_TDmode)
                  || !const0_operand (operands[1], E_TDmode)
                  || !register_operand (operands[2], E_TDmode)
                  || !(
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1807; /* *cmptd_ccz_0 */

            case E_DDmode:
              if (!register_operand (operands[0], E_DDmode)
                  || !const0_operand (operands[1], E_DDmode)
                  || !register_operand (operands[2], E_DDmode)
                  || !(
#line 1565 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1808; /* *cmpdd_ccz_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pattern41 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern221 (x3, 
E_TImode) != 0
                  || !
#line 6622 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2266; /* *subti3 */

            case E_DImode:
              if (pattern221 (x3, 
E_DImode) != 0)
                return -1;
              if (
#line 6713 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return 2271; /* *subdi3_31z */
              if (!
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2273; /* *subdi3 */

            case E_SImode:
              if (pattern221 (x3, 
E_SImode) != 0)
                return -1;
              return 2274; /* *subsi3 */

            case E_TFmode:
              if (pattern221 (x3, 
E_TFmode) != 0
                  || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2290; /* subtf3_fpr */

            case E_FPRX2mode:
              if (pattern221 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 754 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2291; /* subfprx23 */

            case E_DFmode:
              if (pattern221 (x3, 
E_DFmode) != 0
                  || !
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2292; /* subdf3 */

            case E_SFmode:
              if (pattern221 (x3, 
E_SFmode) != 0
                  || !
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2293; /* subsf3 */

            case E_TDmode:
              if (pattern221 (x3, 
E_TDmode) != 0
                  || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2294; /* subtd3 */

            case E_DDmode:
              if (pattern221 (x3, 
E_DDmode) != 0
                  || !(
#line 6938 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2295; /* subdd3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern250 (x3, 
E_DImode) != 0)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6661 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2267; /* *subdi3_sign */
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6887 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              return 2287; /* *subdi3_sign */

            case E_SImode:
              if (pattern250 (x3, 
E_SImode) != 0
                  || !memory_operand (operands[2], E_HImode))
                return -1;
              return 2272; /* *subsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6701 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2270; /* *subdi3_zero */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern251 (x3, 
E_DImode) != 0
              || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2322; /* *subdi3_slb */

        case E_SImode:
          if (pattern251 (x3, 
E_SImode) != 0)
            return -1;
          return 2323; /* *subsi3_slb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pattern41 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (pattern182 (x3) != 0
          || !
#line 9106 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2445; /* *negdi2_sign */

    case REG:
    case SUBREG:
      switch (pattern183 (x3))
        {
        case 0:
          if (
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2450; /* *negdi2 */
          if (!
#line 9148 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2452; /* *negdi2_31 */

        case 1:
          return 2451; /* *negsi2 */

        case 2:
          if (!(
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2467; /* *negtf2 */

        case 3:
          if (!(
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2468; /* *negfprx22 */

        case 4:
          if (!
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2469; /* *negdf2 */

        case 5:
          if (!
#line 9271 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2470; /* *negsf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9454 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2498; /* *negabsdi2_sign */

        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern230 (x3, 
E_DImode) != 0
                  || !
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2503; /* *negabsdi2 */

            case E_SImode:
              if (pattern230 (x3, 
E_SImode) != 0)
                return -1;
              return 2504; /* *negabssi2 */

            case E_TFmode:
              if (pattern230 (x3, 
E_TFmode) != 0
                  || !(
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2519; /* *negabstf2 */

            case E_FPRX2mode:
              if (pattern230 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 761 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2520; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern230 (x3, 
E_DFmode) != 0
                  || !
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2521; /* *negabsdf2 */

            case E_SFmode:
              if (pattern230 (x3, 
E_SFmode) != 0
                  || !
#line 9534 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2522; /* *negabssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 11052 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2606; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 11052 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2607; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_110 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1912; /* *movstr */

        case 1:
          if (!
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1913; /* *movstr */

        case 2:
          if (!(
#line 3961 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1930; /* *setmem_long */

        case 3:
          if (!(
#line 3961 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1931; /* *setmem_long */

        case 4:
          if (!
#line 3989 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1934; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3974 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1932; /* *setmem_long_and */

        case 6:
          if (!(
#line 3974 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1933; /* *setmem_long_and */

        case 7:
          if (!
#line 4001 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1935; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern15 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0L)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10619 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2584; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10619 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2585; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10636 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2586; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10636 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2587; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern16 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10941 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2600; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10941 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2601; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern16 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11879 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2649; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11879 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 781 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2650; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_118 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_108 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_111 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_112 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_113 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_114 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_115 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern7 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern300 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern301 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern302 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12448 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2679; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_116 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern184 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern281 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11355 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2620; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11373 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2621; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern281 (x7, 
E_SImode) != 0
                      || !
#line 11394 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2622; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern220 (x7))
                    {
                    case 0:
                      if (!(
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2623; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2627; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern220 (x7))
                    {
                    case 0:
                      if (!(
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2624; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2628; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern220 (x7))
                    {
                    case 0:
                      if (!(
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2625; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2629; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern220 (x7))
                    {
                    case 0:
                      if (!(
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2626; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11434 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2630; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_117 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 12039 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2659; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2553; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2554; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9974 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2555; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9974 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2556; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9988 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 774 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2557; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9988 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2558; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2588; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2632; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2633; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2634; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2635; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2636; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2637; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2638; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2639; /* pool_section_start */

                case 0L:
                  return 2640; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2644; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12517 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2683; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12525 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2684; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12573 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2688; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2695; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12563 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2687; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10748 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2589; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10777 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2590; /* *sibcall_brc */
          if (!
#line 10785 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2591; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2631; /* nop */

    case RETURN:
      if (!
#line 11804 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2645; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11804 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2646; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 12051 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2660; /* prefetch */

    default:
      return -1;
    }
}
